function hdr2phys,ppar,_description,len_pparx
; calculation the tags of the physically meaningful structure hdr
common hdr2phys,name,place,oper,descr,len_ppar
common magic4chs,magic4chs,FzkPdsFmt,syspar
    c = 2.998e8
    xmt = syspar.txfrequency 

    if ppar.pol gt 2 then begin
        tx_pulsewidth=ppar.pdr*1e-9
        rec_pulsewidth_ns=ppar.pol
        ; ppar.pdr = rec_pulsewidth_ns    ; vielleich besser weg lassen
    endif else begin
        if ppar.pdr le 9 then begin
            rec_pulsewidth_ns = (syspar.RecPulseWidths)[ppar.pdr] 
            ; pulse_width = ([100,200,300,400,500,600,700,800,900,1000])[ppar.pdr] ; devices before and including MPI
            ; pulse_width = ([96,192,288,400,512,576,706,832,912,1040])[ppar.pdr] ; between halo and DLR
            ; pulse_width = ([112,208,306,400,512,624,706,832,912,1040])[ppar.pdr] ; 1khg devices
            ppar.pdr = rec_pulsewidth_ns
        endif else begin
            rec_pulsewidth_ns = ppar.pdr
        endelse
        tx_pulsewidth=rec_pulsewidth_ns*1e-9
    endelse
    GateBinWidth=rec_pulsewidth_ns*1e-9
    pulsecompression = tx_pulsewidth/GateBinWidth gt 6.0
    pulsecompressionoffset = pulsecompression ? 72.0 : 0.0
    pol=syspar.zchan-1
    delta_h = 0.5 * c * GateBinWidth
    mom_h_min   = ppar.ihp * delta_h + syspar.dsprangeoffset + pulsecompressionoffset
    mom_zrg = ppar.chg-2                     ; -2 is applied as chg includes the two noise 
                                             ; estimates which are appended after the higest range gate
    ; mom_height = [findgen(mom_zrg) * delta_h + mom_h_min,15000.,15000.]

    raw_h_min = (ppar.raw_gate1 )*delta_h + syspar.dsprangeoffset + pulsecompressionoffset
    raw_zrg = ppar.raw_gate2 - ppar.raw_gate1+1 - syspar.noise3
    ; raw_height = [findgen(raw_zrg) * delta_h + raw_h_min,15000.,15000.]

    if ppar.prf lt 10 then prf = 2500. * (ppar.prf + 1) else prf = float(ppar.prf)
    if ppar.sft ge 64 then nfft=long(ppar.sft) else nfft= 128L * 2L ^ ppar.sft
    if ppar.osc eq 30 then nfft = nfft * ppar.sum
    if ppar.of0 le 11 then ppar.ofs = ppar.ofs * 10
    ave = float(ppar.avc) * float(nfft) / prf

    if n_elements(_description) gt 0 then begin
        name=_description.name
        place=_description.place
        oper=strmid(_description.oper,0,63)
        descr=strmid(_description.descr,0,255)
    endif
    if N_elements(len_pparx) then len_ppar=len_pparx
    if N_elements(len_ppar) eq 0 then  len_ppar=-1
    len_srvi = -1L

    hdr={ $
        name:name, $                    ; original name of the pds file
        oper:oper, $                    ; operator, should begin with 'fzk' 
        descr:descr,$                   ; may contain informations like Altitude given in /icfg/header.ini
        place:place, $                  ; e.g. string from the gps receiver 
        sn:'fzk',$                      ; device
        len_ppar:len_ppar, $            ; number of bytes of the ppar structure
        len_srvi:len_srvi, $            ; number of bytes of the srvi structure
        prf: prf, $                     ; Pulse repetition frequency
        pulse_width: GateBinWidth, $    ; puls diameter as choosen in the magnetron mode Obsolete or rater use as gate bin width
        rx_pulsewidth:GateBinWidth,$    ; 
        tx_pulsewidth:tx_pulsewidth,$  ;
        nfft: nfft, $                   ; number of FFT points
        avc: ppar.avc, $                ; number of spectral averages
        ave: ave, $                     ; averaging time
        c: c, $                         ; speed of light
        xmt: xmt, $                     ; transmitting frequency. This is a constant and not from the BITE data!
        fzk100: syspar.fzk100 , $       ; serverinfo.tpow/fzk100 = average tx power in Watts. 
        delta_h: delta_h , $            ; range spacing
        mom_h_min: mom_h_min, $         ; height of the lowes range gate of the moment data
        mom_zrg: mom_zrg, $             ; number of range gates of the moment data
        raw_h_min: raw_h_min, $         ; height of the lowes range gate of the raw (or spectrum) data
        raw_zrg: raw_zrg, $             ; number of range gates of the raw data
        do_raw: ppar.raw, $             ; flag -- oscillosgramm or spectra data available
        vuar:  c * prf / (2.0*xmt), $   ; diameter of the range of velocities which can be allocated without ambiguity 
                                    $   ; (Velocity Un-Ambigiuty Range)
        vny: c * prf / (4.0*xmt), $     ; nyquist velocity = vuar/2
        la: c / xmt, $                  ; wave length
        pol: pol,  $               ; cross polarized data on/off
        att: ppar.att $                 ; 1 if attn or STC is switched on
    }
    return,hdr
end
