Pro read1dmp_dwell_mie, lun, ppar,dmpstru, p_srvinfo, p_hsd, p_npeaks, p_dmp_data, skip=skip
; read one dwell from dmp-files
; Parameter
;   lun          logical unit of the file which has opened before
;   dmpstru   prototype of the dpm structure, typically: {SNRco,VELco,RMSco,LDRco}
;   p_srvinfo    pointer to struct with dwell header containing information from the log data
;   p_hsd_npeaks pointer to a byte array containing the number of peaks per range gate and if HSdiv noise was saved for the corresponding gate
;   p_dpm_data   pointer to array of dpm-structures in which the data is returned
;   skip         skip data from this dwell.
;
; Matthias Bauer-Pfundstein
;
    common magic4chs,magic4chs,FzkPdsFmt,syspar
    on_ioerror,ioerr
    
    if FzkPdsFmt then srvi_sgnt='SRVI' else srvi_sgnt='FHDR' 
    if ~ find_sgnt(lun,srvi_sgnt) then begin
        print,'Signature '+srvi_sgnt+' not found'
        goto,ioerr
    endif
    siz=0L & readu,lun,siz

    p_srvinfo = ptr_new(read_srvinfo(lun,ppar))
    if n_tags(*p_srvinfo) eq 0 then goto,nodata

    if ~ find_sgnt(lun,'HSDD') then goto,ioerr
    siz=0L & readu,lun,siz
    p_hsd = ptr_new(fltarr(siz/4L)) 
    readu,lun,*p_hsd
    
    if ~ find_sgnt(lun,'NPKS') then goto,ioerr
    siz=0L & readu,lun,siz
    p_npeaks = ptr_new(bytarr(siz)) 
    readu,lun,*p_npeaks
    
    if ~ find_sgnt(lun,'DMPD') then goto,ioerr
    siz=0L & readu,lun,siz 
    if siz gt 0 then begin
        len_dmpstru = n_tags(dmpstru,/Length)
        p_dmp_data = ptr_new( replicate(dmpstru,siz / len_dmpstru) )
        readu,lun,*p_dmp_data
    endif else p_dmp_data = ptr_new(dmpstru)

    return
ioerr:
nodata:
    p_hsd_npeaks = ptr_new(-1)  ; (n_elements(*p_hsd_npeaks) eq hdr.zrg_mom) ist dann nicht erfüllt
end

