function read_hdr_nc, ncinid, hdr
; read the header which appears only once at the begining of each pds-file
common fhdr1024,_description,fill1024
common initialize,init_extract,init_header_counter
init_extract=1 ; forces recalculation of init_extract in read1pds_dwell
init_header_counter=1 ; be silent if header_indes dose not match
    name_b   = REPLICATE(0B,32)
    time_b   = REPLICATE(0B,32)
    oper_b   = REPLICATE(0B,64)
    place_b  = REPLICATE(0B,128)
    descr_b  = REPLICATE(0B,256)
    NCDF_ATTGET, ncinid, 'location', location,/global
    NCDF_ATTGET, ncinid, 'source', filenameoff,/global
    NCDF_ATTGET, ncinid, 'Latitude', Latitude,/global
    NCDF_ATTGET, ncinid, 'Longitude', Longitude,/global
    NCDF_ATTGET, ncinid, 'Altitude', Altitude,/global
    place_b[0]=byte(location)
    name_b[0]=byte(filenameoff)
    oper_b[0]=byte('MULTI01')
    descr_b[0] = [byte('Altitude='), Altitude,byte(':Latitude='), Latitude, byte(':Longitude='), Longitude, 0b]

    _description    = {           $ 
            name         : string(name_b), $
            time         : string(time_b), $
            oper         : string(oper_b), $
            place        : string(place_b),$
            descr        : string(descr_b) $
    }

    ppar = read_ppar_nc(ncinid)
    ; len_ppar = N_Tags(ppar, /Length)
    len_ppar = N_Tags(ppar)*4  ; changed due to GDL-bug
    hdr = hdr2phys(ppar,_description,len_ppar)

    NCDF_ATTGET, ncinid, 'hrd', hdrstr,/global
    hdrstrarr=strsplit(string(hdrstr),string(10b),/extract)
    for i=0,n_elements(hdrstrarr)-1 do begin
        tagval=strsplit(hdrstrarr[i],':',/extract)
        if n_elements(tagnr) eq 2 then begin
            tagnr=(where(tag_names(hdr) eq tagval[0]))[0]
            hdr.(tagnr)=tagval[1]
        endif
    endfor

    return, ppar
end

