function read_mainframe_header,lun, hdr
; reads the main frame signature and size and returns 
;     0 if the mainframe caries a PPAR frame, 
;     or size if it caries a data frame, 
; and exits if it did not find a mainframe
common magic4chs,magic4chs,FzkPdsFmt
readfzkf:
    sgntb=bytarr(4) & siz=0L 
    if eof(lun) then return,-1L
    readu,lun,sgntb,siz
    sgnt = string((sgntb > 32b) < 127b )
    ;print,'sgnt:',sgnt,siz,magic4chs
enterafterseek:
    if sgnt eq magic4chs and siz eq hdr.len_ppar+8 then return,0  ; read a ppar frame
    if sgnt eq 'FTXT' then begin
       txt = bytarr(siz) & readu,lun,txt & print,'mes: ',string(txt > 32b)   ; info frame with free text. It can be inserted by radarserver command to the pds data.
       goto,readfzkf
    endif
    if sgnt eq magic4chs then return,siz else begin ; continue with reading srvinfo and data  frames. Noone is checking the size of mainframe header (siz) which is returned here
        if sgnt eq 'Term' then return,-1L
        print,'Frame signature: "'+sgnt+'" unexpected at read_mainframe_header'
        ; seek to next occurence of magic4chs
        if (nseeked=seek2sgnt(lun,magic4chs,sgnt)) ge 0 then begin
            print,'skipped '+string(nseeked)+' bytes seeking for ' + magic4chs
            sgnt=magic4chs
            readu,lun,siz
            goto,enterafterseek 
        endif else return,-1L
    endelse
end
