function read_ppar_frame,lun,hdr
; reads one ppar header structure including frame header which appears once after the fileheader (first 1024 bytes) 
; and each time some parameter has changed. Normally the ppar structure is preceeded by two chunk headers:
; magic4chs <int*4 hdr.len_ppar+8>
; 'PPAR' <int*4 hdr.len_ppar>
; both are swallowed by read_ppar_frame. If the file pointer is already positioned on the 'PPAR' chunk header 
; read_ppar_frame dose not bother. This is the normal situation as read1pds_dwell will read the magic4chs chunk heder and
; realize that the following is no data frame. 
common magic4chs,magic4chs,FzkPdsFmt,syspar
    sgnt='xxxx' & size=0L & readu,lun,sgnt,size   ; read enclosing header, magic 4 chars
    ; print,sgnt,size,' magic4chs:',magic4chs
    if sgnt eq magic4chs then begin
        sgnt='xxxx' & size=0L & readu,lun,sgnt,size
    endif else begin
        if sgnt ne 'PPAR' then begin
            print,'The Signature (magic4chs) defined in the config does not match the signature found in the file. Expected:'+magic4chs+' found:'+sgnt
            exit
        endif
    endelse
    if sgnt eq 'PPAR' then begin
        ppar = read_ppar(lun)
        hdr = hdr2phys(ppar)
    endif else begin
        print,'PPAR Frame expected. Instead '+sgnt+' was found.'
        exit
    endelse
    return,ppar
end

