Function read_srvinfo, lun,ppar
; Read the header which precedes each dwell. It contains log parameters which
; may change from dwell to dwell
common read_srvinfo,header_counter,srvinfo
common initialize,init_extract,init_header_counter
common magic4chs,magic4chs,FzkPdsFmt,syspar
    ; take care to sync this structure with read_srvinfo.pro read_srvinfo_nc.pro and srvinfo2ncdf.pro
    if n_elements(srvinfo) eq 0 then srvinfo = create_srvinfo()
    readu, lun, srvinfo
;   print,srvinfo.time_t,srvinfo.milliseconds
    if srvinfo.microsec gt 1000000L or srvinfo.microsec lt 0 then srvinfo.microsec=0L ; for older radar where this structure tag was used for some errorflag
    if srvinfo.npw1 lt -10. then begin
        srvinfo.npw1 = linear(srvinfo.npw1)
        srvinfo.npw2 = linear(srvinfo.npw2)
        srvinfo.cpw1 = linear(srvinfo.cpw1)
        srvinfo.cpw2 = linear(srvinfo.cpw2)
    endif

    ;normalization= float(syspar.pds_noical_normalization) * float(syspar.pds_spectra_normalization)
    if total(ppar.osc eq [12,16,22,26]) eq 1 then normalization=syspar.xcrl_noical_normalization else normalization=float(syspar.pds_noical_normalization) * float(syspar.pds_spectra_normalization)
    srvinfo.npw1 *= normalization
    srvinfo.npw2 *= normalization
    srvinfo.cpw1 *= normalization
    srvinfo.cpw2 *= normalization

    if srvinfo.npw1 gt 1e9 then begin 
        ; Pfusch der nötig ist solange wir zspc daten auswerten wollen, bei denen statt in write_zspc beim aufruf von write_srvinfo is_xcrl=0 nicht gesetzt war
        korrekturfak = syspar.xcrl_noical_normalization / ( float(syspar.pds_noical_normalization)*float(syspar.pds_spectra_normalization) )
        srvinfo.npw1 = srvinfo.npw1 * korrekturfak
        srvinfo.npw2 = srvinfo.npw2 * korrekturfak
        srvinfo.cpw1 = srvinfo.cpw1 * korrekturfak
        srvinfo.cpw2 = srvinfo.cpw2 * korrekturfak
    endif

    if init_header_counter eq 0 then begin
        ;if srvinfo.frame_cnt ne header_counter+1L and srvinfo.frame_cnt gt 1uL then begin
        ;    print,'Skipped ',long(srvinfo.frame_cnt - header_counter-1L),' dwells at dwell count',srvinfo.frame_cnt,' '
        ;endif
    endif else begin
        init_header_counter = 0
    endelse
    header_counter=srvinfo.frame_cnt

    return, srvinfo
end
