function average_profiles,first_day_0000,buffer,jul_time,AveragedProfile,heis,itr
    noisecom_ex=0
    if itr[0] gt itr[1] then begin
        sel_region = select_region_by_mouse(dir=1,firstday=first_day_0000)
        trmouse = sel_region.x 
        itr = [fstix(where(jul_time ge trmouse[0])),lstix(where(jul_time le trmouse[1]))]
        print,itr
    endif
    if itr[1] le itr[0] or itr[0] lt 0 or itr[1] ge n_elements(jul_time)  then begin
        print,"selected range invalid"
        noisecom_ex=0
    endif else begin
        noisecom_ex=1
        prof = (*(buffer.ptr_var))[*,itr[0]:itr[1]]
        heis = *(buffer.ptr_range) 
        nhei=n_elements(heis)
        nutime=n_elements(prof[0,*])
        AveragedProfile=fltarr(nhei) & ednutime=1.0/float(nutime) & for ihei=0,nhei-1 do AveragedProfile[ihei]=total(prof[ihei,*])*ednutime 
    endelse
    return,noisecom_ex
end

pro viewncdf,arguments
; Tool for visualizing profiles of the MIRA-36 cloud radar saved in ncdf format. 
;
; viewncdf can be called from the IDL prompt or from a unix shell:
; 
; unix> idl viewncdf
;
; IDL > viewncdf
; 
; The Data which should be visualized can be loaded to two buffers by the following commands:
; 
; View NCDF > load <buffer number> <filename> <variable name>    # loads the data to buffer 1
;
; Different visualizations can be created by the following commands:
;
;-----------------------------------------------------------------------------------------------------------------
;     View NCDF > thc <buffer number>
;
; Plot a Time Range Cross section of the profiles idicated by the first argument.
; The default value of the z-range of each type of profiles is stored in the
; parameter <f>range where <f> is the first letter of the profiles name. For 
; example the default value of the z-range for the ldr plots cam be changed by
;
;    View NCDF > set lrange -30 -1 ; trc ldr
;
;-----------------------------------------------------------------------------------------------------------------
;    View NCDF > set <parameter> <valu1> [<value2> ...]
;
; Change the default value of a plotting parameter. If <value1> is omited the
; current value is plotted. All the plotting parameters which 
; are available can be shown by
;
;    View NCDF > set help
;-----------------------------------------------------------------------------------------------------------------
;    View NCDF > tr <begin_hour> <end_hour>
;
; limits the time range of the trc plots. <begin_hour> <end_hour> are given as decimal numbers:
; 17.5 means 17:30. The hours ar countet from 00:00 of the first day contained in the data
; which is loaded.
;-----------------------------------------------------------------------------------------------------------------
;    View NCDF > postscript <filename>
;
; Directs the output of the following plot commands to the given postscript filename.
; for flushing and closing the postscript file the command
;
;    View NCDF > close
;
; must be given. After that the plot out put is directed to the screen again.
;----------------------------------------------------------------------------------------------------------------
;    View NCDF > png <filename>
;
; exports the screen to png-format
;-----------------------------------------------------------------------------------------------------------------
;    View NCDF > info
;
; gives some information from the file header
;-----------------------------------------------------------------------------------------------------------------
;    View NCDF > x
;
; exits viewncdf
;----------------------------------------------------------------------------------------------------------------
; If no command is recognized then the command is executed by the IDL interpreter.
;
; Matthias Bauer-Pfundstein bauer@metek.de
;
common startup,startup_done
if n_elements(startup_done) ne 1 then begin
@startup
endif

startup_device=!d.name

; Arguments can be provided by two methods:
; - If viewncdf is called by an interactive IDL session the first (and only) 
; string parameter arguments which contains a space separated list is split to
; the strarr argv.
; - Aditionally strings contained in the environment variables ARG1, ARG2, ..., 
; ARG9, ARG10, ... are prepended to argv. The script idl packs its calling arguments
; these environment variables. This is done as IDL can not extract the shell 
; variables like $1, $2,...
argv = env2argv(arguments)
kp = { $
    infile1:'',$
    config:'', $
    iam:'nobody',$
    max_dwells:70000L $
}
argv2stru,argv,kp
kp.iam=whoami(kp.iam)
common magic4chs,magic4chs,FzkPdsFmt,syspar
common imagexyp,ssx,ssy,ssp,zzora ; needed for otrc

; Default values for the Ploting parameters. These Parameters can be changed by the command "set"
pp={ $
hr:[0.,13000.],$          ; see comments below!
heira:[1,-1.,-99999,-99999,-99999,-99999],$   
prepend2heitit:['','','','','',''],$
td:1000.,$
tdunit:"km",$
tdx:1000.,$
tdxunit:"km",$
ringr:[-1.0,-1.0,-1.0,-1.0,-1.0,-1.0],$
ringname:['','','','','',''],$
valuetitle:'',$
rhixra:[1.,-1.],$
findscan:1,$
ScanExpectN:160,$
ScanVelThres:0.18,$
northangle:-999.0,$
sioux_color:2,$
sioux_sym:0,$
sioux_maxvel:65.,$
sioux_overlap:4.,$
sioux_arrowsize:0.5,$
dfimax:15.,$
rhi_mirror:0,$
pertubate:0,$
azirange:[!values.f_nan,!values.f_nan],$
elvrange:[!values.f_nan,!values.f_nan],$
beamwidth_azi:0.6,$
beamwidth_elv:0.6,$
aecrange:linear(-9.),$
aec_total:0,$
aecsol:0,$
solcmd:'~/metek/m36s/bin/get_elvazi_at_microsec.py',$
tr:[9d9,-9d9],$
wxsize:-1,$
wysize:-1,$
otrc_color:17,$
badcol :15, $
nullcol:-1,$
nulltol:0.1,$
saturate:3,$
min_txn_pow: 1.7 ,$
only_vertically: -2.0 ,$
BeginTime:0UL,$
rec_err_good_bits:'0000'X,$
rec_err_bad_bits:'0000'X, $
xtu:'Minutes',$
tolerable_gap:5d0, $
trc_smeargap:1.0,$
takeat_gap:'right', $
maxtdsyn:-1.,$
scatter_rg_shift:0L,$
scattertol:-1.0,$
scatter_type:'DOTS',$
InterpoltOffset:0L,$
InterpolrOffset:0.0,$
InterpolrFactor:1.0,$
rangeoffset:0.0,$
timeoffset:0L,$
nbin:[50,50],$
pADC:linear(-12.06),$
mrm_hei:4.0,$
mrm_fac:2,$
mrm_off:-0.35,$
pNoiseCom:linear(22.45-0.2),$
pKuhne:linear(85.0),$
ztime_max:20,$
zrsym:3,$
charsize:1.3, $
charthick:1.0,$
ticklen:0.006, $
thctit:'',$
tit:'',$
titsupplement:'',$
rangetit:'Range',$
heitit:'Height',$
thick:1.0, $
MeltThick:0.5, $
CircleThick:0.4, $
SymColor:0, $
b4tit:'',$
ti:'!3',$
startcolor:30,$
colt:'snr' $
}
argv2stru,argv,pp
config2stru,pp,'viewncdf',[kp.iam+'.config',kp.config]

pph={ $
hr:      "Range of range gates which will be used for plotting and other things", $
heira:   "Shown height range of the image plots given in m. Up to three ranges may be specified. Non used intervals are marked by negative values, e.g.: 0. 1000. 1000. 11000. -99999. -99999.", $
prepend2heitit: "With multible heira-zooms this array of strings can be used to prepend words like Low of Full begore the range title",$
td:      "range scaling factor, 1000 for km for the vertical axis",$
tdunit:  "range unit, km for for td=1000 for the vertical axis",$
tdx:      "range scaling factor, 1000 for km for the horizontal axis",$
tdxunit:  "range unit, km for for td=1000 for the horizontal axis",$
ringr:    "Ranges in m at wich rings in the ppi plots will be added. A maximum of 6 rings may be added to the ppis.",$
ringname: "Array of strings with lables for adding to the rings giben by ringr",$
valuetitle:'Obsolete. Dont use it, it tains the axis title of in all buffers! Use bset <buffnr> name <some\ name>, bset <bufnr> long_name <...>, or bset <bufnr> units <m/s> instead. Override the axis annotation (NetCDF var name + unit) of the plotted values',$
rhixra:  "x range im m of the rhi plots. The yrange is defined by heira",$
findscan: "if set, split the Data to time sequences containing one scan each.",$
ScanExpectN:"In a scan win less than ScanExpectN is detected (see ScanVelThres) it is dicarded.",$
ScanVelThres:"Parameter for autodetection of ppi or rhi scans. A scan is a contigous region in which the smoothed angle velocity is less in magnutude than ScanVelThres",$
northangle:"angle to which the antenna at is pointing after moveabs x 0, moveabs y 0",$
sioux_color:"color of the arrows in the sioux-plots",$
sioux_sym:"Shape of the Arrow of the arrows in the sioux-plots. 0,1, or 2",$
sioux_maxvel:"If the maginitude of wind velocity is larger than sioux_maxvel then the arrow is not plotted in the sioux-plots",$
sioux_overlap:"An arrow with maxvel overlaps across sioux_overlap fields in the sioux-plots",$
sioux_arrowsize:"Arrow size in the sioux-plots",$
dfimax:"Polar image sectors in ppi are blanked if the sector is lager than dfimax. This prevents oferpainting if azi goes from 359 to 1.",$
rhi_mirror:"if set swap left and right in rhi plots",$
pertubate:"Transforms all azi and elevation values so that elv is within -1 .. 90. The pointing angle is not changed by this transmformation.",$
azirange:'azimuth range for aec-plots',$
elvrange:'elevation range for aec-plots',$
beamwidth_azi:'the beamwidth for aec-plots is beamwidth_azi [deg] + azi range scanned during the averaging intervall. Default=1.5',$
beamwidth_elv:'the beamwidth for aec-plots is beamwidth_elv [deg] + elv range scanned during the averaging intervall. Default=0.5',$
aecrange:'Values of the aec-plot which are larger than max*aecrange are used for the moment estimation',$
aec_total:'if 1, values between ranges given in the aec command are summed, else they are averaged',$
aecsol:'if 1, the solar position for each time step is calculated and removed from the azi and elv positions before making an aec plot', $
aeccmd:'The command used for calculating one solelv,solazi pair for each step in unixtime provided on the cmd line', $
tr:      "Time range for plotting", $
wxsize:'plotting window width in pixels',$
wysize:'plotting window height in pixels',$
otrc_color:'Fill color of the poligones plotted by otrc or othc.',$
badcol : "Grey, color for plotting values which are not plausible.", $
nullcol : 'In image plots the range +/- nulltol can be marked by nullcol',$
nulltol : 'Abs range for nullcol',$
saturate : "If values are outside bset <buffer> yrange they are mapped to the range boundaries. bit 0 for lower, bit 2 for higher range.", $
min_txn_pow: "Only profiles are plotted by trc in which srvinfo.tpow (transmitted avg power * 100) is grater than min_txn_pow", $
only_vertically: "Only profiles are plotted by trc in where cos(srvinfo.elv) > only_vertically", $
BeginTime: "Load only data with time stamps later or equal to BeginTime.",$
rec_err_good_bits: "Only profiles are plotted by trc in which rec_err_good_bits in tsrvinfo.re_err are set", $
rec_err_bad_bits: "Only profiles are plotted by trc in which rec_err_bad_bits in tsrvinfo.re_err are not set", $
xtu:     "Parameter to control the number of ticks on the time axis. 'minutes'|'time'|'hours'..", $
tolerable_gap: "A gap in the time sequence will be detected when difference between the time stamps of two dwells is greater than tolerable_gap*median dwelltime", $
trc_smeargap: "In trc (also in *t*c) the averaging period ave is increased by the factor trc_smeargap to avoid gaps e.g. in case of ethi profiles interrupted by ppis",$
takeat_gap: "Describes how itr should be changed when a gap is detected", $
maxtdsyn: "max allowed time shift for data shown in the scatter plots",$
scatter_rg_shift: 'range shift for scatter plots (Behelfs-Pfusch) given in nuber of range gates',$
scattertol: 'when calculating difference and variance of the scatter plot only data with smaller abs difference is accounted for',$
scatter_type: 'Type of Scatter Plots. DOTS or HISTO',$
InterpoltOffset: 'integer time shift in s, which is added to the target ranges begore doing interpolt. timeoffset can be used instead.',$
InterpolrOffset: 'range shift in m, which is added to the target ranges begore doing interpolr. rangeoffset can be used instead.',$
InterpolrFactor: 'range factor, which can be used for scaling the target ranges begore doing interpolr',$
timeoffset:  'an integer offset in s which is added to the time stamps of the data loaded from the ncdf file. The kw param timeoffset has to be loaded before loading the data from the ncdf file, and dont forget to reset it before loading data from other files. timeoffset will have an effect when using the interpolt command for gridding data from two instruments with differently skewd time assignments.',$
rangeoffset: 'an offset in m which is added to the range axis loaded from the ncdf file. The kw param rangeoffset has to be loaded before loading the data from the ncdf file, and dont forget to reset it before loading data from other files. rangeoset will have an effect when using the interpolr command for gridding data from two instruments with differently skewd range assignments.',$
nbin: 'Number of bins for histograms. It is has two elements as it may be used also for 2D histograms when using scatter_type=HISTO in scatter plots',$
pNoiseCom:'Power (linear) of noise source above thermal power.',$
pKuhne:'Power (linear) of Kuhne source above thermal power.',$
pADC:'Noise Power (HSD, linear) if IfAttn is set to -25 dB',$
mrm_hei:'Parameter for MRM command: height where radiometer curve should be plotted',$
mrm_fac:'Parameter for MRM command: The db values of the radiometer curve are multiplied by this factor.',$
mrm_off:'Parameter for MRM command: This parameter is added to the db values of the radiometer curve.',$
zrsym: 'Symbols for isolated points in zr-plots',$
ztime_max: 'Maximum number of spectra profiles loaded',$
charsize: "Character size: 1.0 is quite small, the default is 1.3", $
charthick: "Thicknes of lines used in the Hershley fonts. Default 1. Thicker lines dont really look better.", $
ticklen: "Ticklength: 0.5 means the positive go through 1/2 of the page, with negative values the tick go outside of the plot regin", $
thick:   "Values greater 1 thicken plotted lines and frames.", $
MeltThick:  "Make the Bullets indicating the melting layer heigt thicker.", $
CircleThick:  "Make the Bullets indicating the Ceilo Bases thicker.", $
SymColor:  "Color for the Bullets indicating the melting layer heigt", $
tit:  "Override the auto-generated title of many plot types", $
titsupplement:  "Add to plot titles", $
rangetit:"Y-title for trc-plots. default=Range",$
heitit:"Y-title for thc-plots. default=Range",$
thctit:  "Override the auto-generated title of thc/trc plots (obsolete, replaced by tit).", $
b4tit:  "Can be used to pass a Hershly-style font directive used only for title lines", $
ti:     "Can be uses to pass a Hershly-style font directive used for all annotations", $
startcolor:   "Chang this only if you want to use more than one colt in one plot in an non-true-color device like the png-size efficient 8-bit Z-Buffer", $
colt:   "Color table, the predefined colortables reside in the directory idl/colors" $
}

buffer_proto={ $
ptr_var:ptr_new(),$
ptr_prof:ptr_new(),$
ptr_time:ptr_new(),$
ptr_microsec:ptr_new(),$
ptr_ave:ptr_new(),$
ptr_hours:ptr_new(),$
itr:[-1L,-2L],$
ptr_range:ptr_new(),$
ptr_hei:ptr_new(),$
ptr_tpow:ptr_new(),$
ptr_cpw1:ptr_new(),$
ptr_cpw2:ptr_new(),$
ptr_npw1:ptr_new(),$
ptr_npw2:ptr_new(),$
ptr_azi:ptr_new(),$
ptr_elv:ptr_new(),$
posg:0.5,$ ; weighting factor between 0 and 1 for finetuning the assignement between azi/elv and data chunk. I replaced pp.posg. So now it can be set individually for each buffer
ihr:[-1,-2L], $
drg:-1.,$
nfft:-1,$
location:'unknown',$
filename:'unknown',$
name:'unknown',$
long_name:'unknown',$
units:'',$
yrange:[-15,75.],$
db:0L $
}
buffer_help={ $
name:'Name of the profile used in the axis annotation, use thc after chanhing it.',$
filename:'File name of the profile used in the axis annotation of the scatter plots.',$
long_name:'Name of the profile used in the title, use thc after chanhing it.',$
units:'Unit used in the axis annotation, use thc after chanhing it.',$
yrange:'plotting range for the values, use thc after chanhing it.',$
db:'1 if the data shold be plottet in dB.' $
}
nbuffer = 9
buffer=replicate(buffer_proto,nbuffer+1)

ocolt='none'
hintaec=1

!p.multi = [0,1,1]
if !d.name eq "X" then begin
    if !d.window ge 0 then wdelete
    screen_size=get_screen_size()
    scale=screen_size/[1280.,1024]
    maxcolor=512
    if pp.wxsize gt 0 then xsize=pp.wxsize else xsize=1294*scale[1]
    if pp.wysize gt 0 then ysize=pp.wysize else ysize=800*scale[1]
    ;window,/free,retain=2,colors=maxcolor,title="viewncdf",xpos=90*scale[0],ypos=200*scale[1],xsize=xsize,ysize=ysize
    window,/free,title="viewncdf",xpos=90*scale[0],ypos=200*scale[1],xsize=xsize,ysize=ysize
endif
if !d.name eq "Z" then begin
    Device, Set_Resolution=[1200,800]; , Z_Buffer=0
endif

metarstr=''
ipcs1=0L
ipcs2=0L
last_draw_arg='trc'
while 1 do begin
    if ocolt ne pp.colt then begin
        loadcolor,pp.startcolor,colorfile=pp.colt,zcolor=zcolor 
        ocolt=pp.colt
        TVLCT, ct_red, ct_green, ct_blue, /Get
    endif
    if pp.thctit ne '' then pp.tit=pp.thctit
    
    arg = myprompt('View NCDF >')
artarg:
    cmd = arg[0] &  narg=n_elements(arg)
    case 1 of
        cmd eq 'redraw' or cmd eq 'r': begin
            arg = last_draw_arg
            goto,artarg
        end
        cmd eq 'recent': begin
            pp.BeginTime = ulong(SYSTIME( /SECONDS )) - ulong(arg[1])
        end
        cmd eq 'load' or cmd eq 'ld' or cmd eq 'ldspc': begin
            bufnr = fix(arg[1])-1
            if bufnr ge 0 && bufnr le nbuffer-1 then begin 
                varname = arg[2]
                if ~ ( narg lt 4 || arg[3] eq '"' ) then begin
                    fn4ld = file_search(arg[3])
                    infiles_oldsyntax = strsplit(arg[3],':',/extract)
                    if n_elements(infiles_oldsyntax) gt n_elements(fn4ld) then fn4ld=infiles_oldsyntax
                    fn4title = arg[3]
                endif else begin
                    if n_elements(fn4ld) eq 0 then fn4ld=['']
                endelse
                if fn4ld[0] eq '' then begin 
                    nfiles=0 & print,'file not found'
                endif else nfiles=n_elements(fn4ld)
                firstrun=1
                MissingVarReported=0
                azi_ex=0
                for ifile = 0, nfiles-1 do begin
                    ;catch,error
                    ;if error ne 0 then begin
                    ;    print,'An error with index ',error,' occurred'
                    ;    print,!error_state.msg
                    ;    ;catch,/canc
                    ;    if ifile ge nfiles then print,'ifile ge nfiles',ifile,nfiles $
                    ;    else print,'error while reading from file: ',fn4ld[ifile]
                    ;    goto,NEXT_FILE
                    ;endif
                    gzipped = strpos(fn4ld[ifile],'.gz') eq strlen(fn4ld[ifile])-3
                    if gzipped then begin
                        spawn,'echo $$',pid
                        fn4ldx='/tmp/viewncdf_unzipped.'+pid[0]+'.nc'
                        spawn,'cp '+fn4ld[ifile]+'  '+ fn4ldx+'.gz'
                        spawn,'gunzip -f '+fn4ldx+'.gz'
                    endif else fn4ldx=fn4ld[ifile]
                    ncdfid = NCDF_OPEN(fn4ldx,/NOWRITE)
                    ; Test if varname is a thc variable
                    ncdfnvars=(ncdf_inquire(ncdfid)).NVARS
                    ncdfvarnames=strarr(ncdfnvars)
                    for i=0,ncdfnvars-1 do begin 
                        ncdfvarnames[i] = (ncdf_varinq(ncdfid,i)).name
                    endfor
                    ncdfixv = where(ncdfvarnames eq varname,ncdfnixv)
                    if ncdfnixv eq 1 then begin
                        NCDF_VARGET, ncdfid, 'range', rangex & zrg=n_elements(rangex)
                        rangex = rangex + pp.rangeoffset
                        NCDF_VARGET, ncdfid, 'time', timex
                        timex = timex + pp.timeoffset
                        ixld=where(timex ge pp.BeginTime, ztime)
                        if ztime gt 0 then begin
                            timex=timex[ixld]
                            iBeginTime=ixld[0]
                            NCDF_ATTGET, ncdfid, 'location', location,/global
                            if total(ncdfvarnames eq 'tpow') eq 1 then NCDF_VARGET, ncdfid, 'tpow', tpowx, count=[ztime], offset=[iBeginTime] else tpowx=replicate(30.0,ztime)
                            if total(ncdfvarnames eq 'cpw1') eq 1 then NCDF_VARGET, ncdfid, 'cpw1', cpw1x, count=[ztime], offset=[iBeginTime] else cpw1x=replicate(10.0,ztime)
                            if total(ncdfvarnames eq 'cpw2') eq 1 then NCDF_VARGET, ncdfid, 'cpw2', cpw2x, count=[ztime], offset=[iBeginTime] else cpw2x=replicate(10.0,ztime)
                            if total(ncdfvarnames eq 'npw1') eq 1 then NCDF_VARGET, ncdfid, 'npw1', npw1x, count=[ztime], offset=[iBeginTime] else npw1x=replicate(1.0,ztime)
                            if total(ncdfvarnames eq 'npw2') eq 1 then NCDF_VARGET, ncdfid, 'npw2', npw2x, count=[ztime], offset=[iBeginTime] else npw2x=replicate(1.0,ztime)
                            ncdfixv = where(ncdfvarnames eq 'azi',azi_ex)
                            if azi_ex eq 1 then begin
                                NCDF_VARGET, ncdfid, 'azi', azix, count=[ztime], offset=[iBeginTime]
                                NCDF_VARGET, ncdfid, 'elv', elvx, count=[ztime], offset=[iBeginTime]
                                NCDF_VARGET, ncdfid, 'microsec', microsecx, count=[ztime], offset=[iBeginTime]
                            endif else begin
                                azix=replicate(-999.,ztime)
                                elvx=replicate(90,ztime)
                                microsecx=replicate(0L,ztime)
                            endelse
                            ncdfixv = where(ncdfvarnames eq 'northangle',northangle_ex)
                            if northangle_ex eq 1 then begin
                                NCDF_VARGET, ncdfid, 'northangle', northanglex, count=[ztime], offset=[iBeginTime]
                            endif else begin
                                northanglex=replicate(0.0,ztime)
                            endelse
                            NCDF_VARGET, ncdfid, 'prf',prfx
                            NCDF_VARGET, ncdfid, 'nfft',nfftx
                            NCDF_VARGET, ncdfid, 'nave',navex
                            avex=replicate(float(navex)*nfftx/prfx,n_elements(timex))
                            if cmd ne 'ldspc' then begin
                                ncdfidv = NCDF_VARID(ncdfid, varname ) 
                                NCDF_VARGET, ncdfid, ncdfidv, varx, count=[zrg,ztime], offset=[0L,iBeginTime]
                            endif else begin
                                if ifile eq 0 then begin
                                    NCDF_VARGET, ncdfid, 'doppler', dopplerx
                                    if ztime gt pp.ztime_max then begin
                                        print,'For saving memory only ztime_max='+strgg(pp.ztime_max)+' of '+ strgg(ztime)+' spectra profiles in time are loaded.'
                                        ztime=pp.ztime_max
                                    endif
                                    ncdfidv = NCDF_VARID(ncdfid, varname )
                                    NCDF_VARGET, ncdfid, ncdfidv, spcx, count=[nfftx,zrg,ztime], offset=[0L,0L,iBeginTime]
                                    varx=fltarr(zrg,ztime)
                                    for irg=0L,zrg-1L do for itime=0L,ztime-1 do varx[irg,itime]=min(spcx[*,irg,itime])  
                                    stop
                                endif else begin
                                    print,'spectra are extracted only from the first file. Exiting because multiple files together with ldspc will crash viewncdf'
                                    exit,/no_confirm
                                endelse
                            endelse
                            NCDF_ATTGET, ncdfid, ncdfidv,'yrange', yrangex
                            dyrangex = abs(yrangex[1]-yrangex[0])
                            NCDF_ATTGET, ncdfid, ncdfidv,'long_name', long_namex
                            NCDF_ATTGET, ncdfid, ncdfidv,'units', unitsx
                            NCDF_ATTGET, ncdfid, ncdfidv,'db', dbx
                            if dbx then begin
                                dbvarx=db(varx)
                                ix_outofrange = where(dbvarx lt min(yrangex)-3.*dyrangex or dbvarx gt max(yrangex)+3*dyrangex,nix_outofrange) 
                            endif else begin
                                ix_outofrange = where(varx lt min(yrangex)-3.*dyrangex or varx gt max(yrangex)+3*dyrangex,nix_outofrange)
                            endelse
                            if nix_outofrange gt 0 then varx[ix_outofrange]=!values.f_nan
                            NCDF_VARGET, ncdfid, 'drg', drgx
                            if n_elements(first_day_0000) ne 1 then first_day_0000 = long((timex[0]+70L)/(3600d0*24d0))*24d0
                            hoursx=timex/36d2+microsecx/36d8 - first_day_0000
                            pp.tr[0] <= hoursx[0]-5d-10
                            pp.tr[1] >= hoursx[ztime-1]+5d-10
                            valuetitlex = varname+' ' + (dbx ? 'dB' : '') + string(unitsx)
                            if firstrun eq 1 then begin
                                firstrun=0
                                buffer[bufnr] = buffer_proto
                                buffer[bufnr].ptr_var = ptr_new(varx)
                                buffer[bufnr].ptr_time = ptr_new(timex)
                                buffer[bufnr].ptr_range = ptr_new(rangex)
                                buffer[bufnr].ptr_tpow = ptr_new(tpowx)
                                buffer[bufnr].ptr_cpw1 = ptr_new(cpw1x)
                                buffer[bufnr].ptr_cpw2 = ptr_new(cpw2x)
                                buffer[bufnr].ptr_npw1 = ptr_new(npw1x)
                                buffer[bufnr].ptr_npw2 = ptr_new(npw2x)
                                buffer[bufnr].ptr_microsec = ptr_new(microsecx)
                                buffer[bufnr].ptr_ave = ptr_new(avex)
                                buffer[bufnr].ptr_azi = ptr_new(azix)
                                buffer[bufnr].ptr_elv = ptr_new(elvx)
                                buffer[bufnr].filename = fn4title
                                buffer[bufnr].name = varname
                                buffer[bufnr].location = string(location)
                                buffer[bufnr].nfft = nfftx
                                buffer[bufnr].long_name = string(long_namex)
                                buffer[bufnr].units = string(unitsx)
                                buffer[bufnr].yrange = yrangex
                                buffer[bufnr].db = dbx 
                                buffer[bufnr].drg = drgx 
                            endif else begin
                                ztime_old = n_elements(*buffer[bufnr].ptr_time)
                                ztime_new = n_elements(timex)
                                zrg_old=n_elements(*buffer[bufnr].ptr_range)
                                if zrg_old ne zrg then begin
                                    print,'two files with different number of range gates hav been appended',zrg_old,zrg
                                    zrg = zrg_old < zrg
                                endif
                                varx_old = (*buffer[bufnr].ptr_var)[0:zrg-1,*]  ; limited to new zrg if zrg of next current is smaller than zrg of the last one
                                *buffer[bufnr].ptr_var = fltarr(zrg, ztime_old+ztime_new)
                                (*buffer[bufnr].ptr_var)[*,0:ztime_old-1] = varx_old
                                (*buffer[bufnr].ptr_var)[*,ztime_old:ztime_old+ztime_new-1L] = varx[0:zrg-1,*]  ; the current data is limited in range if it has more ranges than the last file
                                *buffer[bufnr].ptr_time = [*buffer[bufnr].ptr_time,timex]
                                *buffer[bufnr].ptr_microsec = [*buffer[bufnr].ptr_microsec,microsecx]
                                *buffer[bufnr].ptr_ave = [*buffer[bufnr].ptr_ave,avex]
                                *buffer[bufnr].ptr_tpow = [*buffer[bufnr].ptr_tpow,tpowx]
                                *buffer[bufnr].ptr_cpw1 = [*buffer[bufnr].ptr_cpw1,cpw1x]
                                *buffer[bufnr].ptr_cpw2 = [*buffer[bufnr].ptr_cpw2,cpw2x]
                                *buffer[bufnr].ptr_npw1 = [*buffer[bufnr].ptr_npw1,npw1x]
                                *buffer[bufnr].ptr_npw2 = [*buffer[bufnr].ptr_npw2,npw2x]
                                *buffer[bufnr].ptr_azi = [*buffer[bufnr].ptr_azi,azix]
                                *buffer[bufnr].ptr_elv = [*buffer[bufnr].ptr_elv,elvx]
                            endelse
                        endif
                    endif else begin
                        if MissingVarReported eq 0 then begin
                            ; print a list thc of variables which are in the ncdf-file 
                            print,'Requested NetCDF variable ' + varname + ' is not in the file ' + fn4ld[ifile]
                            for i=0,ncdfnvars-1 do begin
                                if (ncdf_varinq(ncdfid,i)).NDIMS ge 2 && (ncdf_varinq(ncdfid,i)).NATTS ge 4 then begin
                                    NCDF_ATTGET, ncdfid, i,'long_name', long_namex
                                    print,form='(a12,": ",a)',(ncdf_varinq(ncdfid,i)).name,string(long_namex)
                                endif
                            endfor
                            MissingVarReported=1
                        endif
                    endelse
NEXT_FILE:
                    ;catch,/canc
                    NCDF_CLOSE, ncdfid
                    if gzipped then spawn,'rm '+fn4ldx
                endfor
                if nfiles gt 0 && azi_ex eq 1 then begin
                    if pp.northangle ge 0 then begin
                        northangle=pp.northangle
                    endif else begin
                        if n_elements(northanglex) gt 0 && northanglex[0] ge 0 then begin
                            northangle=northanglex[0]
                        endif else begin
                            northangle=0.0
                        endelse
                    endelse
                    ixnan=where(finite(*buffer[bufnr].ptr_elv) eq 0,nixnan)  ; doppeltgemoppelt ?
                    if nixnan gt 0 then (*buffer[bufnr].ptr_elv)[ixnan]=90.
                    ixnan=where(finite(*buffer[bufnr].ptr_azi) eq 0,nixnan)
                    if nixnan gt 0 then (*buffer[bufnr].ptr_azi)[ixnan]=-999.
                    ixnan=where(*buffer[bufnr].ptr_elv lt -50.,nixnan)
                    if nixnan gt 0 then (*buffer[bufnr].ptr_elv)[ixnan]=90.
                    ixnan=where(*buffer[bufnr].ptr_azi lt -50.,nixnan)
                    if nixnan gt 0 then (*buffer[bufnr].ptr_azi)[ixnan]=-999.
                    ; correct time stamps, azi and elv and set posg for the loaded buffer
                    ztime=n_elements(*buffer[bufnr].ptr_time)
                    time_ = *buffer[bufnr].ptr_time
                    microsec_ = *buffer[bufnr].ptr_microsec
                    dbltime_=double(time_)+1d-6*microsec_
                    if ztime ge 2 then begin
                        deltatime_=dbltime_[1:ztime-1]-dbltime_[0:ztime-2]
                        dt_=median(deltatime_)
                    endif else begin
                        dt_=1.
                    endelse
                    azielv_corrected = (*buffer[bufnr].ptr_azi)[0] ge 370.
                    if pp.pertubate then begin 
                        ; swap left right in a ppi plot
                        if azielv_corrected then begin
                            (*buffer[bufnr].ptr_elv)[*] -= 720.0
                            (*buffer[bufnr].ptr_azi)[*] -= 720.0
                        endif
                        ixpertubate = where(*buffer[bufnr].ptr_elv gt 90. and *buffer[bufnr].ptr_azi ge -1.0,nixpertubate)
                        if nixpertubate gt 0 then begin
                            (*buffer[bufnr].ptr_elv)[ixpertubate] = 180.-(*buffer[bufnr].ptr_elv)[ixpertubate]
                            (*buffer[bufnr].ptr_azi)[ixpertubate] = ( (*buffer[bufnr].ptr_azi)[ixpertubate] + 180. ) mod 360.
                        endif
                        if azielv_corrected then begin
                            (*buffer[bufnr].ptr_elv)[*] += 720.0
                            (*buffer[bufnr].ptr_azi)[*] += 720.0
                        endif
                    endif
                    case 1 of
                        azielv_corrected: begin
                            buffer[bufnr].posg = 1.0 ; time,elv,azi stamps represent the middle of the averaging periode
                        end
                        syspar.no_stamp_shift:begin
                            ; print,'skipped shifting stamps, setting posg=0.5, try values between .5 and 1 if clouds appear tilted'
                            buffer[bufnr].posg = 0.5  ; time,elv,azi stamps represent the end of the averaging periode
                        end
                        ztime gt 2:begin
                                *buffer[bufnr].ptr_time = [(*buffer[bufnr].ptr_time)[0]-long(dt_),(*buffer[bufnr].ptr_time)[0:ztime-2]]
                                *buffer[bufnr].ptr_microsec = [(*buffer[bufnr].ptr_microsec)[0] - long( 1d6*(dt_ mod 1d0) ),(*buffer[bufnr].ptr_microsec)[0:ztime-2]]
                                *buffer[bufnr].ptr_azi = [2*(*buffer[bufnr].ptr_azi)[0]-(*buffer[bufnr].ptr_azi)[1],(*buffer[bufnr].ptr_azi)[0:ztime-2]]
                                *buffer[bufnr].ptr_elv = [2*(*buffer[bufnr].ptr_elv)[0]-(*buffer[bufnr].ptr_elv)[1],(*buffer[bufnr].ptr_elv)[0:ztime-2]]
                                buffer[bufnr].posg = 0.5  ; after shifting time,elv,azi stamps represent the end of the averaging periode
                        end
                        else:print,'Azi and elv where not corrected because there are less than 3 dwells in the buffer'
                    endcase
                endif
            endif else print,'usage: load <BufferNumber> <ProfileName>  # <BufferNumber>= 1, ..,'+string(nbuffer)
            ;catch,/canc
        end
        cmd eq 'rpg': begin
            bufnr = fix(arg[1])-1
            if bufnr ge 0 && bufnr le nbuffer-1 then begin 
                varname = arg[2]
                if ~ ( narg lt 4 || arg[3] eq '"' ) then begin
                    fn4ld = file_search(arg[3])
                    infiles_oldsyntax = strsplit(arg[3],':',/extract)
                    if n_elements(infiles_oldsyntax) gt n_elements(fn4ld) then fn4ld=infiles_oldsyntax
                    fn4title = arg[3]
                endif else begin
                    if n_elements(fn4ld) eq 0 then fn4ld=['']
                endelse
                if fn4ld[0] eq '' then begin 
                    nfiles=0 & print,'file not found'
                endif else nfiles=n_elements(fn4ld)
                firstrun=1
                MissingVarReported=0
                azi_ex=0
                for ifile = 0, nfiles-1 do begin
                    ;catch,error
                    ;if error ne 0 then begin
                    ;    print,'An error with index ',error,' occurred'
                    ;    print,!error_state.msg
                    ;    ;catch,/canc
                    ;    if ifile ge nfiles then print,'ifile ge nfiles',ifile,nfiles $
                    ;    else print,'error while reading from file: ',fn4ld[ifile]
                    ;    goto,NEXT_FILE_RPG
                    ;endif
                    gzipped = strpos(fn4ld[ifile],'.gz') eq strlen(fn4ld[ifile])-3
                    if gzipped then begin
                        spawn,'echo $$',pid
                        fn4ldx='/tmp/viewncdf_unzipped.'+pid[0]+'.nc'
                        spawn,'cp '+fn4ld[ifile]+'  '+ fn4ldx+'.gz'
                        spawn,'gunzip -f '+fn4ldx+'.gz'
                    endif else fn4ldx=fn4ld[ifile]
                    ChirpPrefix=strmid(varname,0,2)
                    iChirp=long(strmid(varname,1,1))
                    ncdfid = NCDF_OPEN(fn4ldx,/NOWRITE)
                    ; Test if varname is a thc variable
                    ncdfnvars=(ncdf_inquire(ncdfid)).NVARS
                    ncdfvarnames=strarr(ncdfnvars)
                    for i=0,ncdfnvars-1 do begin 
                        ncdfvarnames[i] = (ncdf_varinq(ncdfid,i)).name
                    endfor
                    ncdfixv = where(ncdfvarnames eq varname,ncdfnixv)
                    if ncdfnixv eq 1 then begin
                        NCDF_VARGET, ncdfid, ChirpPrefix+'Range', rangex & zrg=n_elements(rangex)
                        rangex = rangex + pp.rangeoffset
                        drgx=rangex[1]-rangex[0]
                        NCDF_VARGET, ncdfid, 'Time', timex
                        timex = timex + pp.timeoffset + (31UL*365UL+8UL)*3600UL*24UL
                        ixld=where(timex ge pp.BeginTime, ztime)
                        if ztime gt 0 then begin
                            timex=timex[ixld]
                            iBeginTime=ixld[0]
                            ;NCDF_ATTGET, ncdfid, 'location', location,/global
                            location='RPG'
                            if total(ncdfvarnames eq 'TPow') eq 1 then NCDF_VARGET, ncdfid, 'TPow', tpowx, count=[ztime], offset=[iBeginTime] else tpowx=replicate(30.0,ztime)
                            if total(ncdfvarnames eq 'cpw1') eq 1 then NCDF_VARGET, ncdfid, 'cpw1', cpw1x, count=[ztime], offset=[iBeginTime] else cpw1x=replicate(10.0,ztime)
                            if total(ncdfvarnames eq 'cpw2') eq 1 then NCDF_VARGET, ncdfid, 'cpw2', cpw2x, count=[ztime], offset=[iBeginTime] else cpw2x=replicate(10.0,ztime)
                            if total(ncdfvarnames eq 'npw1') eq 1 then NCDF_VARGET, ncdfid, 'npw1', npw1x, count=[ztime], offset=[iBeginTime] else npw1x=replicate(1.0,ztime)
                            if total(ncdfvarnames eq 'npw2') eq 1 then NCDF_VARGET, ncdfid, 'npw2', npw2x, count=[ztime], offset=[iBeginTime] else npw2x=replicate(1.0,ztime)
                            ncdfixv = where(ncdfvarnames eq 'Azm',azi_ex)
                            if azi_ex eq 1 then begin
                                NCDF_VARGET, ncdfid, 'Azm', azix, count=[ztime], offset=[iBeginTime]
                                NCDF_VARGET, ncdfid, 'Elv', elvx, count=[ztime], offset=[iBeginTime]
                                NCDF_VARGET, ncdfid, 'Timems', msx, count=[ztime], offset=[iBeginTime]
                                microsecx = long(msx)*1000 
                            endif else begin
                                azix=replicate(-999.,ztime)
                                elvx=replicate(90,ztime)
                                microsecx=replicate(0L,ztime)
                            endelse
                            ncdfixv = where(ncdfvarnames eq 'northangle',northangle_ex)
                            if northangle_ex eq 1 then begin
                                NCDF_VARGET, ncdfid, 'northangle', northanglex, count=[ztime], offset=[iBeginTime]
                            endif else begin
                                northanglex=replicate(0.0,ztime)
                            endelse
                            NCDF_VARGET, ncdfid, 'SampDur',SampDurx
                            NCDF_VARGET, ncdfid, 'ChirpNum',ChirpNumx
                            NCDF_VARGET, ncdfid, 'DoppLen',DoppLenx,count=[ChirpNumx],offset=0
                            NCDF_VARGET, ncdfid, 'AvgNum',AvgNumx,count=[ChirpNumx],offset=0
                            NCDF_VARGET, ncdfid, 'SeqIntTime',SeqIntTimex,count=[ChirpNumx],offset=0
                            NCDF_VARGET, ncdfid, 'RangeRes',RangeResx,count=[ChirpNumx],offset=0
                            NCDF_VARGET, ncdfid, 'MaxVel',MaxVelx,count=[ChirpNumx],offset=0
                            navex = AvgNumx[iChirp-1]/DoppLenx[iChirp-1]
                            nfftx= DoppLenx[iChirp-1]
                            avex=replicate(SampDurx,n_elements(timex))
                            ncdfidv = NCDF_VARID(ncdfid, varname ) 
                            NCDF_VARGET, ncdfid, ncdfidv, varx, count=[zrg,ztime], offset=[0L,iBeginTime]
                            NCDF_ATTGET, ncdfid, ncdfidv,'Name', long_namex
                            NCDF_ATTGET, ncdfid, ncdfidv,'units', unitsx
                            case 1 of 
                                strpos(varname,'ZE') ge 0:begin
                                    yrangex=[-60,30.]
                                    dbx = 1
                                end
                                else:begin
                                    yrangex=[-10,10.]
                                    dbx = 0
                                end
                            endcase
                            dyrangex = abs(yrangex[1]-yrangex[0])
                            if dbx then begin
                                dbvarx=db(varx)
                                ix_outofrange = where(dbvarx lt min(yrangex)-3.*dyrangex or dbvarx gt max(yrangex)+3*dyrangex,nix_outofrange) 
                            endif else begin
                                ix_outofrange = where(varx lt min(yrangex)-3.*dyrangex or varx gt max(yrangex)+3*dyrangex,nix_outofrange)
                            endelse
                            if nix_outofrange gt 0 then varx[ix_outofrange]=!values.f_nan
                            if n_elements(first_day_0000) ne 1 then first_day_0000 = long((timex[0]+70L)/(3600d0*24d0))*24d0
                            hoursx=timex/36d2+microsecx/36d8 - first_day_0000
                            pp.tr[0] <= hoursx[0]-5d-10
                            pp.tr[1] >= hoursx[ztime-1]+5d-10
                            valuetitlex = varname+' ' + (dbx ? 'dB' : '') + string(unitsx)
                            if firstrun eq 1 then begin
                                firstrun=0
                                buffer[bufnr] = buffer_proto
                                buffer[bufnr].ptr_var = ptr_new(varx)
                                buffer[bufnr].ptr_time = ptr_new(timex)
                                buffer[bufnr].ptr_range = ptr_new(rangex)
                                buffer[bufnr].ptr_tpow = ptr_new(tpowx)
                                buffer[bufnr].ptr_cpw1 = ptr_new(cpw1x)
                                buffer[bufnr].ptr_cpw2 = ptr_new(cpw2x)
                                buffer[bufnr].ptr_npw1 = ptr_new(npw1x)
                                buffer[bufnr].ptr_npw2 = ptr_new(npw2x)
                                buffer[bufnr].ptr_microsec = ptr_new(microsecx)
                                buffer[bufnr].ptr_ave = ptr_new(avex)
                                buffer[bufnr].ptr_azi = ptr_new(azix)
                                buffer[bufnr].ptr_elv = ptr_new(elvx)
                                buffer[bufnr].filename = fn4title
                                buffer[bufnr].name = varname
                                buffer[bufnr].location = string(location)
                                buffer[bufnr].nfft = nfftx
                                buffer[bufnr].long_name = string(long_namex)
                                buffer[bufnr].units = string(unitsx)
                                buffer[bufnr].yrange = yrangex
                                buffer[bufnr].db = dbx 
                                buffer[bufnr].drg = drgx 
                            endif else begin
                                ztime_old = n_elements(*buffer[bufnr].ptr_time)
                                ztime_new = n_elements(timex)
                                zrg_old=n_elements(*buffer[bufnr].ptr_range)
                                if zrg_old ne zrg then begin
                                    print,'two files with different number of range gates hav been appended',zrg_old,zrg
                                    zrg = zrg_old < zrg
                                endif
                                varx_old = (*buffer[bufnr].ptr_var)[0:zrg-1,*]  ; limited to new zrg if zrg of next current is smaller than zrg of the last one
                                *buffer[bufnr].ptr_var = fltarr(zrg, ztime_old+ztime_new)
                                (*buffer[bufnr].ptr_var)[*,0:ztime_old-1] = varx_old
                                (*buffer[bufnr].ptr_var)[*,ztime_old:ztime_old+ztime_new-1L] = varx[0:zrg-1,*]  ; the current data is limited in range if it has more ranges than the last file
                                *buffer[bufnr].ptr_time = [*buffer[bufnr].ptr_time,timex]
                                *buffer[bufnr].ptr_microsec = [*buffer[bufnr].ptr_microsec,microsecx]
                                *buffer[bufnr].ptr_ave = [*buffer[bufnr].ptr_ave,avex]
                                *buffer[bufnr].ptr_tpow = [*buffer[bufnr].ptr_tpow,tpowx]
                                *buffer[bufnr].ptr_cpw1 = [*buffer[bufnr].ptr_cpw1,cpw1x]
                                *buffer[bufnr].ptr_cpw2 = [*buffer[bufnr].ptr_cpw2,cpw2x]
                                *buffer[bufnr].ptr_npw1 = [*buffer[bufnr].ptr_npw1,npw1x]
                                *buffer[bufnr].ptr_npw2 = [*buffer[bufnr].ptr_npw2,npw2x]
                                *buffer[bufnr].ptr_azi = [*buffer[bufnr].ptr_azi,azix]
                                *buffer[bufnr].ptr_elv = [*buffer[bufnr].ptr_elv,elvx]
                            endelse
                        endif
                    endif else begin
                        if MissingVarReported eq 0 then begin
                            ; print a list thc of variables which are in the ncdf-file 
                            print,'Requested NetCDF variable ' + varname + ' is not in the file ' + fn4ld[ifile]
                            for i=0,ncdfnvars-1 do begin
                                if (ncdf_varinq(ncdfid,i)).NDIMS ge 2 && (ncdf_varinq(ncdfid,i)).NATTS ge 4 then begin
                                    NCDF_ATTGET, ncdfid, i,'long_name', long_namex
                                    print,form='(a12,": ",a)',(ncdf_varinq(ncdfid,i)).name,string(long_namex)
                                endif
                            endfor
                            MissingVarReported=1
                        endif
                    endelse
NEXT_FILE_RPG:
                    ;catch,/canc
                    NCDF_CLOSE, ncdfid
                    if gzipped then spawn,'rm '+fn4ldx
                endfor
                if nfiles gt 0 && azi_ex eq 1 then begin
                    if pp.northangle ge 0 then begin
                        northangle=pp.northangle
                    endif else begin
                        if n_elements(northanglex) gt 0 && northanglex[0] ge 0 then begin
                            northangle=northanglex[0]
                        endif else begin
                            northangle=0.0
                        endelse
                    endelse
                    ixnan=where(finite(*buffer[bufnr].ptr_elv) eq 0,nixnan)  ; doppeltgemoppelt ?
                    if nixnan gt 0 then (*buffer[bufnr].ptr_elv)[ixnan]=90.
                    ixnan=where(finite(*buffer[bufnr].ptr_azi) eq 0,nixnan)
                    if nixnan gt 0 then (*buffer[bufnr].ptr_azi)[ixnan]=-999.
                    ixnan=where(*buffer[bufnr].ptr_elv lt -50.,nixnan)
                    if nixnan gt 0 then (*buffer[bufnr].ptr_elv)[ixnan]=90.
                    ixnan=where(*buffer[bufnr].ptr_azi lt -50.,nixnan)
                    if nixnan gt 0 then (*buffer[bufnr].ptr_azi)[ixnan]=-999.
                    ; correct time stamps, azi and elv and set posg for the loaded buffer
                    ztime=n_elements(*buffer[bufnr].ptr_time)
                    time_ = *buffer[bufnr].ptr_time
                    microsec_ = *buffer[bufnr].ptr_microsec
                    dbltime_=double(time_)+1d-6*microsec_
                    if ztime ge 2 then begin
                        deltatime_=dbltime_[1:ztime-1]-dbltime_[0:ztime-2]
                        dt_=median(deltatime_)
                    endif else begin
                        dt_=1.
                    endelse
                    azielv_corrected = (*buffer[bufnr].ptr_azi)[0] ge 370.
                    if pp.pertubate then begin 
                        ; swap left right in a ppi plot
                        if azielv_corrected then begin
                            (*buffer[bufnr].ptr_elv)[*] -= 720.0
                            (*buffer[bufnr].ptr_azi)[*] -= 720.0
                        endif
                        ixpertubate = where(*buffer[bufnr].ptr_elv gt 90. and *buffer[bufnr].ptr_azi ge -1.0,nixpertubate)
                        if nixpertubate gt 0 then begin
                            (*buffer[bufnr].ptr_elv)[ixpertubate] = 180.-(*buffer[bufnr].ptr_elv)[ixpertubate]
                            (*buffer[bufnr].ptr_azi)[ixpertubate] = ( (*buffer[bufnr].ptr_azi)[ixpertubate] + 180. ) mod 360.
                        endif
                        if azielv_corrected then begin
                            (*buffer[bufnr].ptr_elv)[*] += 720.0
                            (*buffer[bufnr].ptr_azi)[*] += 720.0
                        endif
                    endif
                    case 1 of
                        azielv_corrected: begin
                            buffer[bufnr].posg = 1.0 ; time,elv,azi stamps represent the middle of the averaging periode
                        end
                        syspar.no_stamp_shift:begin
                            ; print,'skipped shifting stamps, setting posg=0.5, try values between .5 and 1 if clouds appear tilted'
                            buffer[bufnr].posg = 0.5  ; time,elv,azi stamps represent the end of the averaging periode
                        end
                        ztime gt 2:begin
                                *buffer[bufnr].ptr_time = [(*buffer[bufnr].ptr_time)[0]-long(dt_),(*buffer[bufnr].ptr_time)[0:ztime-2]]
                                *buffer[bufnr].ptr_microsec = [(*buffer[bufnr].ptr_microsec)[0] - long( 1d6*(dt_ mod 1d0) ),(*buffer[bufnr].ptr_microsec)[0:ztime-2]]
                                *buffer[bufnr].ptr_azi = [2*(*buffer[bufnr].ptr_azi)[0]-(*buffer[bufnr].ptr_azi)[1],(*buffer[bufnr].ptr_azi)[0:ztime-2]]
                                *buffer[bufnr].ptr_elv = [2*(*buffer[bufnr].ptr_elv)[0]-(*buffer[bufnr].ptr_elv)[1],(*buffer[bufnr].ptr_elv)[0:ztime-2]]
                                buffer[bufnr].posg = 0.5  ; after shifting time,elv,azi stamps represent the end of the averaging periode
                        end
                        else:print,'Azi and elv where not corrected because there are less than 3 dwells in the buffer'
                    endcase
                endif
            endif else print,'usage: load <BufferNumber> <ProfileName>  # <BufferNumber>= 1, ..,'+string(nbuffer)
            ;catch,/canc
        end
        cmd eq 'melt' or cmd eq 'meltDB' or cmd eq 'meltDet' or cmd eq 'MRM' or cmd eq 'MRMco' or cmd eq 'MRMcx': begin
            if ~ ( narg lt 2 || arg[1] eq '"' ) then fn4ld = file_search(arg[1]) else begin
                if n_elements(fn4ld) eq 0 then fn4ld=['']
            endelse
            if fn4ld[0] eq '' then begin 
                nfiles=0 
                if narg eq 2 then print,'file not found:'+arg[1] else print,'From which file should MeltRg be taken'
            endif else nfiles=n_elements(fn4ld)
            for ifile = 0, nfiles-1 do begin
                gzipped = strpos(fn4ld[ifile],'.gz') eq strlen(fn4ld[ifile])-3
                if gzipped then begin
                    spawn,'echo $$',pid
                    fn4ldx='/tmp/viewncdf_unzipped.'+pid[0]+'.nc'
                    spawn,'cp '+fn4ld[ifile]+'  '+ fn4ldx+'.gz'
                    spawn,'gunzip -f '+fn4ldx+'.gz'
                endif else fn4ldx=fn4ld[ifile]
                ncdfid = NCDF_OPEN(fn4ldx,/NOWRITE)
                if cmd eq 'melt'   then NCDF_VARGET, ncdfid, 'MeltHei', MeltHeis
                if cmd eq 'meltDB' then NCDF_VARGET, ncdfid, 'MeltHeiDB', MeltHeisDB
                if cmd eq 'meltDet' then NCDF_VARGET, ncdfid, 'MeltHeiDet', MeltHeisDet
                if cmd eq 'MRM' then begin & NCDF_VARGET, ncdfid, 'MRMco', MRMco & NCDF_VARGET, ncdfid, 'MRMcx', MRMcx & endif
                if cmd eq 'MRMco' then NCDF_VARGET, ncdfid, 'MRMco', MRMco
                if cmd eq 'MRMcx' then NCDF_VARGET, ncdfid, 'MRMcx', MRMco
                NCDF_VARGET, ncdfid, 'time', timex
                NCDF_CLOSE, ncdfid
                if gzipped then spawn,'rm '+fn4ldx
                usercirc,pp.MeltThick
                if cmd eq 'melt'   then oplot,unixtime2jul(timex),MeltHeis/pp.td,color=pp.SymColor
                if cmd eq 'meltDB' then oplot,unixtime2jul(timex),MeltHeisDB/pp.td,color=pp.SymColor
                if cmd eq 'meltDet' then oplot,unixtime2jul(timex),MeltHeisDet/pp.td,color=pp.SymColor,psym=8,thick=pp.thick
                if cmd eq 'MRM' then begin
                    oplot,unixtime2jul(timex),pp.mrm_hei+(db(0.5*(MRMco+MRMcx))+pp.mrm_off)*pp.mrm_fac,color=pp.SymColor,thick=pp.thick
                    oplot,unixtime2jul(timex),0*timex+pp.mrm_hei,color=pp.SymColor,thick=pp.thick
                endif
                if cmd eq 'MRMco' then begin
                    oplot,unixtime2jul(timex),pp.mrm_hei+(db(1.*(MRMco))+pp.mrm_off)*pp.mrm_fac,color=pp.SymColor,thick=pp.thick
                    oplot,unixtime2jul(timex),0*timex+pp.mrm_hei,color=pp.SymColor,thick=pp.thick
                endif
                if cmd eq 'MRMcx' then begin
                    oplot,unixtime2jul(timex),pp.mrm_hei+(db(1.*(MRMcx))+pp.mrm_off)*pp.mrm_fac,color=pp.SymColor,thick=pp.thick
                    oplot,unixtime2jul(timex),0*timex+pp.mrm_hei,color=pp.SymColor,thick=pp.thick
                endif
            endfor
        end
        cmd eq 'bases': begin    ; read ceilometer bases from the jenoptik-dat files and oplot them to the thc plots
            if file_search(arg[1]) ne '' then begin
                read_ceilo_dat_chm15k,arg[1],timex,bases
                nbasest = n_elements(bases[0,*])
                nbasesr = n_elements(bases[*,0])
                nbases = nbasest * nbasesr
                xxx = dblarr(nbases)
                yyy = fltarr(nbases)
                nbases=0L
                for iti=0L,nbasest-1 do begin
                    hour = timex[iti] ; /36d2 - first_day_0000
                    for irg=0,nbasesr-1 do begin
                        if finite(bases[irg,iti]) then begin
                            xxx[nbases] = hour
                            yyy[nbases] = bases[irg,iti]
                            nbases++
                        endif
                    endfor
                endfor
                if nbases gt 0 then begin
                    usercirc,pp.CircleThick
                    oplot,unixtime2jul(xxx[0:nbases-1]),yyy[0:nbases-1]/pp.td,psym=8,color=pp.SymColor
                endif
            endif else print,'ceilometer data file: ' + arg[1] + ' not found'
        end
        cmd eq 'cbh': begin    ; read ceilometer bases from the jenoptik-nc files and oplot them to the thc plots
            if (file_test(arg[1],/read)) then begin
                read_ceilo_nc_chm15k,arg[1],timex,bases
                usercirc,pp.CircleThick
                oplot,unixtime2jul(timex),bases[0,*]/pp.td,psym=8,color=pp.SymColor
            endif else print,'ceilometer netCDF file: ' + arg[1] + ' not found'
        end
        cmd eq 'ceilo' or cmd eq 'ceilonc': begin
            ;bufnr = fix(arg[1])-1
            if file_search(arg[2]) ne '' then begin
                frm = cmd eq 'ceilonc'
                if bufnr ge 0 && bufnr le nbuffer-1 then begin
                    read_ceilometer_bsc,arg[2],rangex,timex,varx,frm=frm
                    ; for i=0,(ncdf_inquire(ncdfid)).NVARS-1 do print, (ncdf_varinq(ncdfid,i)).name
                    long_namex = 'Ceilometer Power'
                    unitsx = ' '
                    yrangex = [-5,30.]
                    dbx = 1
                    drgx = 10
                    buffer[bufnr] = buffer_proto
                    buffer[bufnr].ptr_var = ptr_new(varx)
                    buffer[bufnr].ptr_time = ptr_new(timex)
                    if n_elements(first_day_0000) ne 1 then first_day_0000 = long((timex[0]+70L)/(3600d0*24d0))*24d0
                    ntime = n_elements(timex)
                    pp.tr[0] <= timex[0]/36d2 - first_day_0000
                    pp.tr[1] >= timex[ntime-1]/36d2 - first_day_0000
                    buffer[bufnr].ptr_range = ptr_new(rangex)
                    buffer[bufnr].ptr_tpow = ptr_new(replicate(30.,n_elements(timex)))
                    buffer[bufnr].filename = arg[2]
                    buffer[bufnr].name = 'PWR'
                    buffer[bufnr].long_name = string(long_namex)
                    buffer[bufnr].units = string(unitsx)
                    buffer[bufnr].yrange = yrangex
                    buffer[bufnr].db = dbx 
                    buffer[bufnr].drg = drgx 
                endif else print,'usage: load <BufferNumber> <ProfileName>  # <BufferNumber>= 1, ..,'+string(nbuffer)
            endif else print,'Ceilometer data file '+arg[2]+ ' not found'
        end
        cmd eq 'interpolt': begin
            bufnr1 = fix(arg[1])-1
            bufnr2 = fix(arg[2])-1
            if bufnr1 ge 0 && bufnr1 lt nbuffer && bufnr2 ge 0 && bufnr2 lt nbuffer then begin
                ; buf1 is modified so that is gridded to the time grid of buf2. pp.InterpoltOffset is added to buf1. Positive InterpoltOffset is needed if the clock of the system of buf1 was running too slow
                t0 = 36d2*24d0*((*buffer[bufnr1].ptr_time)[0]/(3600L*24L))
                time_org = (*buffer[bufnr1].ptr_time - t0) + *buffer[bufnr1].ptr_microsec * 1d-6 + pp.InterpoltOffset
                time_new = (*buffer[bufnr2].ptr_time - t0) + *buffer[bufnr2].ptr_microsec * 1d-6
                ztime_org = n_elements(time_org)
                ztime_new = n_elements(time_new)
                zrg_org = n_elements(*buffer[bufnr1].ptr_range)
                zrg_new = n_elements(*buffer[bufnr2].ptr_range)
                ;ptr_free,ptr_var_new
                ptr_var_new=ptr_new(fltarr(zrg_org,ztime_new))
                ixclosest=lonarr(ztime_new)
                for itin=0L,ztime_new-1 do begin
                    dummy=min(abs(time_new[itin]-time_org),ixmini)
                    ixclosest[itin]=ixmini
                endfor
                for irg=0L,zrg_org-1 do begin
                    orgo=reform(float((*buffer[bufnr1].ptr_var)[irg,*]))
                    if total(finite(orgo)) ge 2 then begin
                        (*ptr_var_new)[irg,*] = interpol(orgo,time_org,time_new,/quadratic) + 0.0*orgo[ixclosest]
                    endif else begin
                        (*ptr_var_new)[irg,*] = !values.f_nan
                    endelse
                endfor
                ptr_free,buffer[bufnr1].ptr_var
                buffer[bufnr1].ptr_var = ptr_var_new
                ptr_free,buffer[bufnr1].ptr_time
                buffer[bufnr1].ptr_time = ptr_new(*buffer[bufnr2].ptr_time)
                ptr_free,buffer[bufnr1].ptr_microsec
                buffer[bufnr1].ptr_microsec = ptr_new(*buffer[bufnr2].ptr_microsec)
                ptr_free,buffer[bufnr1].ptr_ave
                buffer[bufnr1].ptr_ave = ptr_new(*buffer[bufnr2].ptr_ave)
                ptr_elv_new = ptr_new( interpol(*buffer[bufnr1].ptr_elv,time_org,time_new,/quadratic))
                ptr_free,buffer[bufnr1].ptr_elv
                buffer[bufnr1].ptr_elv = ptr_elv_new 
                ptr_azi_new = ptr_new( interpol(*buffer[bufnr1].ptr_azi,time_org,time_new,/quadratic))
                ptr_free,buffer[bufnr1].ptr_azi
                buffer[bufnr1].ptr_azi = ptr_azi_new 
                ptr_tpow_new = ptr_new( interpol(*buffer[bufnr1].ptr_tpow,time_org,time_new,/quadratic))
                ptr_free,buffer[bufnr1].ptr_tpow
                buffer[bufnr1].ptr_tpow = ptr_tpow_new 
            endif else begin
               print,'usage: interpolt <BufferNumber1> <BufferNumber2>'
               print,'Interpolate the data in <BufferNumber1> acording to the time scale of the data in <BufferNumber2>. The buffer <BufferNumber1> and <BufferNumber2> must be filled by load-cmd before.'
            endelse
        end
        cmd eq 'interpolr': begin
            ; Veraendert (interpoliert) die Messdaten in bufnr1 so, dass sie zu bufnr2 passen.
            ; Bevor man scatterplots macht, oder calc auf die Messdaten unterschiedlicher Geraete anwendet
            ; sollt man interpolr und interpolt verwenden. 
            bufnr1 = fix(arg[1])-1
            bufnr2 = fix(arg[2])-1
            if bufnr1 ge 0 && bufnr1 lt nbuffer && bufnr2 ge 0 && bufnr2 lt nbuffer then begin
                ztime_org = n_elements( *buffer[bufnr1].ptr_time )
                ranges_org = *buffer[bufnr1].ptr_range * pp.InterpolrFactor + pp.InterpolrOffset
                zrg_org = n_elements(ranges_org)
                ranges_new = *buffer[bufnr2].ptr_range 
                zrg_new = n_elements(ranges_new)
                ; ptr_free,ptr_var_new
                ptr_var_new=ptr_new(fltarr(zrg_new,ztime_org))
                ixclosest=lonarr(zrg_new) 
                for irgn=0,zrg_new-1 do begin
                    dummy=min(abs(ranges_new[irgn]-ranges_org),ixmini)
                    ixclosest[irgn]=ixmini
                endfor
                for iti=0L,ztime_org-1 do begin
                    orgo = float((*buffer[bufnr1].ptr_var)[*,iti])
                    if total(finite(orgo)) ge 2 then begin
                        (*ptr_var_new)[0,iti] = interpol(orgo,ranges_org,ranges_new,/quadratic) + 0.0*orgo[ixclosest]
                    endif else begin
                        (*ptr_var_new)[*,iti] = !values.f_nan
                    endelse
                endfor
                ptr_free,buffer[bufnr1].ptr_var
                buffer[bufnr1].ptr_var = ptr_var_new
                ptr_free,buffer[bufnr1].ptr_range
                buffer[bufnr1].ptr_range = ptr_new(ranges_new)
                buffer[bufnr1].drg = buffer[bufnr2].drg
            endif else begin
               print,'usage: interpolr <BufferNumber1> <BufferNumber2>'
               print,'The buffer <BufferNumber1> and <BufferNumber2> must be filled by load-cmd before.'
               print,'The ranges of buffer <BufferNumber1> are interpolated to match <BufferNumber2>.'
            endelse
        end
        cmd eq 'vertically': begin
            ; set all values to nan where elevation is not 90+/-0.1
            if narg gt 1 && fix(arg[1])-1 ge 0 && fix(arg[1])-1 le nbuffer then begin
                bufnr = fix(arg[1])-1
                ixt_nonvertically=where(abs((*buffer[bufnr].ptr_elv)-90.) gt 0.1,nixt_nonvertically)
                if nixt_nonvertically gt 0 then begin
                    (*buffer[bufnr].ptr_var)[*,ixt_nonvertically]=!values.f_nan
                    print,'setting '+strgg(nixt_nonvertically)+' profiles to NaN'
                    print,'pls use trc again before making a scatter plot or histogram'
                endif else print,'all was vertically'
            endif else begin
                print,'usage: vertically <BufferNumber1>'
            endelse
        end
        cmd eq 'fillt': begin
            if narg gt 1 && fix(arg[1])-1 ge 0 && fix(arg[1])-1 le nbuffer && n_elements(*buffer[fix(arg[1])-1].ptr_prof) gt 1 then begin
                bufnr1 = fix(arg[1])-1
                time_org = *buffer[bufnr1].ptr_time 
                ztime_org = n_elements(time_org)
                zrg_org = n_elements(*buffer[bufnr1].ptr_range)
                t0=time_org[0]
                tvon=time_org[0]
                tbis=time_org[ztime_org-1]
                tdelta = long(median(abs(time_org[1:ztime_org-1]-time_org[0:ztime_org-2]))+0.4)
                ztime_new = (tbis-tvon) / tdelta + 1
                time_new = tvon + lindgen(ztime_new)*tdelta
                zrg_new = zrg_org
                ;ptr_free,ptr_var_new
                ptr_var_new=ptr_new(fltarr(zrg_org,ztime_new))
                create=1
                for irg=0,zrg_org-1 do begin
                    ;(*ptr_var_new)[irg,*] = interpol(float((*buffer[bufnr1].ptr_var)[irg,*]),time_org-t0,time_new-t0,/quadratic)
                    (*ptr_var_new)[irg,*] = fueller(float((*buffer[bufnr1].ptr_var)[irg,*]),time_org-t0,time_new-t0,missing=-99999.,create=create)
                    create=0
                endfor
                ptr_free,buffer[bufnr1].ptr_var
                buffer[bufnr1].ptr_var = ptr_var_new
                ptr_free,buffer[bufnr1].ptr_time
                buffer[bufnr1].ptr_time = ptr_new(time_new)
                ptr_tpow_new = ptr_new( interpol(*buffer[bufnr1].ptr_tpow,time_org-t0,time_new-t0,/quadratic))
                ptr_free,buffer[bufnr1].ptr_tpow
                buffer[bufnr1].ptr_tpow = ptr_tpow_new 
            endif else begin
               print,'usage: fillt <BufferNumber> tvon tbis tdelta'
               print,'The buffer <BufferNumber> must be filled by load-cmd before.'
            endelse
        end
        cmd eq 'fillr' or cmd eq 'fillh' : begin
            ; fillr <bufnr1> <hvon> <hbis> <hdelta> 
            ; Gridded die Messdaten auf ein neues Hoehenraster 
            ; Wenn <hbis> und /oder <hdelta> weg gelassen werden, werden sie entsprechend den Originaldaten gesetzt
            bufnr1 = fix(arg[1])-1
            hvon = float(arg[2])
            if bufnr1 ge 0 && bufnr1 lt nbuffer && n_elements(*buffer[bufnr1].ptr_prof) gt 1 then begin
                ranges_org = *buffer[bufnr1].ptr_range
                zrg_org = n_elements(ranges_org)
                if narg gt 3 then hbis = float(arg[3]) else hbis=ranges_org[zrg_org-1]
                if narg gt 4 then hdelta = float(arg[4]) else hdelta=min(abs(ranges_org[1:zrg_org-1]-ranges_org[0:zrg_org-2]))
                ztime_org = n_elements( *buffer[bufnr1].ptr_time )
                zrg_new = (hbis-hvon) / hdelta + 1
                ranges_new = hvon + findgen(zrg_new)*hdelta
                ; ptr_free,ptr_var_new
                ptr_var_new=ptr_new(fltarr(zrg_new,ztime_org))
                create=1
                for iti=0L,ztime_org-1 do begin
                    ;(*ptr_var_new)[0,iti] = interpol(float((*buffer[bufnr1].ptr_var)[*,iti]),ranges_org,ranges_new,/quadratic)
                    (*ptr_var_new)[0,iti] = fueller(float((*buffer[bufnr1].ptr_var)[*,iti]),ranges_org,ranges_new,missing=-99999.,create=create)
                    create=0
                endfor
                ptr_free,buffer[bufnr1].ptr_var
                buffer[bufnr1].ptr_var = ptr_var_new
                ptr_free,buffer[bufnr1].ptr_range
                buffer[bufnr1].ptr_range = ptr_new(ranges_new)
                buffer[bufnr1].drg = hdelta
            endif else begin
               print,'usage: fillr <BufferNumber> <heivon> <heibis> <deltahei>'
               print,'The buffer <BufferNumber> must be filled by load-cmd before.'
               print,'The buffer <BufferNumber> s interpolated in range according to <heivon> <heibis> <deltahei>.'
            endelse
        end
        cmd eq 'thc' or cmd eq 'trc' or cmd eq 'tdc' or cmd eq 'otrc' or cmd eq 'othc': begin
            ; time range cross section
            last_draw_arg = arg
            if narg ge 2 then bufnr = fix(arg[1])-1
            if bufnr ge 0 && bufnr lt nbuffer && buffer[bufnr].name ne 'unknown' then begin
                if n_elements(*(buffer[bufnr].ptr_range)) gt 1 then begin
                    hei = *(buffer[bufnr].ptr_range)
                    ihr = [fstix(where(hei ge pp.hr[0])),lstix(where(hei le pp.hr[1]))]
                    buffer[bufnr].ihr = ihr
                    ptr_free,buffer[bufnr].ptr_hei & buffer[bufnr].ptr_hei = ptr_new(hei[ihr[0]:ihr[1]])
                    
                    hours = ( *(buffer[bufnr].ptr_time) - first_day_0000*36d2 + *(buffer[bufnr].ptr_microsec)*1d-6 )/3600d0
                    itr = [fstix(where(hours ge pp.tr[0])),lstix(where(hours le pp.tr[1]))]
                    print,strgg(n_elements(*(buffer[bufnr].ptr_time))) + ' steps in time, showing '+strgg(itr[0])+' '+strgg(itr[1])
                    if itr[1] le itr[0] or itr[0] lt 0 or itr[1] ge n_elements(hours)  then begin
                         itr[1]=n_elements(hours)-1 & itr[0]=0
                         pp.tr=hours[itr]
                         print, "setting tr to ", pp.tr
                    endif
                    buffer[bufnr].itr = itr
                    ptr_free,buffer[bufnr].ptr_hours & buffer[bufnr].ptr_hours = ptr_new(hours[itr[0]:itr[1]])
                   
                    if pp.valuetitle ne '' then begin
                        valuetitle = pp.valuetitle
                    endif else begin
                        valuetitle =  buffer[bufnr].name+' ' + (buffer[bufnr].db ? 'dB' : '') + string(buffer[bufnr].units)
                    endelse
                    
                    prof = (*(buffer[bufnr].ptr_var))[ihr[0]:ihr[1],itr[0]:itr[1]]
                    if buffer[bufnr].db then prof = db(prof)

                    good_times = (*(buffer[bufnr].ptr_tpow))[itr[0]:itr[1]] ge pp.min_txn_pow and sin(!pi/180.*(*(buffer[bufnr].ptr_elv))[itr[0]:itr[1]]) ge pp.only_vertically
                    zrg = n_elements(prof[*,0])
                    ptr_free,buffer[bufnr].ptr_prof 
                    ptr_prof = ptr_new( transpose(   prof +  replicate(1.,zrg) # ( (good_times ne 1) * 999999.)  ) )
                    buffer[bufnr].ptr_prof = ptr_prof
                    ; ptr_prof is the part or *buffer[bufnr].ptr_var selected by tr,hr. It contains the plotted values.
                    ; If buffer[bufnr].db==1 the values are logarithmised
                    if buffer[bufnr].yrange[0] eq buffer[bufnr].yrange[1] then begin
                        ; do auto range
                        arbuf = *ptr_prof
                        buffer[bufnr].yrange = autorange(arbuf,99.99,8.0)
                    endif
                    sxtf=!x.TICKFORMAT & !x.TICKFORMAT='LABEL_DATE'
                    sxtu=!X.TICKUNITS[0] & !X.TICKUNITS[0]=pp.xtu
                    dummy = LABEL_DATE(DATE_FORMAT='%h:%i')
                    dara_title =     + unixtime2bdate((*(buffer[bufnr].ptr_time))[itr[0]], nice=2,utc=1) $ 
                        +  ' - '     + unixtime2bdate((*(buffer[bufnr].ptr_time))[itr[1]], nice=2,utc=1)
                    ixtr=lindgen(itr[1]-itr[0]+1)+itr[0]
                    utime_itr=(*(buffer[bufnr].ptr_time))[ixtr]
                    microsec_itr=double((*(buffer[bufnr].ptr_microsec))[ixtr]) * 1d-6
                    jultime_right = unixtime2jul(utime_itr, microsec_itr + double((*(buffer[bufnr].ptr_ave))[ixtr])*0.5*pp.trc_smeargap)
                    jultime_left  = unixtime2jul(utime_itr, microsec_itr - double((*(buffer[bufnr].ptr_ave))[ixtr])*(1.0+0.5*pp.trc_smeargap))
                    posg=buffer[bufnr].posg & pemg = 1.-posg
                    elv_itr = posg * (*(buffer[bufnr].ptr_elv))[(ixtr-0L)>0L] + pemg * (*(buffer[bufnr].ptr_elv))[(ixtr-1L)>0L] 
                    otrc=0
                    RangeOrHei = min(sin(!pi/180.* elv_itr)) gt 0.98 ? pp.heitit : pp.rangetit
                    case cmd of
                        'thc':begin
                            rangescalingfactor_itr = sin(!pi/180.* elv_itr)
                            heitit = 'Height AGL ' + pp.tdunit
                        end
                        'othc':begin
                            rangescalingfactor_itr = sin(!pi/180.* elv_itr)
                            otrc=1
                        end
                        'tdc':begin
                            rangescalingfactor_itr = cos(!pi/180.* elv_itr)
                            heitit = 'Horizontal Distance ' + pp.tdunit
                        end
                        'trc':begin
                            rangescalingfactor_itr = 1.
                            heitit = RangeOrHei + ' ' + pp.tdunit
                        end
                        'otrc':begin
                            rangescalingfactor_itr = 1.
                            otrc=1
                        end
                        else:begin
                            rangescalingfactor_itr = 1.
                            heitit = RangeOrHei + ' ' + pp.tdunit
                        end
                    endcase
                    y_bot = hei[ihr[0]]/pp.td * rangescalingfactor_itr
                    y_top = hei[ihr[1]]/pp.td * rangescalingfactor_itr
                    if otrc eq 0 then begin
                        tit_filename = stregex(buffer[bufnr].filename,'[0-9_]+\.mmclx',/extract)
                        if pp.tit eq '' then begin
                            loca = buffer[bufnr].location eq 'Meteorologisches Observatorium Lindenberg' ? 'MOL' : buffer[bufnr].location
                            thctit = pp.ti+pp.b4tit+' '+pp.titsupplement+' '+tit_filename+' '+buffer[bufnr].long_name +'   '+dara_title+' '+loca
                        endif else thctit=pp.tit
                        profseq22image, *ptr_prof, jultime_left, jultime_right, y_bot, y_top, yrange=pp.heira/pp.td,buffer[bufnr].yrange, $
                            zcolor, pp.startcolor,pp.badcol,charsize=pp.charsize,charthick=pp.charthick,ticklen=pp.ticklen, $
                            ztitle=pp.ti+valuetitle,xtitle=pp.ti+'Time UTC', title=thctit,$
                            heitit=pp.ti+heitit,saturate=pp.saturate,nullcol=pp.nullcol,nulltol=pp.nulltol,prepend2heitit=pp.prepend2heitit
                    endif else begin
                        ztim=itr[1]-itr[0]+1L
                        zra=buffer[bufnr].yrange
                        for izora=0,zzora-1 do begin
                            !x=*(ssx[izora]) & !y=*(ssy[izora]) & !p=*(ssp[izora])
                            for itim=0L,ztim-1L do begin
                                if n_elements(y_bot) eq 1 then begin
                                    dy = (y_top - y_bot)/zrg
                                    yaxis = findgen(zrg)*dy+y_bot
                                endif else begin
                                    dy = (y_top[itim] - y_bot[itim])/zrg
                                    yaxis = findgen(zrg)*dy+y_bot[itim]
                                endelse
                                dyh = dy*0.5
                                avexx = unixtime2jul( (*(buffer[bufnr].ptr_ave))[ixtr[itim]] * pp.trc_smeargap ) - unixtime2jul(0d0)
                                timel=jultime_left[itim]-avexx & timer=jultime_right[itim]
                                for irg=0,zrg-1 do begin
                                    if is_within( (*ptr_prof)[itim, irg], buffer[bufnr].yrange[0], buffer[bufnr].yrange[1] ) then begin
                                        polyfill, [timel,timer,timer,timel] , yaxis[irg]+[-dyh,-dyh,dyh,dyh] , color=pp.otrc_color,noclip=0
                                    endif
                                endfor
                            endfor
                        endfor
                    endelse
                    !x.TICKFORMAT = sxtf & !X.TICKUNITS[0]=sxtu
                endif else print,'No data for plotting in buffer number' + arg[2]
            endif else begin
               print,'usage: thc <BufferNumber>'
               print,'The buffer <BufferNumber> must be filled by load-cmd before.'
            endelse
        end
        cmd eq 'sioux' or cmd eq 'osioux' or cmd eq 'osx': begin
            last_draw_arg = arg
            oplotsioux = cmd eq 'osioux' or cmd eq 'osx'
            if narg ge 3 then begin
                bufnr_u = fix(arg[1])-1
                bufnr_v = fix(arg[2])-1
                if n_elements(*(buffer[bufnr_u].ptr_time)) eq n_elements(*(buffer[bufnr_v].ptr_time)) && n_elements(*(buffer[bufnr_u].ptr_time)) ge 1 && max( *(buffer[bufnr_u].ptr_time) - *(buffer[bufnr_v].ptr_time) ) eq 0 then begin
                    ;hours = (*(buffer[bufnr_u].ptr_time) + *(buffer[bufnr_u].ptr_microsec)*1d-6)/3600d0 - first_day_0000
                    hours = (*(buffer[bufnr_u].ptr_time)-first_day_0000*3600L + *(buffer[bufnr_u].ptr_microsec)*1d-6)/36d2
                    dhours=hours[1]-hours[0]
                    itr = [fstix(where(hours ge pp.tr[0])),lstix(where(hours le pp.tr[1]))]
                    if itr[1] le itr[0] or itr[0] lt 0 or itr[1] ge n_elements(hours)  then begin
                        itr[1]=n_elements(hours)-1 & itr[0]=0
                        pp.tr=hours[itr]
                        print, "setting tr to ", pp.tr
                    endif
                    ixtr=lindgen(itr[1]-itr[0]+1)+itr[0]
                    ;buffer[bufnr_u].itr = itr & ptr_free,buffer[bufnr_u].ptr_hours & buffer[bufnr_u].ptr_hours = ptr_new(hours[itr[0]:itr[1]])
                    ;buffer[bufnr_v].itr = itr & ptr_free,buffer[bufnr_v].ptr_hours & buffer[bufnr_v].ptr_hours = ptr_new(hours[itr[0]:itr[1]])
                    ztime_itr = itr[1]-itr[0]+1L
                    utime_itr=(*(buffer[bufnr].ptr_time))[ixtr]
                    microsec_itr=double((*(buffer[bufnr].ptr_microsec))[ixtr]) * 1d-6
                    jultime_m  = unixtime2jul(utime_itr, microsec_itr - 0.5*double((*(buffer[bufnr].ptr_ave))[ixtr]))

                    if pp.valuetitle ne '' then begin
                        valuetitle = pp.valuetitle
                    endif else begin
                        valuetitle =  buffer[bufnr].name+' ' + (buffer[bufnr].db ? 'dB' : '') + string(buffer[bufnr].units)
                    endelse
                    
                    prof_u = transpose((*(buffer[bufnr_u].ptr_var))[ihr[0]:ihr[1],itr[0]:itr[1]])
                    prof_v = transpose((*(buffer[bufnr_v].ptr_var))[ihr[0]:ihr[1],itr[0]:itr[1]])
                    if oplotsioux then begin
                        heights = hei[ihr[0]:ihr[1]]/pp.td * rangescalingfactor_itr
                    endif else begin
                        heights = (*(buffer[bufnr].ptr_range))[ihr[0]:ihr[1]]/pp.td
                    endelse
                    dhei=heights[1]-heights[0]
                    zrg = n_elements(prof_u[0,*])
                    if northangle ne 0.0 then begin
                        northangle_pi = northangle * !pi / 180.
                        prof_u_ =  prof_u*cos(northangle_pi) + prof_v*sin(northangle_pi)
                        prof_v_ =  prof_v*cos(northangle_pi) - prof_u*sin(northangle_pi)
                        prof_u = prof_u_ & prof_v=prof_v_
                    endif
                    plotsioux,prof_u,prof_v,jultime_m,heights,missing=pp.sioux_maxvel,maxmag=pp.sioux_maxvel,oplo=oplotsioux,box=pp.sioux_overlap*[dhours,dhei],color=pp.sioux_color,$
                         thick=pp.thick,charsize=pp.charsize,arrowsize=pp.sioux_arrowsize,sym=pp.sioux_sym
                endif else begin
                   print,'Number of profiles in the u and v buffer does not match or is too small or time stamps dont match',n_elements(*(buffer[bufnr_u].ptr_time)), n_elements(*(buffer[bufnr_v].ptr_time))
                endelse
            endif else begin
                print,'Pls specify buffer numbers for for U an V'
            endelse
        end
        cmd eq 'ppi' or cmd eq 'oppi': begin
            last_draw_arg = arg
            if cmd eq 'oppi' then oplo_polarimage=1 else oplo_polarimage=0
            ;FnPpi = 'ppi_'+buffer[bufnr].name
            FnPpi = '' ; do not write a png file by default. In case of oppi the ppi file has to be created afterwards by the png cmd
            nthppi=-1
            if narg ge 2 then bufnr = fix(arg[1])-1
            if narg ge 3 then begin
                if stregex(arg[2],'[+-.0-9]+') eq 0 then nthppi=long(arg[2]) else FnPpi=arg[2]
            endif
            if narg ge 4 then FnPpi=arg[3]
            if bufnr ge 0 && bufnr lt nbuffer && buffer[bufnr].name ne 'unknown' then begin
                ;hours = (*(buffer[bufnr].ptr_time) + *(buffer[bufnr].ptr_microsec)*1d-6)/3600d0 - first_day_0000
                hours = (*(buffer[bufnr].ptr_time)-first_day_0000*3600L + *(buffer[bufnr].ptr_microsec)*1d-6)/36d2
                itr = [fstix(where(hours ge pp.tr[0])),lstix(where(hours le pp.tr[1]))]
                if itr[1] le itr[0] or itr[0] lt 0 or itr[1] ge n_elements(hours)  then begin
                     itr[1]=n_elements(hours)-1 & itr[0]=0
                     pp.tr=hours[itr]
                     print, "setting tr to ", pp.tr
                endif
                buffer[bufnr].itr = itr
                ptr_free,buffer[bufnr].ptr_hours & buffer[bufnr].ptr_hours = ptr_new(hours[itr[0]:itr[1]])
                    
                ztime_itr = itr[1]-itr[0]+1L
                ixtr=lindgen(ztime_itr)+itr[0]
                utime_itr=(*(buffer[bufnr].ptr_time))[ixtr]
                microsec_itr=double((*(buffer[bufnr].ptr_microsec))[ixtr]) * 1d-6
                time_itr = double(utime_itr) + microsec_itr ; doppelt? =buffer[bufnr].ptr_hours , genauso bei rhi
                dtime_itr = time_itr[1:ztime_itr-1] - time_itr[0:ztime_itr-2] 
                ; jultime_right = unixtime2jul(utime_itr, microsec_itr)
                ; jultime_left  = unixtime2jul(utime_itr, microsec_itr - double((*(buffer[bufnr].ptr_ave))[ixtr]))
                posg=buffer[bufnr].posg & pemg=1.-posg
                elv_itr = posg * (*(buffer[bufnr].ptr_elv))[ixtr] + pemg * (*(buffer[bufnr].ptr_elv))[(ixtr-1L)>0L] 
                azi_itr = ave2ang( (*(buffer[bufnr].ptr_azi))[ixtr] , (*(buffer[bufnr].ptr_azi))[(ixtr-1L)>0L] , posg) + northangle
                azi_itr = (azi_itr+360.) mod 360
                ; range of angle in which measuenents of each profile where made:
                azi_intermed=ave2ang(azi_itr[0:ztime_itr-2L],azi_itr[1:ztime_itr-1L])
                azi_left=[azi_intermed,azi_itr[ztime_itr-1L]]
                azi_right=[azi_itr[0],azi_intermed]
                for iaz=0L,n_elements(azi_right)-1 do begin
                    azi_right[iaz] = cmod(azi_right[iaz],360.,azi_left[iaz])
                endfor
                dazi_itr = cmod(azi_itr[1:ztime_itr-1] - azi_itr[0:ztime_itr-2],360.)
                azivel_itr = dazi_itr / dtime_itr
                aziaccel_itr = azivel_itr[1:ztime_itr-2]-azivel_itr[0:ztime_itr-3]
                aziavel_itr = (azivel_itr[1:ztime_itr-2]+azivel_itr[0:ztime_itr-3])*0.5
                if pp.findscan then begin
                    nppi = get_ixaixb(round(abs(aziaccel_itr) lt 0.25 or abs(aziavel_itr) gt pp.ScanVelThres),ixppia,ixppib,nixtrue)
                    ixppib += 2
                    iixx=where((ixppib-ixppia+1) gt pp.ScanExpectN,niixx)
                    if niixx gt 0 then begin
                        ixppia=ixppia[iixx]
                        ixppib=ixppib[iixx]
                    endif
                    nppi=niixx
                    print,'Number of Scans detected from scan velocity, Number of accepted scans: ',nppi,niixx
                    print,'Number of measurements in each scan: ',ixppib-ixppia+1
                    if nthppi ge 0 then begin
                        i0ppi = nthppi < (nppi-1) & i1ppi=i0ppi+1
                    endif else begin
                        i0ppi=0l & i1ppi=nppi
                    endelse
                endif else begin
                    ixppia=[0] & ixppib=[ztime_itr-1L] & i0ppi=0 & i1ppi=1
                endelse

                if pp.valuetitle ne '' then begin
                    valuetitle = pp.valuetitle
                endif else begin
                    valuetitle =  buffer[bufnr].name+' ' + (buffer[bufnr].db ? 'dB' : '') + string(buffer[bufnr].units)
                endelse
                    
                prof = transpose((*(buffer[bufnr].ptr_var))[ihr[0]:ihr[1],itr[0]:itr[1]])
                if buffer[bufnr].db then prof = db(prof)

                zrg = n_elements(prof[0,*])
                nmovie=i1ppi-i0ppi+1
                for ippi=i0ppi, i1ppi-1 do begin
                    nixppi = ixppib[ippi]-ixppia[ippi]+1+1     ; one more to get all filled by colors
                    ixppi = ((ixppia[ippi]-1) > 0 + lindgen(nixppi) ) < (ztime_itr-1)
                    absmedcoselv=abs(cos(!pi/180.*median(elv_itr[ixppi])))
                    radices = *buffer[bufnr].ptr_hei * absmedcoselv
                    tit_filename = stregex(buffer[bufnr].filename,'[0-9_]+\.mmclx',/extract)
                    ixmitte=(ixppia[ippi]+ixppib[ippi])/2
                    dati_title =  unixtime2bdate((*(buffer[bufnr].ptr_time))[ixppi[nixppi-1]], nice=2,utc=1)
                    ;tit='Azimuth Scan, Elv=' + strgg(elv_itr[ixmitte],'(i5)') + '  '
                    if pp.tit eq '' then begin
                        tit = pp.ti+pp.b4tit+' '+pp.titsupplement+' '+tit_filename+' '+buffer[bufnr].long_name+'  '+dati_title+' '+buffer[bufnr].location + '   Elv=' + strgg(elv_itr[ixmitte],'(i5)')
                    endif else tit = pp.tit
                    drh = buffer[bufnr].drg/2 * absmedcoselv
                    maxradi=radices[zrg-1]
                    tdx7=1./pp.tdx
                    polar2image,prof[ixppi,*],(radices-drh),(radices+drh),azi_left[ixppi],azi_right[ixppi],$
                        xrange=[-1.,1.]*(maxradi+drh),scalefacx=tdx7,yrange=[-1.,1.]*(maxradi+drh),scalefacy=tdx7, zrange=buffer[bufnr].yrange, $
                        zcolor, pp.startcolor,pp.badcol,charsize=pp.charsize,charthick=pp.charthick,ticklen=pp.ticklen, $
                        ztit=valuetitle , xtit='Horizontal Range '+pp.tdxunit,ytit='Horizontal Range '+pp.tdxunit,tit=tit,$
                        saturate=pp.saturate,dfimax=pp.dfimax,prepend2heitit=pp.prepend2heitit,$
                        nullcol=pp.nullcol,nulltol=pp.nulltol,ringr=pp.ringr,ringname=pp.ringname,oplo=oplo_polarimage
                    case !d.name of
                        'X':if nmovie gt 1 then wait,0.2
                        'Z': begin
                           if FnPpi ne '' then begin
                               if i0ppi eq i1ppi-1 then fnpng = FnPpi else fnpng = FnPpi +'.'+ string(ippi,format='(i3.3)')+'.png'
                               ; write_png, fnpng, TVRD(true=1) ; larger pngs, allows different colt in one plot
                               write_png, fnpng, TVRD() , ct_red, ct_green, ct_blue ; small and efficient pngs
                           endif
                        end
                        else:
                    endcase
                endfor
                ; append some black pictures at the end of a movie
                if !D.name eq 'Z' and FnPpi ne '' then begin
                    erase
                    for ippi=i1ppi, i1ppi+ round(nmovie*0.04-1.5) do begin
                        fnpng = FnPpi +'.'+ string(ippi,format='(i3.3)')+'.png'
                        ; write_png, fnpng, TVRD(true=1) ; larger pngs, allows different colt in one plot
                        write_png, fnpng, TVRD() , ct_red, ct_green, ct_blue ; small and efficient pngs
                    endfor
                endif
            endif
        end
        cmd eq 'rhi' or cmd eq 'orhi': begin
            last_draw_arg = arg
            if cmd eq 'orhi' then oplo_polarimage=1 else oplo_polarimage=0
            ;FnRhi = 'rhi_'+buffer[bufnr].name
            FnRhi = '' ; do not write a png file by default. In case of oppi the ppi file has to be created afterwards by the png cmd
            nthrhi=-1
            if narg ge 2 then bufnr = fix(arg[1])-1
            if narg ge 3 then begin
                if stregex(arg[2],'[+-.0-9]+') eq 0 then nthrhi=long(arg[2]) else FnRhi=arg[2]
            endif
            if narg ge 4 then FnRhi=arg[3]
            if bufnr ge 0 && bufnr lt nbuffer && buffer[bufnr].name ne 'unknown' then begin
                ;hours = (*(buffer[bufnr].ptr_time) + *(buffer[bufnr].ptr_microsec)*1d-6)/3600d0 - first_day_0000
                hours = (*(buffer[bufnr].ptr_time)-first_day_0000*3600L + *(buffer[bufnr].ptr_microsec)*1d-6)/36d2
                itr = [fstix(where(hours ge pp.tr[0])),lstix(where(hours le pp.tr[1]))]
                if itr[1] le itr[0] or itr[0] lt 0 or itr[1] ge n_elements(hours)  then begin
                     itr[1]=n_elements(hours)-1 & itr[0]=0
                     pp.tr=hours[itr]
                     print, "setting tr to ", pp.tr
                endif
                buffer[bufnr].itr = itr
                ptr_free,buffer[bufnr].ptr_hours & buffer[bufnr].ptr_hours = ptr_new(hours[itr[0]:itr[1]])
                    
                ztime_itr = itr[1]-itr[0]+1L
                ixtr=lindgen(ztime_itr)+itr[0]
                utime_itr=(*(buffer[bufnr].ptr_time))[ixtr]
                microsec_itr=double((*(buffer[bufnr].ptr_microsec))[ixtr]) * 1d-6
                time_itr = double(utime_itr) + microsec_itr 
                dtime_itr = time_itr[1:ztime_itr-1] - time_itr[0:ztime_itr-2] 
                jultime_right = unixtime2jul(utime_itr, microsec_itr)
                jultime_left  = unixtime2jul(utime_itr, microsec_itr - double((*(buffer[bufnr].ptr_ave))[ixtr]))
                posg=buffer[bufnr].posg & pemg=1.-posg
                elv_itr = posg*(*(buffer[bufnr].ptr_elv))[ixtr] + pemg*(*(buffer[bufnr].ptr_elv))[(ixtr-1L)>0] 
                if pp.rhi_mirror then elv_itr = 180.0-elv_itr
                azi_itr = ave2ang( (*(buffer[bufnr].ptr_azi))[ixtr] , (*(buffer[bufnr].ptr_azi))[(ixtr-1L)>0] , posg) + northangle ; Correction due to Romans delay
                if pp.rhi_mirror eq 0 then azi_itr = (azi_itr+360.) mod 360 else azi_itr = (azi_itr+180.) mod 360
                ;range of angle in which measuenents of each profile where made:
                elv_intermed = 0.5 * (elv_itr[0:ztime_itr-2L]+elv_itr[1:ztime_itr-1L])
                elv_left=[elv_intermed,elv_itr[ztime_itr-1L]]
                elv_right=[elv_itr[0],elv_intermed]
                delv_itr = cmod(elv_itr[1:ztime_itr-1] - elv_itr[0:ztime_itr-2],360.)
                elvvel_itr = delv_itr / dtime_itr
                elvaccel_itr = elvvel_itr[1:ztime_itr-2]-elvvel_itr[0:ztime_itr-3]
                elvavel_itr = (elvvel_itr[1:ztime_itr-2]+elvvel_itr[0:ztime_itr-3])*0.5
                if pp.findscan then begin
                    nrhi = get_ixaixb(round(abs(elvaccel_itr) lt 0.25 or abs(elvavel_itr) gt pp.ScanVelThres),ixrhia,ixrhib,nixtrue)
                    ixrhib += 2
                    iixx=where((ixrhib-ixrhia+1) ge pp.ScanExpectN,niixx)
                    if niixx gt 0 then begin
                        ixrhia=ixrhia[iixx]
                        ixrhib=ixrhib[iixx]
                    endif
                    nrhi=niixx
                    print,'Number of Scans detected from scan velocity, Number of accepted scans: ',nrhi,niixx
                    print,'Number of measurements in each scan: ',ixrhib-ixrhia+1
                    if nthrhi ge 0 then begin
                        i0rhi = nthrhi < (nrhi-1) & i1rhi=i0rhi+1
                    endif else begin
                        i0rhi=0l & i1rhi=nrhi
                    endelse
                endif else begin
                    ixrhia=[0] & ixrhib=[ztime_itr-1L] & i0rhi=0 & i1rhi=1
                endelse
                
                if pp.valuetitle ne '' then begin
                    valuetitle = pp.valuetitle
                endif else begin
                    valuetitle =  buffer[bufnr].name+' ' + (buffer[bufnr].db ? 'dB' : '') + string(buffer[bufnr].units)
                endelse
                    
                drh=buffer[bufnr].drg/2
                zrg = n_elements((*buffer[bufnr].ptr_prof)[0,*])
                nmovie=i1rhi-i0rhi+1
                for irhi=i0rhi, i1rhi-1 do begin
                    nixrhi = ixrhib[irhi]-ixrhia[irhi]
                    ixrhi = ((ixrhia[irhi]-0) > 0 + lindgen(nixrhi) ) < (ztime_itr-1)
                    radices = *buffer[bufnr].ptr_hei
                    maxradi=radices[zrg-1]
                    tit_filename = stregex(buffer[bufnr].filename,'[0-9_]+\.mmclx',/extract)
                    ixmitte=(ixrhia[irhi]+ixrhib[irhi])/2
                    dati_title =  unixtime2bdate((*(buffer[bufnr].ptr_time))[ixrhi[nixrhi-1]], nice=2,utc=1)
                    if pp.tit eq '' then begin
                        tit = pp.ti + pp.b4tit + '<- Azi=' + strgg((azi_itr[ixmitte]+180) mod 360,'(i5)') + ' ' + pp.titsupplement +' RHI Scan ' +metarstr+' '+dati_title+ ' ' + buffer[bufnr].location + '   Azi=' + strgg(azi_itr[ixmitte],'(i5)') + ' ->'
                        ;tit = pp.ti + pp.b4tit + tit_filename + ' '+ buffer[bufnr].long_name +"  "+dati_title+ ' ' + buffer[bufnr].location
                    endif else tit=pp.tit
                    if pp.heira[1] gt pp.heira[0] then heira=pp.heira else begin
                        heira=[0,pp.hr[1]+drh]
                    endelse
                    td7=1./pp.td & tdx7=1./pp.tdx
                    if pp.rhixra[1] gt pp.rhixra[0] then rhixrange=pp.rhixra else rhixrange=[-1.,1.]*(maxradi+drh)
                    polar2image,(*buffer[bufnr].ptr_prof)[ixrhi,*],(radices-drh),(radices+drh),90.-elv_left[ixrhi],90.-elv_right[ixrhi],$
                        xrange=rhixrange, scalefacx=tdx7,  yrange=heira, scalefacy=td7,  zrange=buffer[bufnr].yrange, $
                        zcolor, pp.startcolor,pp.badcol,charsize=pp.charsize,charthick=pp.charthick,ticklen=pp.ticklen, $
                        ztit=valuetitle , xtit='Horizontal Range '+pp.tdxunit,ytit='Height '+pp.tdunit,tit=tit,$
                        saturate=pp.saturate,dfimax=pp.dfimax,prepend2heitit=pp.prepend2heitit,$
                        nullcol=pp.nullcol,nulltol=pp.nulltol,ringr=pp.ringr,ringname=pp.ringname,oplo=oplo_polarimage
                    case !d.name of
                        'X':if nmovie gt 1 then wait,0.2
                        'Z': begin
                           if FnRhi ne '' then begin
                               if i0rhi eq i1rhi-1 then fnpng = FnRhi else fnpng = FnRhi +'.'+ string(irhi,format='(i3.3)')+'.png'
                               ; write_png, fnpng, TVRD(true=1) ; larger pngs, allows different colt in one plot
                               write_png, fnpng, TVRD() , ct_red, ct_green, ct_blue ; small and efficient pngs
                           endif
                        end
                        else:
                    endcase
                endfor
                ; append some black pictures at the end of a movie
                if !D.name eq 'Z' and FnRhi ne '' then begin
                    erase
                    for irhi=i1rhi, i1rhi+ round(nmovie*0.04-1.5) do begin
                        fnpng = FnRhi +'.'+ string(irhi,format='(i3.3)')+'.png'
                        ; write_png, fnpng, TVRD(true=1) ; larger pngs, allows different colt in one plot
                        write_png, fnpng, TVRD() , ct_red, ct_green, ct_blue ; small and efficient pngs
                    endfor
                endif
            endif
        end
        cmd eq 'aec' or cmd eq 'azi-elv-cross-section': begin 
            last_draw_arg = arg
            if narg ge 2 then bufnr = fix(arg[1])-1
            if narg ge 3 then rg_hei0 = float(arg[2]) else rg_hei0=500.
            if narg ge 4 then rg_hei1 = float(arg[3]) else rg_hei1=rg_hei0
            if narg ge 5 then rg_hei_type = arg[4] else rg_hei_type='range'

            if bufnr ge 0 && bufnr lt nbuffer && buffer[bufnr].name ne 'unknown' then begin
                ;hours = (*(buffer[bufnr].ptr_time) + *(buffer[bufnr].ptr_microsec)*1d-6)/3600d0 - first_day_0000
                hours = (*(buffer[bufnr].ptr_time)-first_day_0000*3600L + *(buffer[bufnr].ptr_microsec)*1d-6)/36d2
                itr = [fstix(where(hours ge pp.tr[0])),lstix(where(hours le pp.tr[1]))]
                if itr[1] le itr[0] or itr[0] lt 0 or itr[1] ge n_elements(hours)  then begin
                     itr[1]=n_elements(hours)-1 & itr[0]=0
                     pp.tr=hours[itr]
                     print, "setting tr to ", pp.tr
                endif
                buffer[bufnr].itr = itr
                ptr_free,buffer[bufnr].ptr_hours & buffer[bufnr].ptr_hours = ptr_new(hours[itr[0]:itr[1]])
                    
                ztime_itr = itr[1]-itr[0]+1L
                ixtr=lindgen(ztime_itr)+itr[0]
                utime_itr=(*(buffer[bufnr].ptr_time))[ixtr]
                microsec_itr=double((*(buffer[bufnr].ptr_microsec))[ixtr]) * 1d-6
                lastutime_itr = (*(buffer[bufnr].ptr_time))[(ixtr-1L)>0]
                lastmicrosec_itr=double((*(buffer[bufnr].ptr_microsec))[(ixtr-1L)>0]) * 1d-6
                AvgUtime=utime_itr-lastutime_itr
                AvgMicrosec=microsec_itr-lastmicrosec_itr
                AvgFlt=double(AvgUtime)+AvgMicrosec
                UtimeIntermed_itr=lastutime_itr+long(AvgFlt/2d0)
                MicrosecIntermed_itr=round(   ( lastmicrosec_itr + AvgFlt/2d0 mod 1d0 )  * 1d6 )

                posg=buffer[bufnr].posg & pemg=1.-posg
                if pp.aecsol then begin
                    spawnstr = pp.solcmd 
                    for i=0,ztime_itr-1 do spawnstr = spawnstr + ' ' + string(UtimeIntermed_itr[i]) + ' ' + string(MicrosecIntermed_itr[i])
                    spawn,spawnstr,spawnout
                    azielvarr=fltarr(2,ztime_itr)
                    reads,spawnout,azielvarr
                    elv_itr = posg*(*(buffer[bufnr].ptr_elv))[ixtr] + pemg*(*(buffer[bufnr].ptr_elv))[(ixtr-1L)>0]
                    elv_itr = elv_itr - (azielvarr[0,*])
                    azi_itr = ave2ang( (*(buffer[bufnr].ptr_azi))[ixtr] , (*(buffer[bufnr].ptr_azi))[(ixtr-1L)>0] , posg) + northangle
                    azi_itr = azi_itr - azielvarr[1,*]
                    for i=0,ztime_itr-1 do azi_itr = cmod(azi_itr,360.0,0.0)
                endif else begin
                    elv_itr = posg*(*(buffer[bufnr].ptr_elv))[ixtr] + pemg*(*(buffer[bufnr].ptr_elv))[(ixtr-1L)>0]
                    azi_itr = ave2ang( (*(buffer[bufnr].ptr_azi))[ixtr] , (*(buffer[bufnr].ptr_azi))[(ixtr-1L)>0] , posg) + northangle
                    azi_itr = (azi_itr+360.) mod 360
                endelse
                ; +++ range of angle in which measuenents of each profile where made: +++
                
                ;azi_intermed=ave2ang(azi_itr[0:ztime_itr-2L],azi_itr[1:ztime_itr-1L])
                ;azi_left=[azi_intermed,azi_itr[ztime_itr-1L]]-0.5*pp.beamwidth_azi
                ;azi_right=[azi_itr[0],azi_intermed]+0.5*pp.beamwidth_azi
                ;elv_intermed = 0.5 * (elv_itr[0:ztime_itr-2L]+elv_itr[1:ztime_itr-1L])
                ;elv_left=[elv_intermed,elv_itr[ztime_itr-1L]]-0.5*pp.beamwidth_elv
                ;elv_right=[elv_itr[0],elv_intermed]+0.5*pp.beamwidth_elv

                azi_intermed = azi_itr[0:ztime_itr-1L]
                azi_left=azi_intermed-0.5*pp.beamwidth_azi
                azi_right=azi_intermed+0.5*pp.beamwidth_azi
                elv_intermed = elv_itr[0:ztime_itr-1L]
                elv_left=elv_intermed-0.5*pp.beamwidth_elv
                elv_right=elv_intermed+0.5*pp.beamwidth_elv
                
                zrg = n_elements((*buffer[bufnr].ptr_prof)[0,*])

                sprof=fltarr(ztime_itr)
                ihr=buffer[bufnr].ihr
                rg0 = ixclosest( rg_hei0 , (*buffer[bufnr].ptr_range)[ihr[0]:ihr[1]] )
                rg1 = ixclosest( rg_hei1 , (*buffer[bufnr].ptr_range)[ihr[0]:ihr[1]] )
                aecval=buffer[bufnr].db ? linear(*buffer[bufnr].ptr_prof) : *buffer[bufnr].ptr_prof
                aec_total=pp.aec_total
                if pp.aec_total eq 2 then begin
                    if rg1-rg0 ne 1 then begin 
                        aec_total=0 
                        print,'aec_total=2 works only if two ranges are selected. using aec_total=0 (mean)'
                    endif else begin
                        bufnr_modrg = 8
                        deltar=buffer[bufnr].drg
                        print,'writing modolo ranges to buffer number 9'
                        buffer[bufnr_modrg] = buffer[bufnr]
                        buffer[bufnr_modrg].ptr_var=ptr_new(*buffer[bufnr].ptr_var)
                        buffer[bufnr_modrg].ptr_prof=ptr_new(*buffer[bufnr].ptr_prof)
                        buffer[bufnr_modrg].long_name='Modolo Range of Point Targets'
                        buffer[bufnr_modrg].name='Modolo_Range'
                        buffer[bufnr_modrg].units='m'
                        buffer[bufnr_modrg].YRANGE=[0., buffer[bufnr].drg]
                        buffer[bufnr_modrg].db=0
                        for irg=0,zrg-2 do begin
                            p1_=(*buffer[bufnr].ptr_var)[irg,*]
                            p2_=(*buffer[bufnr].ptr_var)[irg+1,*]
                            ixnan1_=where(finite(p1_) ne 1 or p1_ lt 0,nixnan1_)
                            if nixnan1_ gt 0 then p1_[ixnan1_]=0.0
                            ixnan2_=where(finite(p2_) ne 1 or p2_ lt 0,nixnan2_)
                            if nixnan2_ gt 0 then p2_[ixnan2_]=0.0
                            modrg = deltar * (sqrt(p1_*p2_)-p2_)/(p1_-p2_)
                            (*buffer[bufnr_modrg].ptr_var)[irg,*]=modrg
                        endfor
                    endelse
                endif
                refl_resp=fltarr(ztime_itr)
                for iti=0L,ztime_itr-1L do begin
                    case aec_total of
                        1:begin
                            sprof[iti] =  total( aecval[iti,rg0:rg1], /nan )
                        end
                        2:begin
                            mod_range = (*buffer[bufnr_modrg].ptr_var)[rg0+buffer[bufnr].ihr[0],iti+buffer[bufnr].itr[0]]
                            refl_resp[iti]=(deltar^2-2*deltar*mod_range+2*mod_range^2) / deltar^2
                            sprof[iti] = total( aecval[iti,rg0:rg1], /nan ) / refl_resp[iti]
                        end
                        else:begin
                            sprof[iti] = rg1-rg0 gt 0 ? mean( aecval[iti,rg0:rg1],/nan) : aecval[iti,rg0]
                        endcase
                    endcase
                endfor
                if aec_total eq 2 then begin
                    print,' Average range respons',avg(refl_resp,weight=sprof)
                endif
                if narg ge 4 then begin
                    print,' Plotting range gates '+strgg((*buffer[bufnr].ptr_range)[rg0])+ ' to '+strgg((*buffer[bufnr].ptr_range)[rg1])+$
                         ' ('+strgg(rg0)+' to '+strgg(rg1)+')'
                    if hintaec then print,' Method for accounting for multible ranges aec_total=',pp.aec_total
                endif else begin
                    print,' Plotting range gate '+strgg((*buffer[bufnr].ptr_range)[rg0])+$
                        ' ('+strgg(rg0)+')'
                endelse
                if pp.valuetitle ne '' then begin
                    valuetitle = pp.valuetitle
                endif else begin
                    valuetitle =  buffer[bufnr].name+' ' + (buffer[bufnr].db ? 'dB' : '') + string(buffer[bufnr].units)
                endelse

                if hintaec then print,' Hint: maybe beam withs for plotting have to be forced by set beamwidth_azi and set beamwidth_elv'
                mosaik,buffer[bufnr].db ? db(sprof) : sprof, [[azi_left],[azi_right],[azi_right],[azi_left]], [[elv_left],[elv_left],[elv_right],[elv_right]],$
                        xrange=pp.azirange,$
                        yrange=pp.elvrange,$
                        zrange=buffer[bufnr].yrange, $
                        zcolor, pp.startcolor,pp.badcol,charsize=pp.charsize,charthick=pp.charthick,ticklen=pp.ticklen, $
                        ztit=valuetitle , xtit='Azimuth [deg]', ytit='Elevation [deg]',saturate=pp.saturate

                ; moment estimation
                
                if finite(pp.azirange[0] and pp.azirange[1]) then inazirange= azi_left ge pp.azirange[0] and azi_right le pp.azirange[1] else inazirange=replicate(1,ztime_itr)
                if finite(pp.elvrange[0] and pp.elvrange[1]) then inelvrange= elv_left ge pp.elvrange[0] and elv_right le pp.elvrange[1] else inelvrange=replicate(1,ztime_itr)
                if buffer[bufnr].db and pp.aecrange gt 0 then begin ; moment estimation is normally only useful if prefered plotting of values are is db 
                    peakmax=max(sprof*inazirange*inelvrange,/nan) 
                    aecmedian=median(sprof)
                    ixpeak=where(sprof ge peakmax*pp.aecrange and inazirange and inelvrange ,nixpeak)
                    print,' max=',buffer[bufnr].db ? db(peakmax) : peakmax,' median=',buffer[bufnr].db ? db(aecmedian) : aecmedian,' SNR=',buffer[bufnr].db ? db(peakmax/aecmedian) : peakmax/aecmedian
                    if nixpeak gt 3 then begin
                        ; azimom=calc_moms(sprof[ixpeak]*abs(azi_right[ixpeak]-azi_left[ixpeak])*abs(elv_right[ixpeak]-elv_left[ixpeak]),azi_intermed[ixpeak],1.1)
                        ; elvmom=calc_moms(sprof[ixpeak]*abs(azi_right[ixpeak]-azi_left[ixpeak])*abs(elv_right[ixpeak]-elv_left[ixpeak]),elv_intermed[ixpeak],1.1)
                        azimom=calc_moms(sprof[ixpeak]-aecmedian,azi_intermed[ixpeak],1.0)
                        elvmom=calc_moms(sprof[ixpeak]-aecmedian,elv_intermed[ixpeak],1.0)
                        azimom[0]=azimom[0]/(2.*!pi*azimom[2]*elvmom[2])
                        elvmom[0]=elvmom[0]/(2.*!pi*azimom[2]*elvmom[2])
                        if hintaec then print,' Values greater than max*aecrange are used for moment estimation. aecrange='+strgg(pp.aecrange)
                        print,' Azi power=',buffer[bufnr].db ? db(azimom[0]/aecmedian) : azimom[0]/aecmedian,' azi=',-azimom[1],' sigma=',azimom[2],' 3dB-width=',azimom[2]*2.355 ; 2.355=2*sqrt(2*ln(2))
                        print,' Elv power=',buffer[bufnr].db ? db(elvmom[0]/aecmedian) : elvmom[0]/aecmedian,' elv=',-elvmom[1],' sigma=',elvmom[2],' 3dB-width=',elvmom[2]*2.355
                    endif
                endif
                hintaec=0
            endif
        end
        cmd eq 'trm': begin
            sel_region=select_region_by_mouse(dir=1,firstday=first_day_0000)
            itr = [fstix(where(jultime_right ge sel_region.x[0])),lstix(where(jultime_right le sel_region.x[1]))]
            pp.tr = hours[itr]
            ;pp.tr = jul2unixtime(sel_region.x)/3600d0 
            print,pp.tr[0]," bis ", pp.tr[1]
        end
        cmd eq 'export': begin
            if narg ge 2 then exfilename = arg[1] else exfilename="ViewNcdfExport.sav"
            exfilename = arg[1]
            if bufnr ge 0 && bufnr lt nbuffer && buffer[bufnr].name ne 'unknown' then begin
                if n_elements(*(buffer[bufnr].ptr_range)) gt 1 then begin
                    nhei = ihr[1]-ihr[0]+1
                    nutime = itr[1] - itr[0] +1
                    heis = (*(buffer[bufnr].ptr_range))[ihr[0]:ihr[1]]
                    utimes = (*(buffer[bufnr].ptr_time))[itr[0]:itr[1]]
                    filename = buffer[bufnr].filename
                    dataname = buffer[bufnr].name
                    aveprof=fltarr(nhei) & ednutime=1.0/float(nutime) & for ihei=0,nhei-1 do aveprof[ihei]=total(prof[ihei,*])*ednutime
                    save,filename=exfilename,nhei,nutime,heis,utimes,filename,dataname,prof,aveprof
                endif else print,'No data for exporting in buffer number' + arg[2]
            endif else begin
               print,'The buffer must be plotted by thc before'
            endelse
        end
        cmd eq 'noisecom' or cmd eq 'nc': begin
            if narg eq 7  then begin
                itr_on=[long(arg[1]),long(arg[2])]   ; & print,'itr_on ',itr_on
                itr_off=[long(arg[3]),long(arg[4])]  ; & print,'itr_off ',itr_off
                itr_attn=[long(arg[5]),long(arg[6])] ; & print,'itr_attn ',itr_attn
            endif else begin
                itr_on=[1L,0L] & itr_off=[1L,0L] & itr_attn=[1L,0L]
            endelse
            gvh_filename=fn4ld[0]+".sav"
            print,"HSDco or HSDcx of NoiseCom measurment should be plotted by thc before"
            nfft=buffer[bufnr].nfft
            if narg ne 7  then print,"Pls. select the time range by mouse in which the noise source was switched on!"
            ok_on = average_profiles(first_day_0000,buffer[bufnr],jultime_right,HSD_on,heis,itr_on)
            if narg ne 7  then print,"Pls. select the time range by mouse in which the noise source was switched off!"
            ok_off = average_profiles(first_day_0000,buffer[bufnr],jultime_right,HSD_off,heis,itr_off)
            ; die naechsten beiden Zeilen auskommentieren wenn nc files verwendet werden, die mit einer spc2nc version von vor Juni 2017 generiert wurden (siehe unten)
            HSD_on = HSD_on / nfft    ; in the ncdf files the HSD-power is stored. Here HSD-level is needed 
            HSD_off = HSD_off / nfft
            medHSD_on=median(HSD_on)
            medHSD_off=median(HSD_off)
            if narg ne 7  then print,"Pls. select the time range by mouse in which the IF attn was set to 30 dB and noise source was off!"
            ok_attn = average_profiles(first_day_0000,buffer[bufnr],jultime_right,HSD_adc,heis,itr_attn)
            if ok_attn then begin
                ; die naechste Zeile auskommentieren wenn nc files verwendet werden, die mit einer spc2nc version von vor Juni 2017 generiert wurden 
                HSD_adc=HSD_adc/nfft ; in the ncdf files the HSD-power is stored. Here HSD-level is needed
                padc=median(HSD_adc) 
            endif else padc=pp.padc
            ;nf=pp.pnoisecom/((medHSD_on-padc)/(medHSD_off-padc)-1.)
            nf = pp.pnoisecom * (medHSD_off-padc)/(medHSD_on-medHSD_off)
            ;nf=pp.pnoisecom*(medHSD_off)/(medHSD_on-medHSD_off)
            ; in der naechsten Zeile war ein minus statt /. Nach der Korrektur muss das calida-file neu generiert werden
            GainVsRange=(HSD_on-HSD_off)/medHSD_off
            GainVsRange = 0.001 > GainVsRange/median(GainVsRange)   ; soll nicht mehr als 30 dB korrigieren   
            PowCalCo=median((*(buffer[bufnr].ptr_cpw1))[itr_off[0]:itr_off[1]])
            PowCalCx=median((*(buffer[bufnr].ptr_cpw2))[itr_off[0]:itr_off[1]])
            PowNoiCo=median((*(buffer[bufnr].ptr_npw1))[itr_off[0]:itr_off[1]])
            PowNoiCx=median((*(buffer[bufnr].ptr_npw2))[itr_off[0]:itr_off[1]])
            print, gvh_filename + ' Noise Figure = '+strgg(db(nf))+' dB  AdcNoisePow = '+strgg(db(padc*nfft))+' dB Pow14_Off='+strgg(db(medHSD_off*nfft))+ $
                ' dB  PowNoiCo='+strgg(db(PowNoiCo))+' dB  PowNoiCx='+strgg(db(PowNoiCx))+' dB PowCalCo='+strgg(db(PowCalCo))+' dB PowCalCx='+strgg(db(PowCalCx))+' dB' 
            plot,heis,GainVsRange,xra=[0,6000],xtit='Range [m]',ytit='Linear Attenuation (1 <=> no Attenuation)',title='Attenuation in the Lowest Range Gates',charsize=pp.charsize,ticklen=pp.ticklen
            save,filename=gvh_filename,heis,GainVsRange,nf,PowCalCo,PowCalCx,PowNoiCo,PowNoiCx,medHSD_on,medHSD_off,padc,nfft
            if narg ne 7  then begin
                print,'For recalculation without mouse pls type: nc '+strgg(itr_on[0])+' '+strgg(itr_on[1])+' '+strgg(itr_off[0])+' '+strgg(itr_off[1])+' '+strgg(itr_attn[0])+' '+strgg(itr_attn[1])+' '
            endif
        end
        cmd eq 'kuhne' or cmd eq 'kuehne': begin
            if narg eq 5  then begin
                itr_on=[long(arg[1]),long(arg[2])]   ; & print,'itr_on ',itr_on
                itr_off=[long(arg[3]),long(arg[4])]  ; & print,'itr_off ',itr_off
            endif else begin
                itr_on=[1L,0L] 
                itr_off=[1L,0L] 
            endelse
            gvh_filename=fn4ld[0]+".sav"
            print,"SNRg or SNRcx of Kuhne measurment should be plotted by trc before"
            nfft=buffer[bufnr].nfft
            if narg ne 5 then print,"Pls. select the time range by mouse in which the signal source was switched on!"
            ok_on = average_profiles(first_day_0000,buffer[bufnr],jultime_right,SNR_on,heis,itr_on)
            if narg ne 5 then print,"Pls. select the time range by mouse in which the signal source was switched off!"
            ok_off = average_profiles(first_day_0000,buffer[bufnr],jultime_right,SNR_off,heis,itr_off)
            medSNR_on = median(SNR_on)
            PowCalCo=median((*(buffer[bufnr].ptr_cpw1))[itr_off[0]:itr_off[1]])
            PowCalCx=median((*(buffer[bufnr].ptr_cpw2))[itr_off[0]:itr_off[1]])
            PowNoiCo=median((*(buffer[bufnr].ptr_npw1))[itr_off[0]:itr_off[1]])
            PowNoiCx=median((*(buffer[bufnr].ptr_npw2))[itr_off[0]:itr_off[1]])
            is_cx = strpos(strlowcase(gvh_filename),'cx') ge 0
            PowNoi = is_cx ? PowNoiCx : PowNoiCo
            SNRkuhne = medSNR_on 
            GainVsRange = SNR_on/medSNR_on
            GainVsRange = 0.000001 > GainVsRange   ; soll nicht mehr als 60 dB korrigieren   
            print, gvh_filename + ' SNR of the signal from the Kuehe generator = '+strgg(db(SNRkuhne))+' dB' 
            plot,heis,db(1/GainVsRange*heis^2),xra=[0,1500],yra=[50,100],psym=10,ytit='Relative Sensitivity dB (lower:better)',xtit='Range m',tit='Gain vs Range from Kuhne Measurement '+gvh_filename,charsize=pp.charsize
            ;plot,heis,GainVsRange,xra=[0,6000],xtit='Range [m]',ytit='Linear Attenuation (1 <=> no Attenuation)',title='Attenuation in the Lowest Range Gates',charsize=pp.charsize,ticklen=pp.ticklen
            save,filename=gvh_filename,heis,GainVsRange,SNR_on,SNRkuhne,PowCalCo,PowCalCx,PowNoiCo,PowNoiCx,nfft
            if narg ne 7  then begin
                print,'For recalculation without mouse pls type: kuhne '+strgg(itr_on[0])+' '+strgg(itr_on[1])+' '+strgg(itr_off[0])+' '+strgg(itr_off[1])
            endif
        end
        cmd eq 'smooth': begin
            if narg ge 2 then bufnr = fix(arg[1])-1
            if bufnr ge 0 && bufnr lt nbuffer && narg eq 4 then begin
                nsmooth_t = fix(arg[2])
                nsmooth_r = fix(arg[3])
                *buffer[bufnr].ptr_var = smooth(*buffer[bufnr].ptr_var,[nsmooth_r,nsmooth_t],/nan)
            endif else begin
                print,'usage: smooth <BufferNumber> <nbox_time> <nbox_range>'
            endelse
        end
        cmd eq 'histo': begin
            if narg eq 1 then begin
                bufnrs = [bufnr] & nbufnrs=1
            endif else begin
                bufnrs = (fix(arg[1:narg-1])-1)
                nbufnrs=narg-1
            endelse
            for i=0,nbufnrs-1 do begin
                bufnr=bufnrs[i]
                if bufnr lt 0 || bufnr ge nbuffer || n_elements(*buffer[bufnr].ptr_prof) le 1 then begin
                    print,'No data is in buffer number'+string(bufnr+1)
                    goto,emptybuffer
                endif
            endfor
            if pp.valuetitle ne '' then begin
                valuetitle = pp.valuetitle
            endif else begin
                valuetitle =  buffer[bufnr].name+' ' + (buffer[bufnr].db ? 'dB' : '') + string(buffer[bufnr].units)
            endelse

            bufnr=bufnrs[0]
            dzra = buffer[bufnr].yrange[1] - buffer[bufnr].yrange[0]
            x = findgen(pp.nbin[0])/float(pp.nbin[0])*dzra+buffer[bufnr].yrange[0]
            histo=histogram(*buffer[bufnr].ptr_prof,min=(buffer[bufnr].yrange)[0],max=(buffer[bufnr].yrange)[1],nbins=pp.nbin[0])
            plot,x,histo,xrange=buffer[bufnr].yrange,xst=1,ytit='Distribution Frequency / ' + string(dzra/pp.nbin[0],format='(g7.1)'),$
                    xtit=valuetitle,ylog=1,yrange=[1,max(histo)],/nodata,charsize=pp.charsize,ticklen=pp.ticklen
            for i=0,nbufnrs-1 do begin
                bufnr=bufnrs[i]
                if n_elements(*buffer[bufnr].ptr_prof) gt 1 then begin
                    histo=histogram(*buffer[bufnr].ptr_prof,min=x[0],max=x[pp.nbin[0]-1],nbins=pp.nbin[0])
                    oplot,x,histo,color=i+1
                endif else print,'No data in the buffer.'
            endfor
            emptybuffer:
        end
        (cmd eq 'scatter' or cmd eq 'sc') and narg eq 3: begin
            last_draw_arg = arg 
            bufnr1 = fix(arg[1])-1
            bufnr2 = fix(arg[2])-1
            if bufnr1 ge 0 && bufnr1 lt nbuffer && n_elements(*buffer[bufnr1].ptr_prof) gt 1 $
            && bufnr2 ge 0 && bufnr2 lt nbuffer && n_elements(*buffer[bufnr2].ptr_prof) gt 1 then begin
                ; time (dwell matchnig)
                if pp.maxtdsyn gt 0 then maxtdsyn=pp.maxtdsyn else begin
                      maxtdsyn = ((*(buffer[bufnr1].ptr_hours))[1]-(*(buffer[bufnr1].ptr_hours))[0]) $
                    > ( (*(buffer[bufnr2].ptr_hours))[1]-(*(buffer[bufnr2].ptr_hours))[0])
                endelse
                hours1 = *(buffer[bufnr1].ptr_hours)
                hours2 = *(buffer[bufnr2].ptr_hours)
                ntr = n_elements(hours1)
                nmatcheddwells=0L
                ixmatched1=lonarr(ntr)
                ixmatched2=lonarr(ntr)
                for iti=0L, ntr-1L do begin
                    tdsyn = min(abs(hours1[iti]-hours2),ixsysn)
                    if tdsyn le maxtdsyn*36d2 then begin
                        ixmatched1[nmatcheddwells]=iti
                        ixmatched2[nmatcheddwells]=ixsysn
                        nmatcheddwells++
                    endif
                endfor
                if nmatcheddwells gt 0 then begin
                    ; range matching yet only a pp.scatter_rg_shift can be set by the user
                    matchzrg=zrg-abs(pp.scatter_rg_shift)
                    if matchzrg gt 0 then begin
                        ix0machedrg1 = - (pp.scatter_rg_shift < 0)
                        ix0machedrg2 = + (pp.scatter_rg_shift > 0)
                        scatterx=reform((*(buffer[bufnr1].ptr_prof))[ixmatched1[0:nmatcheddwells-1],ix0machedrg1:ix0machedrg1+matchzrg-1])
                        scattery=reform((*(buffer[bufnr2].ptr_prof))[ixmatched2[0:nmatcheddwells-1],ix0machedrg2:ix0machedrg2+matchzrg-1])
                        scatter_gd=where(scatterx ge (buffer[bufnr1].yrange)[0] and scatterx le (buffer[bufnr1].yrange)[1] and $
                                         scattery ge (buffer[bufnr2].yrange)[0] and scattery le (buffer[bufnr2].yrange)[1],scatter_ngd)
                        if scatter_ngd ge 1 then begin
                        valuetitle1 =  buffer[bufnr1].name+' ' + (buffer[bufnr1].db ? 'dB' : '') + string(buffer[bufnr1].units)
                        valuetitle2 =  buffer[bufnr2].name+' ' + (buffer[bufnr2].db ? 'dB' : '') + string(buffer[bufnr2].units)

                            case 1 of
                                strupcase(pp.scatter_type) eq 'DOTS': begin
                                    scatterx=scatterx[scatter_gd]
                                    scattery=scattery[scatter_gd]
                                    plot,scatterx,$
                                        scattery,$
                                        xra=buffer[bufnr1].yrange,yra=buffer[bufnr2].yrange,psym=3,xst=1,yst=1,$
                                        xtit=buffer[bufnr1].filename+' '+valuetitle1,$
                                        ytit=buffer[bufnr2].filename+' '+valuetitle2,charsize=pp.charsize,ticklen=pp.ticklen
                                    if buffer[bufnr1].yrange[0] eq buffer[bufnr2].yrange[0] and buffer[bufnr1].yrange[1] eq buffer[bufnr2].yrange[1] then begin
                                        oplot,buffer[bufnr1].yrange,buffer[bufnr2].yrange,color=12
                                        ; oplot,scatterx,scattery,psym=3
                                        scatterdiff0 = median(scattery-scatterx)
                                        if pp.scattertol lt 0 then scattertol=((buffer[bufnr1].yrange)[1]-(buffer[bufnr1].yrange)[0])/2. else scattertol=pp.scattertol
                                        scatterclose = where(abs(scattery-scatterx-scatterdiff0) le scattertol,scatternclose)
                                        if (scatternclose gt 1) then begin
                                            scatterdif=total(scattery[scatterclose]-scatterx[scatterclose])/float(scatternclose)
                                            scattervarvar= sqrt(total((scattery[scatterclose]-scatterx[scatterclose]-scatterdif)^2)/float(scatternclose))
                                            oplot,buffer[bufnr1].yrange,buffer[bufnr2].yrange+scatterdif,color=2
                                            scatter_result = 'average difference: '+strgg(scatterdif)+'  variance: '+strgg(scattervarvar)
                                            xyouts,0.49,0.93,scatter_result,/noclip,alignment=0.5,/normal,chars=pp.charsize
                                            print,scatter_result
                                        endif
                                    endif
                                end
                                strupcase(pp.scatter_type) eq 'HISTO' or strupcase(pp.scatter_type) eq 'HISTODB' : begin
                                    binwidth1=(buffer[bufnr1].yrange[1]-buffer[bufnr1].yrange[0])/pp.nbin[0]
                                    binwidth2=(buffer[bufnr2].yrange[1]-buffer[bufnr2].yrange[0])/pp.nbin[1]
                                    histo2d = HIST_2D(scatterx, scattery, bin1=binwidth1, bin2=binwidth2,$
                                        min1=buffer[bufnr1].yrange[0], min2=buffer[bufnr2].yrange[0],$
                                        max1=buffer[bufnr1].yrange[1]+binwidth1*0.5, max2=buffer[bufnr2].yrange[1]+binwidth2*0.5)
                                    ;dzra = buffer[bufnr].yrange[1] - buffer[bufnr].yrange[0]
                                    if strupcase(pp.scatter_type) eq 'HISTODB' then begin
                                        histo2d = db(histo2d)
                                        nhistodb=' dB(one)'
                                    endif else begin
                                        nhistodb=''
                                    endelse
                                    ixgd=where(histo2d gt -9000) & nmax_2dhisto = max(histo2d[ixgd],min=nmin_2dhisto)
                                    histo2dzrange=[nmin_2dhisto,nmax_2dhisto]
                                    mimage,histo2d,buffer[bufnr1].yrange,buffer[bufnr2].yrange,histo2dzrange,$
                                        zcolor, pp.startcolor,pp.badcol,charsize=pp.charsize,charthick=pp.charthick,ticklen=pp.ticklen, $
                                        ztit='Number of Data Pairs per Bin'+nhistodb ,$
                                        xtit=buffer[bufnr1].filename+' '+valuetitle1,$
                                        ytit=buffer[bufnr2].filename+' '+valuetitle2 ,saturate=pp.saturate
                                end
                                else:begin
                                    print,'scatter_type should be DOTS, HISTO or HISTODB'
                                end
                            endcase
                        endif else print,'no valid points for making a scatter plot available. Pls check the ranges of the data in both buffers by trc'
                    endif else print,'no matching rangegates'
                endif else print,'no dwells with matching time'
            endif else begin
               print,'usage: scatter <BufferNumber4xAxis>  <BufferNumber4yAxis>'
               print,'The buffers <BufferNumber4*> must be filled by load-cmd before.'
            endelse
        end
        cmd eq 'calc': begin
            bufnrSRC=-1
            bufnrTRG=-1
            right2eq = 0
            for i=1, narg-1 do begin
                if arg[i] eq '=' then right2eq=1
                bufnr = fix((stregex(arg[i],'^#([1-9])$',/subexp,/extract))[1])-1
                bufnr_str = string(bufnr,format='(I1.1)')
                if bufnr_str ne '*' && bufnr le 8 then begin
                    arg[i] = '*buffer['+bufnr_str+'].ptr_var'
                    if right2eq eq 0 then bufnrTRG=bufnr
                    if right2eq and bufnrSRC lt 0 then bufnrSRC=bufnr
                endif
                ; Damit wir auch mit R#<bufnr> = range des Buffers <bufnr> rechnen können:
                bufnr = fix((stregex(arg[i],'^R#([1-9])$',/subexp,/extract))[1])-1
                bufnr_str = string(bufnr,format='(I1.1)')
                if right2eq eq 1 && bufnr_str ne '*' && bufnr le 8 then begin
                    arg[i] = '(*buffer['+bufnr_str+'].ptr_range # replicate(1.0,n_elements(*buffer['+bufnr_str+'].ptr_time)))'
                endif
            endfor
            if bufnrSRC ge 0 and bufnrTRG ge 0 then buffer[bufnrTRG] = buffer[bufnrSRC]
            buffer[bufnrTRG].ptr_var = ptr_new(*buffer[bufnrSRC].ptr_var)
            ;buffer[bufnrTRG].ptr_prof = ptr_new(*buffer[bufnrSRC].ptr_prof)
            buffer[bufnrTRG].ptr_time = ptr_new(*buffer[bufnrSRC].ptr_time)
            ;buffer[bufnrTRG].ptr_hours = ptr_new(*buffer[bufnrSRC].ptr_hours)
            buffer[bufnrTRG].ptr_range = ptr_new(*buffer[bufnrSRC].ptr_range)
            ;buffer[bufnrTRG].ptr_hei = ptr_new(*buffer[bufnrSRC].ptr_hei)
            buffer[bufnrTRG].ptr_tpow = ptr_new(*buffer[bufnrSRC].ptr_tpow)
            execstr=strjoin(arg[1:narg-1],' ')
            print,execstr
            returnvalue = execute(execstr)
        end
        cmd eq 'pointtarget': begin
            if narg ge 2 then begin 
                bufnr = fix(arg[1])-1
                bufnr_modrg = 8
                deltar=buffer[bufnr].drg
                print,'writing modolo ranges to buffer number 9'
                print,'Calculating the modolo range of point targets (PT) for the reflectivity in the Buffer ',strgg(bufnr),','
                print,'and the reflectivity which the PT would have if it would be in the center of a gate.' 
                print,'The PTs range modolo ',strgg(deltar),' is stored in buffer ',strgg(bufnr_modrg)
                print,'For closer gates this calculation rather should be applied to SNRg than to Zg because the R^2 weighting of Zg distorts the weighting of adjacent gates, because the signal seen in both gate comes from the same range.'
                buffer[bufnr_modrg] = buffer[bufnr]
                buffer[bufnr_modrg].ptr_var=ptr_new(*buffer[bufnr].ptr_var)
                buffer[bufnr_modrg].ptr_prof=ptr_new(*buffer[bufnr].ptr_prof)
                buffer[bufnr_modrg].long_name='Modolo Range of Point Targets'
                buffer[bufnr_modrg].name='Modolo_Range'
                buffer[bufnr_modrg].units='m'
                buffer[bufnr_modrg].YRANGE=[0., buffer[bufnr].drg]
                buffer[bufnr_modrg].db=0
                ztim=n_elements((*buffer[bufnr].ptr_var)[0,*])
                zrang=n_elements((*buffer[bufnr].ptr_var)[*,0])
                for irg=0,zrang-2 do begin
                    p1_=(*buffer[bufnr].ptr_var)[irg,*]
                    p2_=(*buffer[bufnr].ptr_var)[irg+1,*]
                    ixnan1_=where(finite(p1_) ne 1 or p1_ lt 0,nixnan1_)
                    if nixnan1_ gt 0 then p1_[ixnan1_]=0.0
                    ixnan2_=where(finite(p2_) ne 1 or p2_ lt 0,nixnan2_)
                    if nixnan2_ gt 0 then p2_[ixnan2_]=0.0
                    modrg = deltar * (sqrt(p1_*p2_)-p2_)/(p1_-p2_)
                    (*buffer[bufnr_modrg].ptr_var)[irg,*]=modrg
                    ; if irg ge 135 and irg lt 140 then stop
                endfor
                for iti=0L,ztim-1L do begin
                    mod_range = (*buffer[bufnr_modrg].ptr_var)[*,iti] ; (*buffer[bufnr_modrg].ptr_var)[irg,iti]
                    refl_range_response = (deltar^2-2*deltar*mod_range+2*mod_range^2) / deltar^2
                    (*buffer[bufnr].ptr_var)[*,iti] = (*buffer[bufnr].ptr_var)[*,iti] / refl_range_response
                    ; stop
                endfor
            endif else print,'a buffer with reflectivity or SNR should be given.'
        end
        cmd eq 'concatrangesections' or cmd eq 'crs' or cmd eq 'concat': begin
            bufnr1 = fix(arg[1])-1
            bufnr2 = fix(arg[2])-1
            if bufnr1 ge 0 && bufnr1 lt nbuffer && n_elements(*buffer[bufnr1].ptr_prof) gt 1 $
            && bufnr2 ge 0 && bufnr2 lt nbuffer && n_elements(*buffer[bufnr2].ptr_prof) gt 1 then begin
               ; Buffer 2 is concatnated to Buffer 1
                    zrg_buf1=n_elements(*buffer[bufnr1].ptr_range)
                    zrg_buf2=n_elements(*buffer[bufnr2].ptr_range)
                    ztime_buf1=n_elements(*buffer[bufnr1].ptr_time)
                    ztime_buf2=n_elements(*buffer[bufnr2].ptr_time)
                    if ztime_buf1 eq ztime_buf2 then begin
                        zrg_new=zrg_buf1+zrg_buf2
                        varx_old = (*buffer[bufnr1].ptr_var)[0:zrg_buf1-1,*]  ; limited to new zrg if zrg of next current is smaller than zrg of the last one
                        *buffer[bufnr1].ptr_var = fltarr(zrg_new, ztime_buf1)
                        (*buffer[bufnr1].ptr_var)[0:zrg_buf1-1,0:ztime_buf1-1] = varx_old
                        (*buffer[bufnr1].ptr_var)[zrg_buf1:zrg_new-1,0:ztime_buf1-1] = (*buffer[bufnr2].ptr_var)[0:zrg_buf2-1,*]  ; the current data is limited in range if it has more ranges than the last file
                        *buffer[bufnr1].ptr_range = [*buffer[bufnr1].ptr_range,*buffer[bufnr2].ptr_range]
                    endif else begin
                        print,'concatrangesections can only concatenate buffers with identical time intervals',zrg_old,zrg
                    endelse
            endif else begin
               print,'usage: concat <Buffer 1>  <Buffer 2> ; Buffer 2 is concatnated to Buffer 1'
               print,'The buffers <BufferNumber4*> must be filled by load-cmd before.'
            endelse
        end
        cmd eq 'sequence' or cmd eq 'zr': begin
            last_draw_arg = arg
            arg[0]='&'
            IxPlt = where(arg eq '&' or arg eq '|', zPltO) ; plots and oplots
            dummy = where(arg eq '&', zPlt) ; only plots that need a new frame
            multi_save=!p.multi
            erase
            iPlt=0
            for iPltO=0,zPltO-1 do begin
                ; Default Values for the plotting parameters:
                kpzr = { $
                    ra:[0.0,-1.0],$
                    db:0,$
                    ti:'',$
                    os:0.0,$
                    tr:[0d0,-1d0],$
                    st:'',$
                    co:!p.color $
                }
                medianoverallrg = 0
                ; Find out what to plot:
                plt_item = arg[IxPlt[iPltO] + 1]

                ; search for h<bufnr>.<rg> plot range gate <rg> of buffer <bufnr>
                greped = stregex(plt_item,'^h([1-9])\.([0-9]*)$',/subexp,/extract,/fold)
                if greped[0] ne '' then begin 
                   rg=long(greped[2])
                   bufnr=long(greped[1])-1L
                endif else rg=-1

                greped = stregex(plt_item,'^m([1-9])$',/subexp,/extract,/fold)
                if greped[0] ne '' then begin
                    rg=0
                    medianoverallrg = 1
                    bufnr=long(greped[1])-1L
                endif


                ; search for srvi.<tag> where <tag> is a tagname defined in read_srvinfo.pro
                greped = stregex(plt_item,'^srvi([1-9])\.(.*)$',/subexp,/extract,/fold)
                if greped[0] ne '' then begin 
                   bufnr=long(greped[1])-1L
                   srvi=greped[2]
                endif else srvi=''

                ; search for l<log_item_nr> where <log_item_nr> is the number of the log parameter
                ; loaded by grep_log before
                if ( n_elements(log_params) gt 0 ) then begin
                    LogItemNr = (stregex(plt_item,'^l([0-9]*)$',/subexp,/extract,/fold))[1]
                    if (LogItemNr ne '') then begin
                        ZrDataIx = long(LogItemNr)
                    endif else begin
                        ZrDataIx = (where(log_params eq plt_item))[0]
                    endelse
                endif else ZrDataIx=-1

                ; check if a variable generated by an IDL cmd typed by the user on the VIEWNCDF > prompt
                nelmi=0
                if rg lt 0 and srvi eq '' and ZrDataIx lt 0 and medianoverallrg eq 0 then begin
                    dummi = execute( 'nelmi=n_elements('+plt_item+')' )
                endif else nelmi=0

                ZrIsThere = 0
                case 1 of
                    rg ge 0 and medianoverallrg eq 0: begin
                        if n_elements(*buffer[bufnr].ptr_prof) gt 1 then begin
                            ZrData = (*buffer[bufnr].ptr_prof)[*,rg]
                            ZrTime = *buffer[bufnr].ptr_hours
                            zti = n_elements(ZrTime)
                            ZrTrange = [ZrTime[0],ZrTime[zti-1]]
                            if pp.valuetitle ne '' then begin
                                kpzrVtit = pp.valuetitle
                            endif else begin
                                kpzrVtit =  buffer[bufnr].name+' ' + (buffer[bufnr].db ? 'dB' : '') + string(buffer[bufnr].units)
                            endelse
                            kpzr.ti = kpzrVtit + ' ' + string((*buffer[bufnr].ptr_hei)[rg]/pp.td,format='(f6.2)') + ' '+pp.tdunit
                            kpzr.ra = buffer[bufnr].yrange
                            ZrIsThere = 1
                        endif
                    end
                    rg eq 0 and medianoverallrg eq 1: begin
                        if n_elements(*buffer[bufnr].ptr_prof) gt 1 then begin
                            ZrTime = *buffer[bufnr].ptr_hours
                            zti = n_elements(ZrTime)
                            ZrTrange = [ZrTime[0],ZrTime[zti-1]]
                            ZrData = (*buffer[bufnr].ptr_prof)[*,0]
                            
                            for iti=0,zti-1 do begin
                                ix4med = where((*buffer[bufnr].ptr_prof)[iti,*] ge (buffer[bufnr].yrange)[0] and (*buffer[bufnr].ptr_prof)[iti,*] le (buffer[bufnr].yrange)[1],nix4med)
                                if nix4med ge 1 then ZrData[iti] = median((*buffer[bufnr].ptr_prof)[iti,ix4med]) else ZrData[iti] = !values.f_nan
                            endfor
                            if pp.valuetitle ne '' then begin
                                kpzrVtit = pp.valuetitle
                            endif else begin
                                kpzrVtit =  buffer[bufnr].name+' ' + (buffer[bufnr].db ? 'dB' : '') + string(buffer[bufnr].units)
                            endelse
                            kpzr.ti = kpzrVtit + ' Median over all Ranges' 
                            kpzr.ra = buffer[bufnr].yrange
                            ZrIsThere = 1
                        endif
                    end
                    srvi ne '': begin
                        filenamezr=buffer[bufnr].filename
                        gzipped = strpos(filenamezr,'.gz') eq strlen(filenamezr)-3
                        if gzipped then begin
                            spawn,'echo $$',pid
                            fn4ldx='/tmp/viewncdf_unzipped.'+pid[0]+'.nc'
                            spawn,'cp '+filenamezr+'  '+ fn4ldx+'.gz'
                            spawn,'gunzip -f '+fn4ldx+'.gz'
                        endif else fn4ldx=filenamezr
                        ncdfid = NCDF_OPEN(fn4ldx,/NOWRITE)
                        ; Test if varname is a thc variable
                        ncdfnvars=(ncdf_inquire(ncdfid)).NVARS
                        ncdfvarnames=strarr(ncdfnvars)
                        for i=0,ncdfnvars-1 do begin 
                            ncdfvarnames[i] = (ncdf_varinq(ncdfid,i)).name
                        endfor
                        ncdfixv = where(ncdfvarnames eq varname,ncdfnixv)
                        if ncdfnixv eq 1 then begin
                            NCDF_VARGET, ncdfid, srvi, ZrData
                            if (size(ZrData))[0] eq 1 then begin
                                ZrTime = *buffer[bufnr].ptr_hours
                                zti = n_elements(ZrTime)
                                ZrTrange = [ZrTime[0],ZrTime[zti-1]]
                                kpzr.ti = srvi
                                kpzr.ra = [min(ZrData,max=sdmax),sdmax]
                                ZrIsThere = 1
                            endif else print, 'The variable you loaded from the NetCDF file cannot be plotted as a sequence as it has '+strgg((size(ZrData))[0])+' dimensions'
                        endif else begin
                            print,'Requested NetCDF variable ' + varname + ' is not in the file ' + fn4ld[ifile]
                            for i=0,ncdfnvars-1 do begin
                                if (ncdf_varinq(ncdfid,i)).NDIMS eq 2 && (ncdf_varinq(ncdfid,i)).NATTS ge 4 then begin
                                    NCDF_ATTGET, ncdfid, i,'long_name', long_namex
                                    print,form='(a12,": ",a)',(ncdf_varinq(ncdfid,i)).name,string(long_namex)
                                endif
                            endfor
                        endelse
                        NCDF_CLOSE, ncdfid
                    end
                    ZrDataIx ge 0: begin
                        if ( n_elements(log_params) gt 0 ) then begin
                            if (LogItemNr ne '') then begin
                                ZrDataIx = long(LogItemNr)
                            endif else begin
                                ZrDataIx = (where(log_params eq plt_item))[0]
                            endelse
                            if (ZrDataIx ge 0) then begin
                                ZrData = log_data.(ZrDataIx+1)
                                ZrTime = log_time
                                ZrTrange = [log_time[0],log_time[log_n-1]]
                                kpzr.ti = log_params[ZrDataIx]
                                kpzr.ra = [0.,-1.]
                                ZrIsThere = 1
                            endif
                        endif  
                    end
                    nelmi eq n_elements(*buffer[bufnr].ptr_hours):begin
                        dummi = execute( 'ZrData = ' + plt_item  )
                        ZrTime = *buffer[bufnr].ptr_hours
                        zti = n_elements(ZrTime)
                        ZrTrange = [ZrTime[0],ZrTime[zti-1]]
                        kpzr.ra = [min(ZrData,max=sdmax),sdmax]
                        if pp.valuetitle eq '' then kpzr.ti = plt_item else kpzr.ti=pp.valuetitle
                        ZrIsThere = 1
                    end
                    else:print,'Unrecognized sequence plot item'
                endcase

                ; Overwrite the default plotting parameters kpzr by the settings supplied in the cmd line
                kpzr0 = IxPlt[iPltO] + 2          ; index at which the key word parameters in arg start
                if iPltO lt zPltO-1 then begin
                    kpzr1 = IxPlt[iPltO + 1]-1
                endif else begin
                    kpzr1 = narg -1
                endelse
                nkpzr = kpzr1 - kpzr0+1
                if nkpzr gt 0 then begin
                    argv2stru,arg[kpzr0:kpzr1],kpzr
                endif
                
                zrxtit='Time in Hours UTC'
                if kpzr.st ne '' and n_elements(hstamps) ne 0 then begin
                    zstamps = n_elements(hstamps)
                    ZrTimeOrg = ZrTime
                    nZrTimeOrg = n_elements(ZrTimeOrg)
                    dt=median(ZrTimeOrg[1:nZrTimeOrg-1]-ZrTimeOrg[0:nZrTimeOrg-2])
                    ZrTime[*] = !values.f_nan
                    if n_elements(buffer[bufnr]) ne 0 then posg=buffer[bufnr].posg else posg=0.2
                    for istamps=0,zstamps-1 do begin
                        ixstamps=where(ZrTimeOrg-dt*posg ge hstamps[istamps],nixstamps)
                        if nixstamps gt 0 then ZrTime[ixstamps]=vstamps[istamps] 
                    endfor
                    ZrTrange=[min(vstamps),max(vstamps)]
                    zrxtit=kpzr.st
                endif

                ; make the plot
                if ZrIsThere then begin
                    if iPlt eq 0 then begin
                        ; select the timerange in the first plot so that all plots will have the same time range
                        if kpzr.tr[0] lt kpzr.tr[1] then begin
                            ZrTrange4all = kpzr.tr
                        endif else begin
                            ZrTrange4all = ZrTrange
                        endelse
                    endif 
                    if kpzr.tr[0] lt kpzr.tr[1] then ZrTrangeX = kpzr.tr else ZrTrangeX = ZrTrange4all
                    if kpzr.db eq 1 then ZrData = db(ZrData)
                    ZrData += kpzr.os
                    if kpzr.os ne 0 then kpzr.ti = kpzr.ti + (kpzr.os lt 0 ? ' - ' : ' - ' ) + strgg(abs(kpzr.os))
                    if arg[IxPlt[iPltO]] eq '&' then begin
                        ; make a new frame
                        if iPlt eq 0 then !x.title=zrxtit
                        !p.multi=[++iPlt,1,zPlt]
                        if kpzr.ra[0] gt kpzr.ra[1] then begin
                            kpzr.ra = autorange(ZrData,99.9,8.) ; the range is chosen to cover 98 percent of the data 
                                                               ; and afterwards it is increased by 4 percent to each side.
                        endif
                        plot,ZrTime,ZrData,/nodata,yrange=kpzr.ra,ytit=kpzr.ti,xrange=ZrTrangeX,xst=1,yst=1,charsi=pp.charsize,ticklen=pp.ticklen
                        last_ra = kpzr.ra
                        !x.title=''
                    endif else kpzr.ra = last_ra
                    oplot,ZrTime,ZrData,color=kpzr.co,min=kpzr.ra[0],max=kpzr.ra[1],psym=pp.zrsym
                    ; oplot,ZrTime,ZrData,color=kpzr.co,psym=pp.zrsym
                endif
            endfor
            !p.multi=multi_save
        end
        cmd eq 'stamps' or cmd eq 'readstamps' or cmd eq 'read_from_write_with_timestamp':begin
            if narg ge 2 && findfile(arg[1]) ne '' then begin
                stamps = reada(arg[1],tstamps,t0stamps,jstamps)
                nstamps=n_elements(stamps[0,*])
                hstamps = reform(tstamps+stamps[1,*]*1d-9/36D2,nstamps)
                vstamps = reform(stamps[2,*],nstamps)
            endif else begin
                print,'The first arument must be a filename of a ascii file containing 3 columns in the format as produced by the command write_with_timestamp: epoch time, nanosec, some parameter'
            endelse
        end
        cmd eq 'grep_log' or cmd eq 'gl': begin
            nparam = (where(arg[1:narg-1] eq ':'))[0]
            if nparam gt 0 then begin
                log_params = arg[1:nparam]
                spawn,'grep_log '+tota(arg[1:narg-1]+' ')+'> /tmp/grep_log.tmp'
                log_data = read_ascii('/tmp/grep_log.tmp', TEMPLATE={ VERSION:1.0, DATASTART:0, $
                    DELIMITER:32b, MISSINGVALUE:9e29, COMMENTSYMBOL:'#', FIELDCOUNT:nparam+1,$
                    FIELDTYPES:[3,replicate(4,nparam)], FIELDNAMES:['time',log_params],$
                    FIELDLOCATIONS:replicate(-1,nparam+1), FIELDGROUPS:lindgen(nparam+1)})
                spawn,'rm /tmp/grep_log.tmp'
                if n_elements(first_day_0000) ne 1 then first_day_0000 = long(log_data.time[0]/(3600d0*24d0))*24d0
                log_time = log_data.time/36d2 - first_day_0000
                log_n = n_elements(log_time)
                ; log_data.data[(where(log_params eq param]))[0],*)
            endif else print,'Pls. use a detached colon to separate parameters from log file names'
        end
        cmd eq 'curmetar': begin
            spawn,'show_metar',metarstr
        end
        cmd eq 'postscript' or cmd eq 'ps' or cmd eq 'print': begin
            if narg eq 2 then psfile = arg[1] else psfile="viewncdf.ps"
            if (!d.name ne 'PS') then set_plot,'PS'
            device,/color,bits_per_pixel=8,filename=psfile ; ,yoffset= 27,xoffset=0.7
        end
        cmd eq 'png': begin
            if narg ge 2 then fnpng = arg[1] else begin
                fnpng =  fn4ld[0] + '.png'
            endelse
            case !d.name of
                'X':write_png, fnpng, TVRD(true=1)
                'Z': begin
                    ; write_png, fnpng, TVRD(true=1) ; larger pngs, allows different colt in one plot
                    write_png, fnpng, TVRD() , ct_red, ct_green, ct_blue ; small and efficient pngs
                end
                else:
            endcase
        end
        cmd eq 'close':begin
            device,/close
            if startup_device ne 'PS' then set_plot,'X'
        end
        cmd eq 'set': begin
            if narg ge 2 then set_tag_name = arg[1] else set_tag_name='HELP'
            if strupcase(set_tag_name) eq 'HELP' then begin
                pp_tags = tag_names(pp)
                pph_tags = tag_names(pph)
                for i=0,n_elements(pp_tags)-1 do begin
                    helptext_tag_number = (where(pph_tags eq pp_tags[i]))[0]
                    helptext = helptext_tag_number ge 0 ? pph.(helptext_tag_number) : ''
                    print_table,pp_tags[i]+':',helptext,tabw=20,linew=79
                endfor
            endif else begin
                set_tag_number = (where(strupcase(set_tag_name) eq tag_names(pp)))[0]
                if set_tag_number ge 0 then begin
                    if narg eq 2 then print,set_tag_name+' :',pp.(set_tag_number) else begin
                        for i=0,(narg-3) < (n_elements(pp.(set_tag_number))-1) do begin
                            if strupcase(arg[i+2]) ne 'SKIP' then begin
                                valstr=arg[i+2]
                                lenval = strlen(valstr)
                                colopos = strpos(valstr,':')
                                ; convert time strings of the form 06:45 to floatingpoint representation 6.75
                                if is_within((size(pp.(set_tag_number)[i]))[1],4,5) and is_within(colopos,1,lenval-2) then begin
                                    val_=float(strmid(valstr,0,colopos))+float(strmid(valstr,colopos+1))/60.0
                                endif else val_=valstr
                                pp.(set_tag_number)[i] = val_
                            endif
                        endfor
                    endelse
                endif else print,'unknown variable name ' + set_tag_name
            endelse
        end
        cmd eq 'bset': begin
            bufnrs=strsplit(arg[1],':',/extract)
            for ibuf=0, n_elements(bufnrs)-1 do begin
                bufnr = fix(bufnrs[ibuf])-1
                if bufnr ge 0 && bufnr lt nbuffer && buffer[bufnr].name ne 'unknown' then begin
                    if narg ge 3 then set_tag_name = arg[2] else set_tag_name='HELP'
                    if strupcase(set_tag_name) eq 'HELP' then begin
                        pp_tags = tag_names(buffer[bufnr])
                        pph_tags = tag_names(buffer_help)
                        for i=0,n_elements(pp_tags)-1 do begin
                            helptext_tag_number = (where(pph_tags eq pp_tags[i]))[0]
                            helptext = helptext_tag_number ge 0 ? buffer_help.(helptext_tag_number) : ''
                            print_table,pp_tags[i]+':',helptext,tabw=20,linew=79
                        endfor
                    endif else begin
                        set_tag_number = (where(strupcase(set_tag_name) eq tag_names(buffer[bufnr])))[0]
                        if set_tag_number ge 0 then begin
                            if narg eq 3 then print,set_tag_name+' :',buffer[bufnr].(set_tag_number) else begin
                                for i=0,(narg-4) < (n_elements(buffer[bufnr].(set_tag_number))-1) do begin
                                    if strupcase(arg[i+3]) ne 'SKIP' then begin
                                        newval=arg[i+3]
                                        regex = stregex(newval,"^\'(.*)\'",/extr,/subex)
                                        if regex[0] ne '' then newval=regex[1]
                                        buffer[bufnr].(set_tag_number)[i] = newval 
                                    endif
                                endfor
                            endelse
                        endif else print,'unknown variable name ' + set_tag_name
                    endelse
                endif else begin
                    print,'usage: bset <BufferNumber> <name> <value1> [<value2> ...]  '
                    print,'The buffer <BufferNumber> must be filled by load-cmd before.'
                endelse
            endfor
        end
        cmd eq 'info': begin
        end
        cmd eq 'stop': if lmgr(/vm) then goto,ende else stop
        cmd eq 'x' or cmd eq 'quit' or cmd eq 'exit': goto,ende
        else: begin
            setcmd = ''
            for i=0 , narg - 1 do setcmd = setcmd + arg[i] + ' '
            if lmgr(/vm) then print,'VM license can not execute '+setcmd $
            else dummi=execute( setcmd )
        end
    endcase
endwhile

ende:
if !d.name eq "X" then wdelete
exit,/no_confirm
end

