function calc_4moms,spc,xx,noise_snr
; calculate the three spectral moments from the selected spectral points spc which are at the given positions xx
    pwx = total(spc)
    if pwx gt 0.0 then begin
        vlx = total(spc*xx)/pwx
        vvx = total(spc*xx*xx)/pwx
        if n_elements(spc) gt 2 then begin
            rms = sqrt(vvx - vlx*vlx)
            skw = total(spc*(xx-vlx)^3)/(pwx*rms^3)
            ; if pwx/noise_snr gt 10. then stop
            ; pwx =      total(spc)
            ; vel =      total(spc*xx)/pwx
            ; rms = sqrt(total(spc*(xx-vlx)^2)/pwx)
            ; skw =      total(spc*(xx-vlx)^3)/(pwx*rms^3)
            return, [pwx/noise_snr, -vlx,rms,skw]
        endif else begin
            return, [pwx/noise_snr, -vlx, !values.f_nan,!values.f_nan] 
        endelse
    endif else return,[!values.f_nan,!values.f_nan,!values.f_nan,!values.f_nan]
end
