function calc_moms_rho,spc_co,rhospc,dpsspc,xx,ix4rho,noise4snr,dmpstru,SNRco
; calculate the three spectral moments from the selected spectral points spc_co which are at the given positions xx
    nspc = n_elements(spc_co)
    dmpst = dmpstru

    ; first three moments:
    if spc_co[0] lt 0.0 then spc_co[0]=0.                  ; wozu?
    if spc_co[nspc-1] lt 0.0 then spc_co[nspc-1]=0.0       ; wozu? 
    pwx = total(spc_co)
    SNRco = pwx/noise4snr
    dmpst.SNR = fix(1000.*alog10(SNRco))
    vlx = total(spc_co*xx)/pwx
    dmpst.VEL = - vlx
    vvx = total(spc_co*xx*xx)/pwx
    if nspc ge 2 then begin
        dmpst.RMS = sqrt(vvx - vlx*vlx)
    endif else begin 
        dmpst.RMS = 0.0
    endelse

    if ix4rho ge 0 then begin
        dmpst.SNM = fix(round( 10000.* rhospc[ix4rho] ))  ; RHO_ldr between ( 0. and 1.)*10000
        dmpst.LWC = fix(round( 1000.* dpsspc[ix4rho] ))     ; DPS_ldr in rad * 1000
    endif else begin
        dmpst.SNM = -9999
        dmpst.LWC = -9999
    endelse
    
    if nspc ge 3 then begin
        skew = - total(spc_co*(xx-vlx)^3)/(pwx*dmpst.RMS^3) 
        dmpst.RR = fix(round( 100.* skew ))
    endif else begin 
        dmpst.RR = -9999
    endelse
    
    return,dmpst
end
