pro dmp2arr_rho, p_npeaks, p_dmp_data, arr, zpeak, itime=itime
; unpacks the "dynamically packed multi peak" array of structs *p_dmp_data which comes from read1dmp_dwell 
; to the rectangular and therefore lager array 
;     arr[irg,ipeak,itime]. 
; Each element of this array is the structure momstru
;
    npeak_max=16b ; maximum number of peaks that may show up in the dmpformat. This parameter must be the same as in spcs2moms.
    zrg = n_elements(*p_npeaks)
    narr = n_elements(arr)
    vvv=alog(10)*0.001
    if narr eq 0 then begin
        momstru = {SNR:!values.f_nan, RHO:!values.f_nan, DPS:!values.f_nan, SKEW:!values.f_nan, LDR:!values.f_nan, VEL:!values.f_nan, RMS: !values.f_nan, ixa:-20000, ixb:20000}
        arr = replicate(momstru,zrg,npeak_max)
        zpeak = intarr(zrg)
    endif
    if n_elements(itime) eq 0 then itime=0
    i=0L
    for irg=0,zrg-1 do begin
        zp = (*p_npeaks)[irg]
        for ipk=0,zp-1 do begin
            ; arr[irg,ipk,itime] = (*p_dmp_data)[i++]
            ; arrx=arr[irg,ipk,itime] & STRUCT_ASSIGN,(*p_dmp_data)[i],arrx & arrx.SNR=exp(vvv*arrx.SNR) & ...LWC...RR..LDR & arr[irg,ipk,itime]=arrx
            arr[irg,ipk,itime].SNR = exp(vvv*(*p_dmp_data)[i].SNR)
            arr[irg,ipk,itime].RHO = (*p_dmp_data)[i].SNM gt -9000 ? (*p_dmp_data)[i].SNM * 0.0001 : !values.f_nan
            arr[irg,ipk,itime].DPS = (*p_dmp_data)[i].LWC gt -9000 ? (*p_dmp_data)[i].LWC*0.001 : !values.f_nan
            arr[irg,ipk,itime].SKEW = (*p_dmp_data)[i].RR  gt -9000 ? (*p_dmp_data)[i].RR*0.01 : !values.f_nan
            ldr_int = (*p_dmp_data)[i].LDR
            arr[irg,ipk,itime].LDR = ldr_int gt -4999 ? exp(vvv*ldr_int) : !values.f_nan
            arr[irg,ipk,itime].VEL = (*p_dmp_data)[i].VEL
            arr[irg,ipk,itime].RMS = (*p_dmp_data)[i].RMS
            arr[irg,ipk,itime].ixa = (*p_dmp_data)[i].ixa
            arr[irg,ipk,itime].ixb = (*p_dmp_data)[i].ixb
            i++
        endfor
        zpeak[irg,itime] = zp
    endfor
end
