pro get_noisecom,calida,ranges_out
    ; GAINVSRANGE_co,GAINVSRANGE_cx,nf_co,nf_cx,Calibr0Co,Calibr0Cx,CorrLNAmatchCo,CorrLNAmatchCx,adcnoise
    ; GAINVSRANGE_co/x  Receiver, flat part above 500 m is normalized to 1.0
    ; nf_co/x Noise figure, Factor, not in dB! Measured by the calibrated noise source (Noisecom) by on/off comparison 
    ; Calibr0Co/x  = Power of calibration noise / Power of Receiver Noise with matched load @300K  measured at the same time as
    ; CorrLNAmatchCo/x The noise measured in noise gate is lower than noise Receiver Noise with matched load @300K as the LNA is not matched during noise measurment.
    ;                  CorrLNAmatchCo/x > 1 has to be multiplied to noise power from the noise gate (npow from serverinfo) so that it is equivalent to the receiver noise.
    ; adcnoise   adc noise level. note it has to be multiplied by nfft so that it corresponds to noise power.
    ppgnc={$
        NoiseComFn_co:'/home/data/specialdata/noisecom_co.nc.sav',$ ; files containing the receiver calibration measurement
        NoiseComFn_cx:'/home/data/specialdata/noisecom_cx.nc.sav',$
        KuhneFn_co:'',$ ; files containing the receiver calibration measurement
        KuhneFn_cx:'',$
        range_flat:880.,$ ; above this range the receiver gain (GainVsRange, get_noisecom) is flat
        dummy:-1$
    }
common magic4chs,magic4chs,FzkPdsFmt,syspar
    config2stru,ppgnc,'get_noisecom',[syspar.iam+'.config']
    if strlen(ppgnc.KuhneFn_co) gt 0 then begin
        restore,ppgnc.KuhneFn_co
        KuhneCoExists=1
        GAINVSRANGE_Kuhne=GAINVSRANGE
        heis_Kuhne = heis
    endif else KuhneCoExists=0
    restore,ppgnc.NoiseComFn_co
    if n_elements(ranges_out) eq 0 then begin
         printf,-2,'Since summer 2015 get_noisecom works with differen range bin width setting. for this reason get_noisecom needs to be called by: get_noisecom,calida,ranges_out'
         printf,-2,'Setting ranges_out to ',heis[0:4],' ...'
         ranges_out=heis
    endif
    if KuhneCoExists then begin
        print,'old GainVsRange from Noisecom Co:  ',db(GAINVSRANGE[0:8])
        print,'new GainVsRange from Kuhne Co:     ',db(GAINVSRANGE_Kuhne[0:8])
        print,'Ranges from Noisecom meas.:        ',heis[0:8]
        if total(abs(heis[0:8]-heis_Kuhne[0:8])) gt 1 then begin 
            print,'Ranges from Kuehne meas.:     ',heis_Kuhne[0:8]
        endif
        GAINVSRANGE = GAINVSRANGE_Kuhne
        heis = heis_Kuhne
    endif
    HeisIn_co=heis
    rgflatout = (where(ranges_out gt ppgnc.range_flat) )[0]
    rgflatorg = (where(HeisIn_co gt ppgnc.range_flat) )[0] + 10.
    zhsout=n_elements(ranges_out)
    GAINVSRANGE_co = interpol(GAINVSRANGE[0:rgflatorg],HeisIn_co[0:rgflatorg],ranges_out[0:(rgflatout-1)>3])
    ;### window,xsize=1600,ysize=1200
    ;### plot,    HeisIn_co[0:rgflatorg],      GAINVSRANGE[0:rgflatorg],psym=1,xtit='Range [m]',ytit='Sensitivity/Full Sensitivity',tit='Magenta: Co, Blue:Cross',charsi=1.8,yrange=[0,1.05]
    ;### oplot,   HeisIn_co[0:rgflatorg],      GAINVSRANGE[0:rgflatorg],psym=1,colo=2
    ;### oplot,ranges_out[0:rgflatout-1], GAINVSRANGE_co[0:rgflatout-1],colo=3 
    ;### oplot,ranges_out[0:rgflatout-1], GAINVSRANGE_co[0:rgflatout-1],color=3,psym=2 
    nf_co=nf 
    PowCalOrgCoFromCoMeas=PowCalCo 
    PowNoiOrgCoFromCoMeas=PowNoiCo 
    PowCalOrgCxFromCoMeas=PowCalCx 
    PowNoiOrgCxFromCoMeas=PowNoiCx 
    PowNoi14Co=MEDHSD_OFF*nfft 
    padc_co=padc
    if syspar.zchan ge 2 then begin
        if strlen(ppgnc.KuhneFn_cx) gt 0 then begin
            restore,ppgnc.KuhneFn_cx
            KuhneCxExists=1
            GAINVSRANGE_Kuhne=GAINVSRANGE
            heis_Kuhne = heis
        endif else KuhneCxExists=0
        restore,ppgnc.NoiseComFn_cx
        if total(heis[0:rgflatorg] ne HeisIn_co[0:rgflatorg]) gt 0 then begin
            printf,-2,'Co- and Cross-channel noisecom files have different pulse width or range settings'
            stop
        endif
        if KuhneCxExists then begin
            print,'old GainVsRange from Noisecom Cx:  ',db(GAINVSRANGE[0:8])
            print,'new GainVsRange from Kuhne Cx:     ',db(GAINVSRANGE_Kuhne[0:8])
            GAINVSRANGE = GAINVSRANGE_Kuhne
            heis = heis_Kuhne
        endif
        HeisIn_cx=heis
        nf_cx=nf 
        GAINVSRANGE_cx = interpol(GAINVSRANGE[0:rgflatorg],HeisIn_cx[0:rgflatorg],ranges_out[0:(rgflatout-1)>3])
        ;### oplot,    HeisIn_cx[0:rgflatorg],     GAINVSRANGE[0:rgflatorg],psym=4,colo=1
        ;### oplot, ranges_out[0:rgflatout-1],GAINVSRANGE_cx[0:rgflatout-1],colo=5 
        ;### oplot, ranges_out[0:rgflatout-1],GAINVSRANGE_cx[0:rgflatout-1],colo=5,psym=5
        ;### write_png,'GainVsRange.png',tvrd(true=1)
        ;### stop
        PowCalOrgCoFromCxMeas=PowCalCo 
        PowNoiOrgCoFromCxMeas=PowNoiCo 
        PowCalOrgCxFromCxMeas=PowCalCx 
        PowNoiOrgCxFromCxMeas=PowNoiCx 
        PowNoi14Cx=MEDHSD_OFF*nfft 
        padc_cx=padc
    endif else begin
        nf_cx=!values.f_nan
        GAINVSRANGE_cx=replicate(!values.f_nan,n_elements(GAINVSRANGE_co))
        PowCalOrgCoFromCxMeas=!values.f_nan
        PowNoiOrgCoFromCxMeas=!values.f_nan
        PowCalOrgCxFromCxMeas=!values.f_nan
        PowNoiOrgCxFromCxMeas=!values.f_nan
        PowNoi14Cx=!values.f_nan
        padc_cx=!values.f_nan
    endelse
    if syspar.noisecomgainmurx then begin
        PowCalOrgCo = PowCalOrgCoFromCoMeas
        PowNoiOrgCo = PowNoiOrgCoFromCoMeas
        PowCalOrgCx = PowCalOrgCxFromCxMeas
        PowNoiOrgCx = PowNoiOrgCxFromCxMeas
    endif else begin
        PowCalOrgCo = PowCalOrgCoFromCxMeas
        PowNoiOrgCo = PowNoiOrgCoFromCxMeas
        PowCalOrgCx = PowCalOrgCxFromCoMeas
        PowNoiOrgCx = PowNoiOrgCxFromCoMeas
    endelse
    ; During measurement in noise gate the LNA input is not matched. Though it cannot be explained, this causes lower noise power.
    ; For this reason the noise power (noise from noise gate) in the pds and dmp data are too small. 
    ; They are corrected by multiplying with  CorrLNAmatchCo/Cx ~= 1.3
    ; For this reason also the the SNR values in the pds and dmp files are too big. They can be corrected by multiplying with 1/(CorrLNAmatchCo)
    ; For this reason also the the LDR values in dmp files are slightly wrong. They can be corrected by multiplying with CorrLNAmatchCo/CorrLNAmatchCx
    CorrLNAmatchCo = PowNoi14Co/PowNoiOrgCo & CorrLNAmatchCx = PowNoi14Cx/PowNoiOrgCx
    Calibr0Co=PowCalOrgCo/PowNoi14Co & Calibr0Cx=PowCalOrgCx/PowNoi14Cx
    calida={$
        GAINVSRANGE:[[GAINVSRANGE_co],[GAINVSRANGE_cx]],$
        nf:[nf_co,nf_cx],$
        Calibr0:[Calibr0Co,Calibr0Cx],$
        CorrLNAmatch:[CorrLNAmatchCo,CorrLNAmatchCx],$
        adcnoise:[padc_co,padc_cx], $
        PowNoi:[PowNoiOrgCo,PowNoiOrgCx],$
        PowCal:[PowCalOrgCo,PowCalOrgCx],$
        nfft:nfft $
    }
end
