function identify_peaks_by_2ndmom,spc,thr,x,moms,peak_thr_wider=peak_thr_wider,peak_thr_higher=peak_thr_higher, peak_sig_thr=peak_sig_thr
; find the dominant peaks in the spectrum spc by investigating the distance of the peaks and their witdth. 
; peak_thr_fac = 
    n = n_elements(spc)

    ; find all extrema
    extremum_type = find_extrema(spc,ix_extremum_l,ix_extremum_r,thr,peak_sig_thr)
    nmin = n_elements(extremum_type)/2

    if extremum_type[0] lt 0 then return,-1

    ; save the ranges of the peaks which are seperated by minima to peak_ranges
    ; Calcultate the moments of each peak. In stead of the 2rd moment vv = sum vel[i]^2*spc[i]/pow
    ; is saved, which makes it easier to join two peaks later.
    peak_ranges=lonarr(2,nmin) ; left, and right index of each max will be stored to this array
    pw=fltarr(nmin) ; power linear
    vl=fltarr(nmin) ; velocity
    vv=fltarr(nmin) ; peak width rms = sqrt(vv-vl^2)
    ixmin = where(extremum_type eq 0,nmin)
    lastir=-1L
    for i=0,nmin-1 do begin
        il = ix_extremum_r[ixmin[i]]
        if il eq lastir then il = (il+1L) mod n
        ir = ix_extremum_l[ixmin[(i+1) mod nmin]]
        peak_ranges[0,i] = [il, ir]
        lastir = ir
        ; moment estimation
        ix4spc = ab2ix4spc(il,ir,n)
        spcx = spc[ix4spc]
        xx=x[ix4spc]
        pwx = total(spcx)
        vlx = total(spcx*xx)/pwx
        vvx = total(spcx*xx*xx)/pwx
        ; rmxs^2 = wwx - vlx * vlx
        pw[i] = pwx
        vl[i] = vlx
        vv[i] = vvx
    endfor

    ix = sort(-pw)

    ; 
    vua = (x[n-1]-x[0]) * float(n) / float(n-1) ; unambiguty velocity
    for i=0,nmin-2 do begin
        ihungry = ix[i]
        if pw[ihungry] gt 0.0 then begin
            ismaller = i + 1L + lindgen(nmin-i-1)
            repeat begin
                vl_hungry = vl[ihungry]
                sigq_hungry = vv[ihungry]-vl_hungry^2
                ; ix_join = where(pw[ix[ismaller]] gt 0.0 and $
                ;    peak_thr_higher * pw[ihungry] * $
                ;        exp(-0.5*(vl[ix[ismaller]]-vv[ihungry])^2/(sigq_hungry*peak_thr_wider)) $
                ;    gt pw[ix[ismaller]], nixjoin)
                vl_smaller = vl[ix[ismaller]]
                sigq_smaller = vv[ix[ismaller]]-vl_smaller^2
                ix_join = where(pw[ix[ismaller]] gt 0.0 and $
                     (sigq_hungry+sigq_smaller) * peak_thr_wider  $
                     gt cmod(vl_hungry-vl_smaller,vua)^2 , nixjoin)
                for j=0,nixjoin-1 do begin
                    ; join moment of isnack to moment ihungry
                    isnack = ix[ismaller[ix_join[j]]]
                    pw_hungry = pw[ihungry]
                    pw_snack = pw[isnack]
                    pw_new = pw[ihungry] + pw[isnack] & pw[ihungry] = pw_new & pw[isnack]=0.
                    vl[ihungry] = (pw_hungry*vl[ihungry] + pw_snack*vl[isnack])/pw_new
                    vv[ihungry] = (pw_hungry*vv[ihungry] + pw_snack*vv[isnack])/pw_new
                    ; falsch, geht nicht wenn peak am Rand des Eindeutigkeitsbereichs ist
                    peak_ranges[0,ihungry] = peak_ranges[0,ihungry] < peak_ranges[0,isnack]
                    peak_ranges[1,ihungry] = peak_ranges[1,ihungry] > peak_ranges[1,isnack]
                endfor
            endrep until nixjoin eq 0 
        endif
    endfor
    npeak = long(total(pw gt 0))
    ix = (sort(-pw))[0:npeak-1]
    moms=transpose([[pw[ix]],[vl[ix]],[sqrt(vv[ix]-vl[ix]^2)]])
    
    pr=peak_ranges[*,ix] 

    return,pr
end

