pro remove_clutter2,spc,noise,det_thres,LDRcorfa,pp,irg,RemovedSpc,ClutterFound,do_plt,rhospc,ph_cocx
    ; remove clutter from a spectrum which is distrubuted symmetrically around zero velocity (index 0 in spc)
    ; spc = Spectrum of one range gate, zero velocity at index 0
    ; noise = Noise level
    ; det_thres = detection threshold
    ; pp = Structure containing the following Parameters:
    ; Parameters tested with Data from September + October 2005:
    ; pp.max_sholder_dbc=-1.10  ; theoretically the shoulders should be -6 dbc, -1.1 dB works good in practice
    ;                  Non clutter signal may cover the the clutter. The typically one of the shoulders is higer.
    ;                  In this case no clutter removal is done.
    ; pp.fftwin=[0.45,.055,0.014, 0.003,,0.002,,0.001, 0] ; decaying factor for the neighbors typically used for strong clutter
    ; pp.fftwin=[0.31, 0.0042, 0.001, 0, 0, 0, 0, 0] ; decaying factor (fourier transfomed fft window) for normal clutter
common remove_clutter,max_sholder_oc,TotFitErrThres,nfft,nffth,npatch,nfitgc,fftwinfit,ixpatch,xxpatch,co,cx,minLDRgc,sigLDRs,nsigLDRs,fftwin00,nop,ix00fftwin,TotFftWin,ix00spc
    if n_elements(nfft) ne 1 || n_elements(spc[*,0]) ne nfft then begin
        co=0L & cx=1L
        minLDRgc = 0.0019
        max_sholder_oc = linear(pp.max_sholder_dbc)
        TotFitErrThres = 0.2
        nfft = n_elements(spc[*,co])
        nffth = nfft/2-2 ; maximum span of the spectral range that will be investigated for separating ground clutter and signal
        nfitgc = 3 ; for fitting the ground clutter only 2*nfitgc+1 bins are taken
        npatch = 3  ; 2 * npatch +1 spectral bins are patched if they are affected by ground clutter (gc)
        ;fftwinfit = [0.0006,0.25,1.0,0.25,0.0006]
        ixpatch = [nfft+lindgen(npatch)-npatch,0L,lindgen(npatch)]
        xxpatch = [findgen(npatch)-npatch,findgen(npatch+1)]
        sigLDRs=[1.,1.1,1.2,1.3,1.4,1.5]
        nsigLDRs = n_elements(sigLDRs)
        ; prameters needed for old version of clutter removal:
        ; nop = max(where( fftwin gt 0.0 ))+1L 
        nop = npatch
        fftwin00 = [1.0,pp.fftwin[0:nop-1]]
        ix00fftwin = [nop-lindgen(nop),0L,lindgen(nop)+1L]
        ; fftwinSym = [reverse(pp.fftwin[0:nop-1]),1.0,pp.fftwin[0:nop-1]] = fftwin00[ix00fftwin]
        TotFftWin = total(fftwin00[ix00fftwin])
        ix00spc = [nfft+lindgen(nop)-nop,0L,lindgen(nop)+1L] ; wegen nop = npatch identisch mit ixpatch
        if do_plt then window,xsize=1100,ysize=1400
    endif
    RemovedSpc = replicate(0.0,2*npatch+1,2)
    ClutterFound = replicate(0,2)
    sigcx = -1.0 
    sig = -1.0 
    TotFitErrCo=9999.
    TotFitErrCx=9999.
    ;pcco = max(spc[[nfft-1L,0L,1L],co])   ; power of the spectral component at zero Doppler shift
    pcco = spc[0L,co]   ; power of the spectral component at zero Doppler shift
    pccx = spc[0L,cx]
    det_thres_co=det_thres[co]
    if pcco ge det_thres_co then begin
        nli=nfitgc & while spc[nfft-nli,co] gt det_thres_co && nli lt nffth do ++nli
        nre=nfitgc & while spc[nre,co] gt det_thres_co && nre lt nffth do ++nre
        ixpiece = [lindgen(nli)+nfft-nli,lindgen(nre+1)]
        npiece = nli + nre + 1 ; number of spectral bins of the piece of the spectrum which will be analyzed spcpiec
        ix0 = nli ; here is the vel=0 bin
        ixfitgc = ix0-nfitgc + lindgen(nfitgc*2L+1L)  ; zeigt in spcopiece auf die 2*nfitgc+1 bins, in denen der gc gefittet wird
        xxpiece = lindgen(npiece) - ix0 
        spcopiece = spc[ixpiece,co]-noise[co] 
        spcxpiece = spc[ixpiece,cx]-noise[cx]
        if do_plt then begin
            plot,xxpiece,db(spcopiece+noise[co]),yra=[-45,55],xra=[-25,25],xst=1,yst=1,tit='Significant Spectral Bins arround Vel=0 range: '+strgg(irg),psym=10
            oplot,xxpiece,db(spcopiece+noise[co]),psym=1
        endif
        det_thres3noise = reform(det_thres[*]-noise[*])
        spcopiece_copy = spcopiece & spcopiece_copy[ixfitgc]=0.0
        ixfitatm=where(spcopiece_copy gt det_thres3noise[co],nixfitatm)
        xxfitatm = xxpiece[ixfitatm]
        if nixfitatm ge 4 then begin
            ; gauss fit with the spectral bins which are far enough away from the ground clutter
            ; normally moment estimation is done by integrating over all significant bins instead of
            ; fitting a gauss to selected bins. The later make strange things unles the bins are weighted by power in the least square fit. 
            afit = wgaussfit(xxfitatm,db((spcofitatm=spcopiece_copy[ixfitatm])),spcofitatm)
            pwatmco = linear(afit[0]) & vlx = afit[1] & sig = afit[2]
        endif else begin
            ; this branch is useful only in few cases where not enough spectral bins for fitting are available
            ;++niter=14
            ;++for iter=0,niter-1 do begin
            ;++    pwatmco = total(spcopiece_copy)
            ;++    vlx = total(spcopiece_copy*xxpiece)/pwatmco
            ;++    vvx = total(spcopiece_copy*xxpiece*xxpiece)/pwatmco
            ;++    rmsq = 2.*(vvx - vlx*vlx)
            ;++    if rmsq gt 0.0 then begin
            ;++        spcopiece_copy[ixfitgc] = pwatmco/sqrt(!pi*rmsq) * exp(-1 * (xxpiece[ixfitgc]-vlx)^2 / rmsq ) 
            ;++    endif else begin
            ;++        iter=niter-1
            ;++    endelse
            ;++endfor
            ;++sig=sqrt(rmsq/2.)
            sig=-1.0 ; ++++++++++++++++++++++++++++++++++ test ++++++++++++++++++
        endelse

        if finite(sig) && sig gt 0.0 then begin
            spco_patch = ( pwatmco/(sqrt(2.*!pi)*sig) * exp(-0.5 * ((xxpatch-vlx)/sig)^2) ) + noise[co]  ; new (patched) spectral bins
            clutterco = spc[ixpatch,co]-spco_patch
            pwgcco = clutterco[npatch] > (0.25*det_thres3noise[co])  ; peakleistung des ground clutters
            biggershoulderco = clutterco[npatch-1L] > clutterco[npatch+1L]
            sholder2headco = biggershoulderco / pwgcco
            TotFitErrCo=sqrt(total((pwgcco*fftwin00[ix00fftwin]-clutterco)^2))/total(spc[ixpatch,co]-noise[co])
            ;++ if TotFitErrCo gt TotFitErrThres then begin
            ;++     ; recalculate the moments of the atm signal peak.
            ;++     pwatmco = total(spcopiece)
            ;++     vlx = total(spcopiece*xxpiece)/pwatmco
            ;++     vvx = total(spcopiece*xxpiece*xxpiece)/pwatmco
            ;++     sig = sqrt(vvx - vlx*vlx)
            ;++     pwgcco=0.0  ; due to setting gc level to zero its not needed to recalculate spco_patch and clutter. They will not be used.
            ;++     biggershoulderco = 9999.
            ;++     sholder2headco = 9999.
            ;++ endif
        endif
        if TotFitErrCo le TotFitErrThres then begin
            ; fit the cross spectrum assuming the peak of the atmospheric signal has the same spectral shape in both channels
            ; this gives an estimate of LDR of the spectral components caused by gc and atm 

            ; The commented lines below are a least square fit for pwgccx and pwatmcx based on the assumtion that the spectral shape of the atm signal is the same as for co channel. It did not work reliable.
            ; f1 = fftwinfit ; f2 = 1/(sqrt(2.*!pi)*sig)*exp(-0.5*((xxpiece-vlx)/sig)^2) ; f1 hat 2*nfitgc+1 elemente zentriert um vel=0, und f2 2*npiece+1 werte mit vel=0 bei ix0
            ; tspcxf1f2 = [total(spcxpiece[ixfitgc]*f1),total(spcxpiece*f2)] ; die inhomogene Seite des Gleichungssystems   IHO = A X
            ; tf1f1 = total(f1*f1) & tf2f2 = total(f2*f2) & tf1f2 = total(f1*f2[ixfitgc]) ; AB = invert( [[tf1f1,tf1f2],[tf1f2,tf2f2]] ) # tspcxf1f2
            ; pwgccx = AB[0] & pwatmcx = AB[1]
            ; The following calculation of pwatmcx and pwgccx works better:
            if nixfitatm ge 1 then begin
                spcxfitatm = spcxpiece[ixfitatm]
                sigcxs = sig*sigLDRs
                pwatmcxs = fltarr(nsigLDRs)
                errors = fltarr(nsigLDRs)
                for isigcx=0,nsigLDRs-1 do begin
                    gau = 1/(sqrt(2*!pi)*sigcxs[isigcx])*exp(-0.5*((xxfitatm-vlx)/sigcxs[isigcx])^2)
                    pwatmcxs[isigcx] = total( spcxfitatm^2 / gau )/total(spcxfitatm) 
                    errors[isigcx] = total(spcxfitatm*(pwatmcxs[isigcx]*gau-spcxfitatm)^2)/total(spcxfitatm)
                endfor
                besterr=min(errors,ibest) 
                sigcx=sigcxs[ibest] & pwatmcx = pwatmcxs[ibest] > (0.25*det_thres3noise[cx])
            endif else begin
                pwatmcx=0.0 & sigcx=0.0
            endelse
            if pwatmcx gt det_thres3noise[cx] then begin
                spcx_patch = ( pwatmcx/(sqrt(2.*!pi)*sigcx) * exp(-0.5*((xxpatch-vlx)/sigcx)^2  ) ) + noise[cx] 
            endif else spcx_patch=replicate(noise[cx],2*npatch+1)
            cluttercx = spc[ixpatch,cx]-spcx_patch
            pwgccx = cluttercx[npatch] > (0.25*det_thres3noise[cx])
            TotFitErrCx=sqrt(total((pwgccx*fftwin00[ix00fftwin]-cluttercx)^2))/total(spc[ixpatch,cx]-noise[cx])
            biggershouldercx = cluttercx[npatch-1L] > cluttercx[npatch+1L]
            sholder2headcx = biggershouldercx / pwgccx
            LDRgc = LDRcorfa * pwgccx / pwgcco  & LDRatm = LDRcorfa * pwatmcx/pwatmco
            
            ; Decide if gc should be patched
            ; ClutterFound[co] = (sholder2headco lt max_sholder_oc) and pwgcco ge det_thres3noise[co] and LDRgc gt minLDRgc
            ;+ClutterFound[co] = (sholder2headco lt max_sholder_oc || biggershoulderco lt det_thres3noise[co]) && LDRgc gt minLDRgc
            ClutterFound[co] = (TotFitErrCo le TotFitErrThres) && LDRgc gt minLDRgc
            ; ClutterFound[cx] = (sholder2headcx lt max_sholder_oc) and pwgccx gt det_thres3noise[cx] and LDRgc gt minLDRgc
            ;+ClutterFound[cx] = (sholder2headcx lt max_sholder_oc || biggershouldercx lt det_thres3noise[cx]) && LDRgc gt minLDRgc
            ClutterFound[cx] = (TotFitErrCx le TotFitErrThres) && LDRgc gt minLDRgc
            
        endif

        if TotFitErrCo gt TotFitErrThres then begin
            ; The atm fit in co channel did not work gc removal is done as in the old version.
            ; co
            if pcco ge det_thres_co then begin
                lshoulderco = spc[nfft-1L,co] & rshoulderco=spc[1L,co]
                biggershoulderco = lshoulderco > rshoulderco
                sholder2headco = (0.5*(lshoulderco+rshoulderco)-noise[co] ) / (pcco-noise[co])
                ;               biggershoulderco lt pcco &&               ist das in der naechsten Zeile ueberflussig?
                spco_patch = (spc[ix00spc,co] - (pcco - noise[co])*fftwin00[ix00fftwin]) > noise[co]
                clutterco = spc[ix00spc,co] - spco_patch
                pwgcco = clutterco[npatch]  ; peakleistung des ground clutters
                ; TotFitErrCo=sqrt(total((pwgcco*fftwin00[ix00fftwin]-clutterco)^2))/total(spc[ix00spc,co]-noise[co])  ; Kontraproduktiv weil es Neuberechnung nach altem Verfahren verhindert
            endif else begin
                biggershoulderco = pcco * 33.0
                ; sholder2headco ; will not be needed due to shortcut &&
            endelse
        endif
           
        if TotFitErrCx gt TotFitErrThres then begin
            ; The atm fit in the cross channel was not done or it result is not good
            ; cx  same method as the fallback solution in cross channel.
            if pccx ge det_thres[cx]  then begin
                lshouldercx = spc[nfft-1L,cx] & rshouldercx=spc[1L,cx]
                biggershouldercx = lshouldercx > rshouldercx
                sholder2headcx = (0.5*(lshouldercx+rshouldercx)-noise[cx] ) / (pccx-noise[cx])
                ;               biggershouldercx lt pccx &&               ist das in der naechsten Zeile ueberflussig?
                spcx_patch = (spc[ix00spc,cx] - (pccx - noise[cx])*fftwin00[ix00fftwin]) > noise[cx]
                cluttercx = spc[ix00spc,cx] - spcx_patch
                if do_plt then begin
                    pwgccx = cluttercx[npatch]  ; peakleistung des ground clutters
                endif
                ; sholder2headcx = max(cluttercx[[npatch-1L,npatch+1L]]) / pwgccx  ; sollte ähnlich sein wie das oben berechnete sholder2headcx
            endif else begin
                biggershouldercx = pccx * 33.0
                ; sholder2headcx ; will not be needed due to shortcut &&
            endelse
        endif

        if TotFitErrCo gt TotFitErrThres or TotFitErrCx gt TotFitErrThres then begin
            case 1 of
                pcco ge det_thres_co and pccx ge det_thres[cx]: LDRgc = LDRcorfa * (pccx-noise[cx]) / (pcco-noise[co])
                pcco ge det_thres_co                          : LDRgc = LDRcorfa * (det_thres3noise[cx]) / (pcco-noise[co]) ; dann muss ja pccx lt det_thres[cx] sein
                                         pccx ge det_thres[cx]: LDRgc = LDRcorfa * (pccx-noise[cx]) / det_thres_co
                else: LDRgc = 33 ; undefined
            endcase
            LDRatm = 1.1 

            ClutterFound[co] = biggershoulderco lt pcco && ( sholder2headco lt max_sholder_oc || biggershoulderco lt det_thres[co] ) && LDRgc gt minLDRgc
            ClutterFound[cx] = biggershouldercx lt pccx && ( sholder2headcx lt max_sholder_oc || biggershouldercx lt det_thres[cx] ) && LDRgc gt minLDRgc
        endif

        if do_plt then begin
            if pcco gt det_thres_co and n_elements(pwatmco) ne 0 then begin
                oplot,xxpiece,db(spc[ixpiece,cx]),psym=10,color=1
                oplot,xxpatch,-42 > db(clutterco) < 52,color=4,psym=2
                if sig gt 0.0 then oplot,xxpiece,db(pwatmco/(sqrt(2.*!pi)*sig)*exp(-0.5*((xxpiece-vlx)/sig)^2)),color=2
                if sig gt 0.0 then begin
                    spc_patch_recalc4plot = ( pwatmco/(sqrt(2.*!pi)*sig) * exp(-0.5 * ((xxpatch-vlx)/sig)^2  ) ) + noise[co]
                    oplot,xxpatch,db(spc_patch_recalc4plot),color=2,psym=5
                endif
                xyouts,-15,-35,'MaxSholder/Head= '+strgg(dB(sholder2headco))+' dB Power GC= '+strgg(db(pwgcco))+' dB',charsize=1.8
                if sig gt 0.0 then xyouts,-15,-40,'LDRgc='+strgg(dB(LDRgc))+' dB LDRatm='+strgg(dB(LDRatm))+' dB LDRsig='+strgg(sigcx/sig) ,charsize=1.8
                oplot,[0,0],[-1,1]*100.,linest=1
            endif
        endif

        ; exec the patches if they seem reasonable 
        ; co channel
        if ClutterFound[co] then begin 
            spc[ixpatch,co] = spco_patch 
            RemovedSpc[*,co] = clutterco
            if do_plt then oplot,xxpiece,db(spc[ixpiece,co]),color=5
        endif
        ; cross channel
        if ClutterFound[cx] then begin
            spc[ixpatch,cx] = spcx_patch
            RemovedSpc[*,cx] = cluttercx
            if do_plt then oplot,xxpiece,db(spc[ixpiece,cx]),color=6
        endif
        if do_plt then begin
            empty
            if 1 then begin
                li='' & read,li
                if li eq 'stop' then stop
            endif
        endif
    endif ; pcco gt det_thres
end
