pro remove_clutter2,spc,noise,det_thres,pp,irg,RemovedSpc,do_plt,rhospc,ph_cocx,clutter_level=clutter_level
    ; remove clutter from a spectrum which is distrubuted symmetrically around zero velocity (index 0 in spc)
    ; spc = Spectrum of one range gate, zero velocity at index 0
    ; noise = Noise level
    ; det_thres = detection threshold
    ; pp = Structure containing the following Parameters:
    ; Parameters tested with Data from September + October 2005:
    ; pp.max_sholder_dbc=-1.10  ; theoretically the shoulders should be -6 dbc, -1.1 dB works good in practice
    ;                  Non clutter signal may cover the the clutter. The typically one of the shoulders is higer.
    ;                  In this case no clutter removal is done.
    ; pp.fftwin=[0.45,.055,0.014, 0.003,,0.002,,0.001, 0] ; decaying factor for the neighbors typically used for strong clutter
    ; pp.fftwin=[0.31, 0.0042, 0.001, 0, 0, 0, 0, 0] ; decaying factor (fourier transfomed fft window) for normal clutter
common remove_clutter,max_sholder_oc,n,nop,ixnon,ixnop,fftwin,np,yra,fftwin2
; common remove_clutter_patchrg,ixpatchrg
    if n_elements(do_plt) ne 1 then do_plt=0
    if n_elements(n) ne 1 || n_elements(spc[*,0]) ne n then begin
        max_sholder_oc=linear(pp.max_sholder_dbc)
        n = n_elements(spc[*,0])
        ;fftwin=pp.fftwin
        ;fftwin=[0.25,0.0005]
        ;nop = max(where( fftwin gt 0.0 ))+1L
        nop=2
        ;fftwin2 = [reverse(fftwin[0:nop-1]),1.0,fftwin[0:nop-1]]
        ;ixnop=1L+lindgen(nop)
        ;ixnon=n-1-lindgen(nop)
        ;ixpatchrg=[0L,ixnop,ixnon]
        if do_plt then begin
            print,'white is the original spectrum, red the clutterfiltered spectrum,'
            print,'blue is the spectraprocessing.fftwin which is set in the config file.'
            print,'it can be accessed here as fftwin'
            print,'use w+ <k> to increase fftwin at frequency <k> (only fft win will change in the picture)'
            print,'or  w- <k> to decrease it (only fftwin will change in the picture)'
            print,'set the parameters yra,np'
            print,'use con to go to the next spectrum'
            print,'quit to continue processing silen or stop exit to return to shell'
            np=30
            yra=60
        endif
    endif
    if do_plt then ospc=spc
    pc = spc[0,0]   ; power of the spectral component at zero Doppler shift
    det_thres_co=det_thres[0,0]
    if pc ge det_thres_co then begin
        nme = n-1
        nre=0L & while nre le nop || spc[nre,0L] gt det_thres_co do ++nre
        nli=0L & while nli le nop || spc[nme-nli,0L] gt det_thres_co do ++nli
        ixx=[lindgen(nli)+n-nli,lindgen(nre+1)]
        xx = lindgen(nli+nre+1)-nli
        spcpiece = spc[ixx,0] 
        spcpiece_fstguess = spcpiece-noise[0] 
        ix0 = nli
        spcpiece_fstguess[ix0-1:ix0+1]=0.0
        niter=16
        for iter=0,niter-1 do begin
            pwx = total(spcpiece_fstguess)
            vlx = total(spcpiece_fstguess*xx)/pwx
            vvx = total(spcpiece_fstguess*xx*xx)/pwx
            rmsq = 2.*(vvx - vlx*vlx)
            if rmsq gt 0.0 then begin
                ;pcx = spcpiece[ix0] - pwx/sqrt(!pi*rmsq) * exp(-1 * vlx^2 / rmsq ) - noise[0]
                ;spcpiece_fstguess[ix0-nop:ix0+nop] = (spcpiece[ix0-nop:ix0+nop] - pcx*fftwin2 -  noise[0] ) > 0.15
                spcpiece_fstguess[ix0-nop:ix0+nop] = pwx/sqrt(!pi*rmsq) * exp(-1 * (xx[ix0-nop:ix0+nop]-vlx)^2 / rmsq ) 
                pcx = total(spcpiece[ix0-nop:ix0+nop]-spcpiece_fstguess[ix0-nop:ix0+nop]-noise[0])
                print,iter,pcx,pwx,vlx,rmsq
            endif else begin
                iter=niter-1
            endelse
        endfor
        plot,xx,db(spcpiece),yra=[-25,55],xra=[-25,25],xst=1,yst=1,tit='Significant Spectral Bins arround Vel=0 range: '+strgg(irg),psym=10
        oplot,xx[ix0-nop:ix0+nop],db(spcpiece_fstguess[ix0-nop:ix0+nop]),colo=1,psym=1 
        oplot,xx,db(pwx/(sqrt(!pi*rmsq))*exp(-1*(xx-vlx)^2/rmsq)),colo=1

        spcfit = spcpiece - noise[0]
        spcfit[ix0-nop:ix0+nop]=-10000.
        ixfit=where(spcfit gt 0.0,nixfit)
        if nixfit gt 3 then begin
            xxfit=xx[ixfit] & spcfit10 = spcfit[ixfit]
            ;afit=mgausfit(xxfit,db(spcfit10))
            afitstru=mgaussfit(xxfit,db(spcfit10),spcfit10)
            afit=[afitstru.amp10.wert,afitstru.null.wert,afitstru.sig.wert]
            oplot,xx,afit[0]+db(1./(sqrt(2.*!pi)*afit[2])*exp(-0.5*((xx-afit[1])/afit[2])^2)),colo=2
            oplot,xx[ix0-nop:ix0+nop],afit[0]+db(1./(sqrt(2.*!pi)*afit[2])*exp(-0.5*((xx[ix0-nop:ix0+nop]-afit[1])/afit[2])^2)),colo=2,psym=2
            clutter=spcpiece-linear(afit[0])/(sqrt(2.*!pi)*afit[2])*exp(-0.5*((xx-afit[1])/afit[2])^2)
            head2sholderma = clutter[ix0]/max(clutter[[ix0-1,ix0+1]])
            oplot,xx[ix0-nop:ix0+nop],db(clutter[ix0-nop:ix0+nop]),colo=4,psym=2
            xyouts,7,50,'Head/MaxSholder= '+strgg(dB(head2sholderma))+' dB',charsize=1.8
        endif
        stop
        clutter_level=1.0
    endif else clutter_level=0.0
    while do_plt do begin
        ix=[n-np+lindgen(np),lindgen(np+1)]
        frq=[-np+lindgen(np),lindgen(np+1)]
        frq_nop=[-nop+lindgen(nop),lindgen(nop+1)]
        plot,frq,db(ospc[ix]),yra=[-7,yra],psym=10,xst=1,yst=1,ytit='Power Spectrum [dB]',xtit='Number of Frequency Bin'
        if ospc[0] ne spc[0] then oplot,frq_nop,db([fftwin[nop-lindgen(nop)-1],1.0,fftwin[lindgen(nop)]]*pc),color=1
        oplot,frq,replicate(db(det_thres),2*np+1),linest=1,color=4
        oplot,frq,replicate(db(noise[0]),2*np+1),linest=2,color=4
        oplot,frq,db(spc[ix]),col=2,psym=2

        ixp=1L+lindgen(n/2)
        ixn=n-1-lindgen(n/2)
        pspc=ospc[ixp]
        nspc=ospc[ixn]

        arg = myprompt('Remove Clutter >')
        cmd = arg[0] &  narg=n_elements(arg)
        case 1 of
        cmd eq 'png': begin
            if narg ge 2 then png_fn = arg[1] else begin
                png_fn =  'clutter' + tag_mom + '.png'
            endelse
            case !d.name of
                'X':write_png, png_fn, TVRD(true=1)
                'Z': begin
                    write_png, png_fn, TVRD() , ct_red, ct_green, ct_blue
                end
                else:
            endcase
        end
        cmd eq 'w+' or cmd eq 'w-' or cmd eq 'w0' or cmd eq 'w1' :begin
            if narg eq 2 then begin
                iiichange=(0>(fix(arg[1])-1))<(nop-1)
                case arg[0] of 
                    'w+':  fftwin[iiichange] *= 1.1
                    'w-':  fftwin[iiichange] *= 0.9
                    'w0':  fftwin[iiichange] = 0
                    'w1':  begin
                        fftwin[iiichange] = 0.25
                        nop = max(where( fftwin gt 0.0 ))+1L
                    end
                    else:
                endcase
                print,format='(99f10.7)',fftwin
            endif else print,'syntax: fftwin <number of bin> <factor>'
        end
        cmd eq 'stop': stop
        cmd eq 'quit': begin
            pp.pltclutter=0
            do_plt=0
        end
        cmd eq 'x' or cmd eq 'exit' or cmd eq 'con' or cmd eq 'conti': do_plt=0
        else: begin
            setcmd = ''
            for i=0 , narg - 1 do setcmd = setcmd + arg[i] + ' '
            if lmgr(/vm) then print,'VM license can not execute '+setcmd $
            else dummi=execute( setcmd )
        end
        endcase
        nop = max(where( fftwin gt 0.0 ))+1L
    endwhile
end
