pro sigmaXKaW
c_light=2.99792e8
;kwq = 0.93
hei=1000.
zD=5000
Vel=mk_x(zD,[0.00001,9.771])
nue = 1+3.68e-5 * hei + 1.71e-9 * hei^2
D =  -0.0016 * alog( 0.9369 - 0.097087 * ((Vel/nue) ) ) 
Temp=[0,10.,20,-10]
zT=n_elements(Temp)
Frq=[9.4e9,35.1e9,95e9]
zF=n_elements(Frq)
mie7ray=fltarr(zD,zF,zT)
for iFrq=0,zF-1 do begin 
    for iT=0,zT-1 do begin 
        att=forward_tkc(Frq[iFrq]/1e9,Temp[iT],epsilon=epsilon) 
        nref=sqrt(epsilon)
        kwq=abs((nref^2-1.)/(nref^2+2.))^2
        print,'Frq='+strgg(Frq[iFrq])+' Temp='+strgg(Temp[iT])+' nef='+strgg(real_part(nref))+', '+strgg(imaginary(nref))+' kwq='+strgg(kwq)
        for iD=0,zD-1 do begin
            lambda=c_light/Frq[iFrq]
            bhmie,!dpi*D[iD]/lambda,nref,0,dumy_s1,dumy_s2,dumy_qext,dumy_qsca,qback,dumy_gsca
            mie7ray[iD,iFrq,iT]=qback*lambda^4/(kwq*D[iD]^4*!dpi^3)
        endfor
    endfor
endfor
; wdelete
window,xsize=1250,ysize=1750
plot,d*1000,vel,charsi=2,xtit='Droplet Size im mm',ytit='Terminal Fall Velocity of Rain Droplets m/s at 1000 m above sea level',xst=1,yst=1,yrange=[0,10]
write_png,'TerminalFallVelVsDropSize.png',tvrd(true=1)
plot,d*1000.,db(mie7ray[*,0,0]),charsi=2,xtit='Droplet Size im mm',ytit='Sigma_mie/Sigma_Rayleigh in dB',tit='blue: X-Band, Magenta: Ka-Band, Yellow: W-Band; Temp=0 C; height=1000 m',yra=[-35,3],yst=1,xst=1
oplot,d*1000,db(mie7ray[*,0,0]),co=1
oplot,d*1000,db(mie7ray[*,1,0]),co=2
oplot,d*1000,db(mie7ray[*,2,0]),co=4
write_png,'sigmaXKaW_vs_d.png',tvrd(true=1)
plot,vel,db(mie7ray[*,0,0]),charsi=2,xtit='Terminal Fall Velocity of Droplets in m/s',ytit='Sigma_mie/Sigma_Rayleigh in dB',tit='blue: X-Band, Magenta: Ka-Band, Yellow: W-Band; Temp=0 C; height=1000 m',yra=[-35,3],yst=1,xst=1
oplot,vel,db(mie7ray[*,0,0]),co=1
oplot,vel,db(mie7ray[*,1,0]),co=2
oplot,vel,db(mie7ray[*,2,0]),co=4
write_png,'sigmaXKaW_vs_vel.png',tvrd(true=1)
plot,vel,db(mie7ray[*,1,0]/mie7ray[*,0,0]),xtit='Terminal Fall Velocity of Droplets in m/s',ytit='Sigma_Ka/Sigma_X in dB',tit='blue: Temp=0, Magenta: Temp=10, Red: Temp=20, Yellow: Temp=-10; height=1000 m',yra=[-12,3],yst=1,xst=1,charsi=2
oplot,vel,db(mie7ray[*,1,0]/mie7ray[*,0,0]),co=1
oplot,vel,db(mie7ray[*,1,1]/mie7ray[*,0,1]),co=2
oplot,vel,db(mie7ray[*,1,2]/mie7ray[*,0,2]),co=3
oplot,vel,db(mie7ray[*,1,3]/mie7ray[*,0,3]),co=4
write_png,'sigmaKa7sigmaX_vs_vel.png',tvrd(true=1)
plot,vel,db(mie7ray[*,2,0]/mie7ray[*,1,0]),xtit='Terminal Fall Velocity of Droplets in m/s',ytit='Sigma_W/Sigma_Ka in dB',tit='blue: Temp=0, Magenta: Temp=10, Red: Temp=20, Yellow: Temp=-10; height=1000 m',yra=[-21,1],yst=1,xst=1,charsi=2
oplot,vel,db(mie7ray[*,2,0]/mie7ray[*,1,0]),co=1
oplot,vel,db(mie7ray[*,2,1]/mie7ray[*,1,1]),co=2
oplot,vel,db(mie7ray[*,2,2]/mie7ray[*,1,2]),co=3
oplot,vel,db(mie7ray[*,2,3]/mie7ray[*,1,3]),co=4
write_png,'sigmaW7sigmaKa_vs_vel.png',tvrd(true=1)

;stop
end
