pro strarr2ht,str,hei,temp,n
    n=n_elements(str)
    if n gt 30 then begin
        hei=fltarr(n) & temp=fltarr(n)
        j=0
        for i=0,n-1 do begin
            htstr=strsplit(str[i],/extr) 
            if n_elements(htstr) eq 2 then begin
                hei[j]=float(htstr[0]) 
                temp[j]=float(htstr[1])
                j++
            endif
        endfor
        if j ne n then begin
            n=j
            hei=hei[0:j-1]
            temp=temp[0:j-1]
        endif
    endif else n=0
end


function temperature,hei,utime,MeltHei=MeltHei,done=done,agl2asl=agl2asl,outdoortemp2metlhei=outdoortemp2metlhei,prefere_modle=prefere_modle
    ; get temperature profile from the database
    common tempdatabase, rawinTime1, rawinTime2, modelTime, heiRawin1, heiRawin2, heiModel, tempRawin1, tempRawin2, tempModel, nRawin1, nRawin2, nModel
    common magic4chs,magic4chs,FzkPdsFmt,syspar
    if n_elements(rawinTime1) ne 1 then begin
        rawinTime1=0UL & rawinTime2=0UL & modelTime=0UL
    endif

    if n_elements(agl2asl) ne 1 then agl2asl=0.0
    if n_elements(outdoortemp2metlhei) ne 1 then outdoortemp2metlhei=190.
    if n_elements(prefere_modle) ne 1 then prefere_modle=0
    
    done=0
    
    host=getenv('HOSTNAME') 
    
    if strpos(strupcase(host),'PLGFE3F003') ge 0 || strpos(strupcase(host),'DWD') ge 0 || host eq 'radarserver' || ( host eq '' and strmid(syspar.iam,0,1) eq 'D') then begin
        ; host = '' happens when mmclx is run as cron job
        nowis = ulong(systime(/sec,/utc))
        H6=3600UL*6UL
        H1 = 3600UL
    
        if host ne 'plgfe3l004.dwd.de' then doitat='ssh rmol1@lglxs408.dwd.de ' else doitat=''
        if prefere_modle eq 0 then begin
            rawinTime2x = ((utime + h6-1L) ) / h6 *h6
            if rawinTime2x ne rawinTime2 then begin
                rawinTime2=rawinTime2x
                if rawinTime2x le (nowis-3600UL*1UL) then begin
                    rawinTimeStr2 = unixtime2bdate(rawinTime2,nice=5)
                    print,'loading rawind data by calling: ' + doitat+'/rao/uhome/rmol1/routine_scripts/cloudradar/readFromDb /rao/uhome/rmol1/routine_scripts/cloudradar/rawindata '+rawinTimeStr2 
                    ;spawn,doitat+'/home/data/bin/killerscript rawindata4kill &' ; monitor next execution and kill if it crashes
                    spawn,doitat+'/rao/uhome/rmol1/routine_scripts/cloudradar/readFromDb /rao/uhome/rmol1/routine_scripts/cloudradar/rawindata '+rawinTimeStr2,result
                    strarr2ht,result,heiRawin2,tempRawin2,nRawin2
                endif else nRawin2=0
            endif 
            if n_elements(nRawin2) ne 1 then nRawin2=0  ; schnellfix
            if nRawin2 gt 0 then begin
                tempRawinG2=interpol(tempRawin2,heiRawin2,hei+agl2asl)
            endif

            if nRawin2 gt 0 then begin
                rawinTime1x = ((utime -1L) ) / h6 * h6
                if rawinTime1x ne rawinTime1 then begin
                    rawinTime1=rawinTime1x
                    if rawinTime1 le (nowis-3600UL*1UL) then begin
                        rawinTimeStr1 = unixtime2bdate(rawinTime1,nice=5)
                        print,'loading rawindata1 '+rawinTimeStr1
                    	;spawn,doitat+'/home/data/bin/killerscript rawindata4kill &' ; monitor next execution and kill if it crashes
                        spawn,doitat+'/rao/uhome/rmol1/routine_scripts/cloudradar/readFromDb /rao/uhome/rmol1/routine_scripts/cloudradar/rawindata '+rawinTimeStr1,result
                        ;print, result
                        strarr2ht,result,heiRawin1,tempRawin1,nRawin1
                    endif else nRawin1=0
                endif
                if nRawin1 gt 0 then begin
                    tempRawinG1=interpol(tempRawin1,heiRawin1,hei+agl2asl)
                endif
                if nRawin1 gt 0 then begin
                    RgAbove3000m = (where(hei ge 3000))[0]
                    if max(abs((tempRawinG1-tempRawinG2)[RgAbove3000m:*])) lt 16. then begin
                        w1 = double(rawinTime2-utime)/double(rawinTime2-rawinTime1)
                        w2 = double(utime-rawinTime1)/double(rawinTime2-rawinTime1)
                        done=2
                        temp = tempRawinG1 * w1 + tempRawinG2 * w2
                        ;print,temp[80],w1,w2,utime
			;print, temp
                        return,temp
                    endif else begin
                        print,'The two closest Rawin Profiles are too different. Using model data instead.'
                    endelse
                endif
            endif
        endif
        if done eq 0 then begin
            modelTimex = ( (utime + 1790UL) < (nowis-0UL) ) / H1 * H1
            if modelTimex ne modelTime then begin
                modelTime=modelTimex
                modelTimeStr = unixtime2bdate(modelTime,nice=5)
                print,'loading modeldata '+modelTimeStr
                ;spawn,doitat+'/home/data/bin/killerscript modeldata14kill &' ; monitor next execution and kill if it crashes
                spawn,doitat+'/rao/uhome/rmol1/routine_scripts/cloudradar/readFromDb /rao/uhome/rmol1/routine_scripts/cloudradar/modeldata1 '+modelTimeStr,result
                if n_elements(result) gt 2 then begin
                    strarr2ht,result[1:*],heiModel,tempModel,nModel
                endif else begin
                    nModel=0
                    spawn,'append_message2loga no modeldata, cmd: modeldata1 ' + modelTimeStr
                endelse
            endif 
            if n_elements(nModel) ne 1 then  nModel=0
            if nModel gt 0 then begin
                tempModelG = interpol(tempModel,heiModel,hei+agl2asl,/quadratic)
                temp = tempModelG
                done=1
		;print, temp
                return,temp
            endif
        endif
    endif

    if done eq 0 then begin
       if n_elements(MeltHei) ne 1 || MeltHei lt -80000 then begin
           xMeltHei=1800.
           done=0
       endif else begin
           xMeltHei=MeltHei
           done=3
       endelse
       temp = (xMeltHei-hei) * (1. / outdoortemp2metlhei)
       return,temp
    endif 
    
    print,'sollte da nicht hin kommen'
    return,-1

end 
