function total_dmp_rho, data, LDRdetectable
; join the peaks in the array of dmp structures data and return it as dmp structure.
    
    out = data[0]
    SNRx = total(data[*].SNR)
    npeaks = n_elements(data[*].SNR)
   
    out.ixa = npeaks
    out.SNR = SNRx
    out.RHO = avg(data[*].RHO,weight=data[*].SNR)
    out.DPS = avgangles(data[*].DPS,weight=data[*].SNR)
    out.SKEW = npeaks eq 1 ? data[0].SKEW : !VALUES.F_NAN
    if SNRx gt 0.0 then begin
        out.VEL = total(data[*].VEL*data[*].SNR)/SNRx
        ; out.RMS = total(data[*].RMS*data[*].SNR)/SNRx ; quatsch
        out.RMS = sqrt( total((data[*].RMS^2 + data[*].VEL^2)*data[*].SNR) / SNRx - out.VEL^2  )
    endif else begin
        out.VEL = !VALUES.F_NAN
        out.RMS = !VALUES.F_NAN
    endelse
    ixLDRdetectable = where(LDRdetectable, nixLDRdetectable)
    if nixLDRdetectable gt 0 then begin
        SNRx = total(data[ixLDRdetectable].SNR)
        if SNRx gt 0.0 then out.LDR = total(data[ixLDRdetectable].LDR*data[ixLDRdetectable].SNR)/SNRx else out.LDR = !VALUES.F_NAN
    endif else out.LDR = !VALUES.F_NAN    
    return,out
end
