function whoami,iam
    ; this routine should be called at the begining of each program
    common iam,whoami
    common magic4chs,magic4chs,FzkPdsFmt,syspar

    whoami={iam:'nobody'}
    config2stru,whoami,'whoami',['whoami.config']
    if n_elements(iam) eq 1 && ( (iam eq 'nobody' || iam eq 'me') eq 0 ) then whoami.iam=iam
    
    syspar={ $ ;  contains system parameters which can not be found in the pds data as e.g. the system frequency 
             $ ;  or the magic 4 characters which are in the pds data but for extracting the data they should be known in advance.
        magic4chs:'XXXX',$
        iam:whoami.iam,$     ; z.B. radarconst braucht syspar.iam aus dem magic4chs common block um mit config2stru,radarconst,[<iam>.config] die Radarconstante einstellen zu koennen.
        FzkPdsFmt:1  , $     ; 1, if the radarserver saves the pds data in the format which allows repeated headers DWD0 and NASA
        zchan:2 , $          ; number of channels, co cross, or only co
        fzk100:1.0, $        ; 100. if the power givn in the serverinfo structs is given in centi Watts. 
        powermetertype:0, $   ; 0:power is given as average power; 1 power is given as peak power in W as in MBX1; 2:power in given as peak power in kW line in MBC3
        fzkscanner:0, $      ; If set 90 deg will be added to elvpos ELVPOS
        noscanner:0, $       ; for vertically pointing systems this should be 1
        fixedelv:90.0, $     ; fixedelv in case of noscanner=1
        fixedazi:0.0, $      ; fixedazi in case of noscanner=1
        has_stc:1, $ ; set to 0 for systems where the stc attm parameter needs to under dsp msc needs to be set to 1 though the harware does not have stc. (mpi2 hybrid receiver)
        mombufsize:512L , $  ; 512 in case of all systems with max 500 range gates, 1024 for the systems since 1khg.
        txfrequency:35.5e9 , $; center frequrncy
        RecPulseWidths:[96,192,288,400,512,576,706,832,912,1040] , $; syspar.RecPulseWidths[ppar.pdr]=Pulse Width is ns 
            $; pulse_width = ([100,200,300,400,500,600,700,800,900,1000])[ppar.pdr] ; devices before and including MPI
            $; pulse_width = ([96,192,288,400,512,576,706,832,912,1040])[ppar.pdr] ; between halo and DLR
            $; pulse_width = ([112,208,306,400,512,624,706,832,912,1040])[ppar.pdr] ; 1khg devices
        dsprangeoffset:0.0,$ ; correct offset in range assignment caused by error in dsp software. It should be -90 m for IFT and -30 for FMI and 0 else
        dwd_me:1,$ ; set to -1 for radars where the falling targets have positive Doppler shifts.
        dwd_me_spc:1,$ ; set to -1 for radars where the falling targets have positive Doppler shifts.
        pds_spectra_centered:0, $ ; set to 1 for radars (mublaze) where the spectra in the pds files are shifted by nfft/2 so that vel=0 appears at nfft/2 
        pds_spectra_normalization:1L,$ ; 713031680. for mublaze radars and 1. for the others
        xcrl_spc_normalization:2.69272e+09,$ ; normalization needed with mode 22,..,26 of xcrl radarserver
        rx_spc_normalization:5.44,$ ;          normalization needed with mode 12,..,16 of rx_client
        pds_noical_normalization:1L,$ ; 30 for mublaze radars and 1. for the others (hopefully never important). Because I cannot find why it should be 30, its not used any more.
        xcrl_noical_normalization:2.0,$ ; scaling factor for the Npow1/2 and CPow1/2 from the srvinfo structure in the pds files from the xcrl-processing (hopefully never important).
        NoNoiCalGateInIQ:0L,$ ; if set work around bug in DSP of IFT and FMI. In these systems there are no noise and cal gates in the IQ data.
        iqpowerscalingfactor:1.0,$ ; scale the spectra gained by iq-processing so that the adc noise in these spectra is the same as for the spectra calculated by the DSP
        noisecomgainmurx:0,$ ; 1 bei der vermurxten noisecom messung be mbr4, bei der IF-affn2 (co-kanal) ploetzlich auf 5 stand.
        pds_pnoipcal_log:0,$ ; 1 for mublaze radars and and 0 for others
        noise3:0,$           ; 1 for mublaze radar where the nois and cal gate appear at one rg lower
        no_stamp_shift:0,$   ; 1 for mublaze radars, and for rx_client data, 0 for radars where the time and position stamps are from are shifted by one averaging periode
        hybridmode:0,$ ; 1 for hybrid mode radars
        TxRecbandwidthMatchingLoss:1., $  ; Receiver bandwidth loss (Probert Johnes 1964). Theoretically it should be set to 1.5 = 1.8 dB. Due to not 100 percent rectangular shape of the tx pulse rather 2 dB. 
                                       $  ; For compatibility with old data 1.0 is used for most mira3x systems.  It is not in the radarconstant config structure because it is already needed in header2ncdf.pro
        compression_loss19:1.0, $  ; loss due to pulse compression has to be defined for each compression mode round(tx_pulsewitch/rx_pulsewidth). 3 us,160 ns it was determined as 2.11
        gzipq:4, $ ; quality parameter for the netcdf4 compression
        Z_UnitString:'Z', $ ; unit string for reflectivities. It may be set to the name of the customer name if they want to keep known wrong values of the radar constant to maintain continuity
        Z_UnitDescription:'', $ ; Additional string for the long name of reflectivities. It may be set to something like Offset if they want to keep known wrong values of the radar constant to maintain continuity
        systemtype:'MIRA36',$
        dumy:'' $
    }
    config2stru,syspar,'syspar',[whoami.iam+'.config']
    FzkPdsFmt=syspar.FzkPdsFmt  ; for compatibility with older programs
    syspar.magic4chs=strmid(syspar.magic4chs,0,4)
    magic4chs=syspar.magic4chs  ; "
return,whoami.iam
end
;
; Die Strukturaenderung von whoami hat den folgenden Vorteil:
; Nach einer Aenderung des systems (zb Frequenzaenderung wuerde man zb den Namen DLR1 verwenden und 
; eine neue DLR1.config anlegen. Das meiste darin kopiert man. aber es erlaubt einem zb die noisecom-Dateienm zu 
; aendern, zum verarbeiten der alten Daten ruft man dann die Programmen zb 'idl mmclx iam=DLR infile=...' auf
; common magic4chs,magic4chs,FzkPdsFmt,syspar  ueberall so aendern!!

; Case Statement aus der alten Whoami des DLR-Radars
;case iam of
;    'DWD': begin
;        FzkPdsFmt=0
;        magic4chs='FHDR'
;    end
;    'NASA':begin
;        FzkPdsFmt=0
;        magic4chs='FHDR'
;    end
;    'FZK':begin
;         magic4chs='FZKF'
;    end
;    'MPI':begin ; MPI2 is meant as completely other software is used for MPI1
;        magic4chs='FZKF'
;    end
;    'HALO':begin
;         magic4chs='HALO'
;    end
;    'NUIG':begin
;        magic4chs='NUIG'
;    end
;    'CNRP':begin
;        magic4chs='CNRP'
;    end
;    'JUEL':begin
;        magic4chs='0709'
;    end
;    'IFT':begin
;        magic4chs='NMRA'
;        mombufsize=1024L
;    end
;    'FMI':begin
;        magic4chs='1KHG'
;        mombufsize=1024L
;    end
;    'DLR':begin
;        magic4chs='METL'
;    end
;    'LMU':begin
;        magic4chs='LMUM'
;        mombufsize=1024L
;    end
;    else:begin
;       print,'I dont know who Iam: '+kp.iam 
;       exit
;    end
;endcase
