function fhilde,a,n_spcave=n_spcave,ndiv=ndiv,ofdiv=ofdiv
; Gibt den Rauchpegel des Spektrums a zurrück
; div-Verfahren, schnelle Version
;
;the spectrum is cut into ndiv=8 pieces. 
;
;The average from each piece is calculated 
;==> smothspc[i]
;        i=0,..,zdiv-1
;        zdiv=sfft/ndiv
;
;A threshold is calculated to decide which of the  smothspc[i] will be averaged for getting the result.
;    thrdiv = minimum(smothspc[i]) * (1.0 +ofdiv/sqrt(avg*zdiv))
;    avg = ppar->avg

; An average from all the values smothspc[i] <= thrdiv is calculated and returned as result.
;
    n=n_elements(a)
    if n_elements(ndiv) ne 1 then ndiv=8
    if n_elements(ofdiv) ne 1 then ofdiv=8.
    zdiv=long(n/ndiv)
    smothspc=fltarr(ndiv)
    smothspc = 1/float(zdiv) * total(reform(a > 0.0,zdiv,ndiv),1)
    thrdiv = min(smothspc) * (1.0+ofdiv/sqrt(n_spcave*zdiv)) 
    ixdiv = where(smothspc le thrdiv,nixdiv)
    return,total(smothspc[ixdiv])/float(nixdiv)
end

