function get_ixaixb,flagarr,ixa,ixb,nixtrue
; Search for contiguous sequences of True-values in the vector flagarr and provide the indeces ixa where the True-sequences are beginning 
; and the corresponding indeces ixb where these ranges are ending. On get_ixaixb returns the number of those contiguous sequences.
; The optional last parameter can be return the total number of True-Values in flagarr.
; Example: 
;    a=[0,1,1,0,1,0] 
;    nixab = get_ixaixb(a,ixa,ixb,nixtrue)
;    ==> nixab=2   ixa=[1,4]  ixb=[2,4]  nixtrue=3
; 
; Matthias 
;
    n = n_elements(flagarr)
    ixtrue = where(flagarr,nixtrue)
    if nixtrue ge 1 then begin
        if nixtrue eq 1 then begin
            ixa = ixtrue[0] 
            ixb = ixa 
            nixab = 1
        endif else begin
            ixa = ixtrue[where(ixtrue - [-2,ixtrue[0:nixtrue-2]]            gt 1L,nixab)]
            ixb = ixtrue[where(          [ixtrue[1:nixtrue-1],n+1] - ixtrue gt 1L      )]
            nixab = nixab
        endelse
    endif else begin
        nixab=0
        ixa=-1
        ixb=-1
    endelse
    return,nixab
end
