pro  limit_itr2contiguous,hours,max_ave,pp
; soubroutine of viewpds 
; which limits the time range (pp.itr) to a piece with contiguous data
; (no gap in the time sequence)
    if pp.itr[1]-pp.itr[0] gt 2 then begin 
        delta_hour = hours[pp.itr[0]+1:pp.itr[1]] - hours[pp.itr[0]:pp.itr[1]-1]
        ix_skip = where(delta_hour*36d2 gt max_ave*pp.tolerable_gap, nix_skip)
        if nix_skip gt 0 then begin ; an un-tolerable gap in the data was detected
            print,'Number of gaps in the time sequence:',nix_skip
            print,'Depending on takeat_gap the time range will be set to the first or last piece of contiguous data'
            print,'tolerable_gap=',pp.tolerable_gap,'  takeat_gap=', pp.takeat_gap 
            case pp.takeat_gap of
                'left': pp.itr[1]=pp.itr[0]+ix_skip[0]  
                'right': pp.itr[0]=pp.itr[0]+ix_skip[nix_skip-1]+1
                else:
            endcase
        endif
    endif
end
