function mgausfit,xwerte,powers10
; afit = mgausfit(xval,db(yval))
; fit a gaussian to the n pairs of measured values xval[0:n-1],yval[0:n-1]
; y = afit[0] / (sqrt(2.*!pi)*afit[2]) * exp(-0.5*((x-afit[1])/afit[2])^2)
; afit[0] is the integral in dB scale 
; simple without errors and without weighting. See mgaussfit for a weighted gauss fit with error estimates
common fgaussfitcom,zdlnz,wzp
    if n_elements(zdlnz) ne 1 then begin
        zdlnz = 10.0 / alog(10)
        wzp = sqrt(2.*!pi)
    endif
    zpow=n_elements(powers10)
    tx_pot_mat = [ [replicate(1.,zpow)], [xwerte], [xwerte*xwerte] ]
    x_pot_mat = transpose(tx_pot_mat)
    iho = x_pot_mat # powers10 
    x_pot_tx_pot = x_pot_mat # tx_pot_mat
    ;;; a = cramer( x_pot_tx_pot , iho ) ; strzt ab und zu ab
    choldc, x_pot_tx_pot, p_x_pot_tx_pot
    a = cholsol( x_pot_tx_pot, p_x_pot_tx_pot, iho  )
    if a[2] le 0 then begin 
        sigsig = - 1. / ( 2.0 * a[2] )
        x0 = a[1] * sigsig
        sig = sqrt( sigsig * zdlnz )  
        amp10 = a[0] + x0 * x0 / ( 2.0 * sigsig ) + zdlnz * alog(wzp * sig)
        return,[amp10,x0,sig]
    endif else return,[-120,-999.9,-1] 
end
