function mgaussfit,xwerte,powers,gewichte,tit
; afitstru = mgausfit(xval,db(yval),weights)   
; afit=[afitstru.amp10.wert,afitstru.null.wert,afitstru.sig.wert]
; fit a gaussian to the n pairs of measured values xval[0:n-1],yval[0:n-1] 
; y = afit[0] / (sqrt(2.*!pi)*afit[2]) * exp(-0.5*((x-afit[1])/afit[2])^2)
; afit[0] is the integral in dB scale
; It also allows providing weighting factors for the data pairs.
; Errors of the estimates are returned in afit. [afitstru.amp10.err,afitstru.null.err,afitstru.sig.err]
; See mgaussfit simple and faster version.
    on_error,2
    if n_elements(tit) eq 0 then tit='no plot'
    zpow=n_elements(powers)
    if zpow lt 3 then begin 
        mompar={mompar, {wf,0.0,1e30} ,{wf, 0.0,1e30} , {wf,0.0,1e30} , 16 }
	goto,ende
    endif
    if n_elements(gewichte) ne zpow then gewichte=replicate(1.,zpow)
    koef = pofi( xwerte , powers , gewichte , 2 , dkoef )

    mompar = moment(koef(0)     ,koef(1)    ,koef(2)     ,$
                        dkoef(0)    ,dkoef(1)   ,dkoef(2))

    ;plotten
    if tit ne 'no plot' and tit ne 'x' and tit ne 'X' then begin
	iidx = sort(xwerte)
	sortxw = xwerte(iidx)
        plot,sortxw,powers(iidx),psym=4,$
             title=tit
        oplot , sortxw ,koef(0) + sortxw*koef(1) + sortxw^2 *koef(2),$
                linestyle=0
	oplot , [mompar.null.wert,mompar.null.wert],[-100,100]
        key=get_kbrd(1)
        if key eq 'n' then begin
        mompar={mompar, {wf,-100.,1e30} ,{wf, 0.0,1e30} , {wf,1e30,1e30} , 8 }
        endif 
        tit=key
    endif
    ende:return,mompar
end
