function moment, a0,a1,a2,  da0,da1,da2
; convert polinomal momnets to the parameters amp10,x0,sigma used for describing gaussians
common fgaussfitcom,zdlnz,wzp
    if n_elements(zdlnz) ne 1 then begin
        zdlnz = 10.0 / alog(10)
        wzp = sqrt(2.*!pi)
    endif
    wf     = { wf , wert:0.0 , fehler:0.0 }
    mompar = { mompar , amp10:wf , null:wf , sig:wf , err:0 }
    lgundef = -100
    if a2 lt 0.0 then begin
        sigsig = - 1 / ( 2.0 * a2 )
        x0 = a1 * sigsig
        sig = sqrt( sigsig * zdlnz )  
        amp10 = a0 + x0 * x0 / ( 2.0 * sigsig ) + zdlnz * alog(wzp * sig)

        dsigsig = da2 / (2.0*a2*a2)
        dx0 =sqrt( (da1 * sigsig)^2 + (a1 * dsigsig)^2 )
        damp10q = da0^2 + (x0 * dx0 / sigsig)^2              $
               + (x0*x0*dsigsig / (2.0*sigsig*sigsig) )^2 
        dsig = sqrt(10/alog(10))*dsigsig / (2.*sqrt( sigsig )) 
    endif else begin
        amp10 = lgundef    
        x0 =  0.0
        sig = 0.0
        dx0 =  100.
        damp10q = 100.
        dsig = 100.
        mompar.err=mompar.err or 2 
    endelse
    mompar.amp10 = { wf , amp10 , sqrt(damp10q) }
    mompar.null  = { wf , x0    , dx0    }
    mompar.sig   = { wf , sig   , dsig   }
    return , mompar
end
