pro plotpfeile,ugood,vgood,xgood,ygood,maxmag,box,sym=sym,color=color,linestyle=linestyle,thick=thick,arrowsize=arrowsize
; mahlt in ein vorhandenes Koordinatensystem pfeile:
; ugood,vgood x/y-L"angen der pfeile. Ein Pfeil der L"ange maxmag
;             passt genau in die gr"o\3te quadratische box die in dem
;             rechteck box[0],box[1] platz findet
; xgood,ygood x/y-Koordinaten der Mittelpunkte der Pfeile. Die Achsen des
;             Koodinatensysstems in das die Pfeile geplottet werden soll
;             sind nach diesen Werten skaliert und beschriftet.
;             Die Dimensionen von 
;		 ugood,vgood,xgood und ygood 
;             m"ussen identisch sein
; sym=0       Pfeile mit Quaderspitze konstanter groesse
; sym=1       Pfeile mit Dreiecksspitze konstanter groesse
; sym=2       Pfeile mit zur L"ange proportionalen Spitzen
    if n_elements(arrowsize) ne 1 then arrowsize=1.0
    if n_elements(sym) ne 1 then sym = 0
    d_pix = dxy_pix()
    pixbox = (box[0]/d_pix.x) < (box[1]/d_pix.y)
;
    if n_elements(linestyle) ne 1 then linestyle=!p.linestyle
    if n_elements(thick) ne 1 then thick=1.2
    olisty = !p.linestyle
    !p.linestyle = linestyle
    case sym of 
	0:begin               ; gef"ulltes dreick                     
	    mag  =   sqrt( double(ugood)^2 + double(vgood)^2 )
	    sina =   pixbox / maxmag  *  ugood
	    cosa =   pixbox / maxmag  *  vgood
	    vv   =   maxmag/mag
	    r = .15  * arrowsize     			;len of arrow head
	    angle = 20.0 * !dtor		;Angle of arrowhead
	    st = r * sin(angle)		;sin 22.5 degs * length of head
	    ct = r * cos(angle)
	    for i=0,n_elements(xgood)-1 do begin	;Each point
		x0 = xgood[i]
		dxpix = sina[i]
		dx = dxpix * d_pix.x
		x1 = x0 + dx
		y0 = ygood[i] 
		dypix = cosa[i]
		dy = dypix * d_pix.y
		y1 = y0 + dy
		plots,[x0,x1],[y0,y1],thick=thick,color=color
		polyfill,[x1,                                       $
			  x1-d_pix.x*(ct*dxpix-st*dypix)*vv[i],     $
		          x1-d_pix.x*(ct*dxpix+st*dypix)*vv[i],     $
			  x1],                                      $
			 [y1,                                       $
			  y1-d_pix.y*(ct*dypix+st*dxpix)*vv[i],     $
		          y1-d_pix.y*(ct*dypix-st*dxpix)*vv[i],     $
			  y1],color=color
	    endfor
        end
	1:begin                                 ; Viereck
	    mag  =   sqrt( ugood^2 + vgood^2 )
	    sina =   pixbox / maxmag  *  ugood
	    cosa =   pixbox / maxmag  *  vgood
	    vv   =   maxmag/mag
	    r = .08  * arrowsize                  ;len of arrow head
	    angle = 90.0 * !dtor		;Angle of arrowhead
	    st = r * sin(angle)		;sin 22.5 degs * length of head
	    ct = r * cos(angle)
	    for i=0,n_elements(xgood)-1 do begin	;Each point
		x0 = xgood[i]
		dxpix = sina[i]
		dx = dxpix * d_pix.x
		x1 = x0 + dx 
		y0 = ygood[i] 
		dypix = cosa[i]
		dy = dypix * d_pix.y
		y1 = y0 + dy
		plots,[x0,x1],[y0,y1],thick=thick ,color=color
		polyfill,[x1-d_pix.x*((-r+ct)*dxpix-st*dypix)*vv[i],          $ 
		          x1-d_pix.x*((-r+ct)*dxpix+st*dypix)*vv[i],          $
		          x1-d_pix.x*(( r+ct)*dxpix+st*dypix)*vv[i],     $
		          x1-d_pix.x*(( r+ct)*dxpix-st*dypix)*vv[i],     $
		          x1-d_pix.x*((-r+ct)*dxpix-st*dypix)*vv[i]],         $
			 [y1-d_pix.y*((-r+ct)*dypix+st*dxpix)*vv[i],          $
		          y1-d_pix.y*((-r+ct)*dypix-st*dxpix)*vv[i],          $
		          y1-d_pix.y*(( r+ct)*dypix-st*dxpix)*vv[i],     $
		          y1-d_pix.y*(( r+ct)*dypix+st*dxpix)*vv[i],     $
		          y1-d_pix.y*((-r+ct)*dypix+st*dxpix)*vv[i]], $
			  color=color
	    endfor
	end
	else:begin                              ; Pfeil mit propotionaler Spitze
	    sina =   pixbox / maxmag  *  ugood
	    cosa =   pixbox / maxmag  *  vgood
	    r = .2 * arrowsize            	;len of arrow head
	    angle = 20.0 * !dtor		;Angle of arrowhead
	    st = r * sin(angle)		;sin 22.5 degs * length of head
	    ct = r * cos(angle)
	    for i=0,n_elements(xgood)-1 do begin	;Each point
		x0 = xgood[i]
		dxpix = sina[i]
		dx = dxpix * d_pix.x
		x1 = x0 + dx
		y0 = ygood[i] 
		dypix = cosa[i]
		dy = dypix * d_pix.y
		y1 = y0 + dy
		plots,                                     $
		 [x0,x1,x1-d_pix.x*(ct*dxpix-st*dypix),x1, $
		  x1-d_pix.x*(ct*dxpix+st*dypix)],         $
		 [y0,y1,y1-d_pix.y*(ct*dypix+st*dxpix),y1, $
		  y1-d_pix.y*(ct*dypix-st*dxpix)],color=color,thick=thick
	    endfor
	end
    endcase
    !p.linestyle = olisty 
end

