function smooth_deriv,f,n=kn,alpha=kalpha
; calculate the derivative of the first argument after smoothing it by a gausssian with parameters givn by the KWPs alpha= and n=kn
common smooth_deviate,n,alpha,ddg
default_value,kn,7L
default_value,kalpha,3.4
if n_elements(n) ne 1 then begin
    n=-1L & alpha=-1.0
endif
if n ne kn or alpha ne kalpha then begin
   ; calculate the gaussian for the convolution filter only at the first call and save it in the common block
   n = kn & alpha = kalpha
   ix = lindgen(n)
   x = float(ix-long(n/2L))
   g = exp(-0.5*(alpha/float(n))^2*x^2)
   dg = g[(ix+1+n) mod n] -  g[(ix-1+n) mod n]  
   ddg = dg[(ix+1+n) mod n] -  dg[(ix-1+n) mod n]
endif
df = convol(f,ddg,0.5,/center)
return,df
end

