function wgaussfit,xwerte,powers,gewichte,tit
; afitstru = mgausfit(xval,db(yval),weights)   
; afit=[afitstru.amp10.wert,afitstru.null.wert,afitstru.sig.wert]
; fit a gaussian to the n pairs of measured values xval[0:n-1],yval[0:n-1] 
; y = afit[0] / (sqrt(2.*!pi)*afit[2]) * exp(-0.5*((x-afit[1])/afit[2])^2)
; afit[0] is the integral in dB scale
; It also allows providing weighting factors for the data pairs.
; Errors of the estimates are returned in afit. [afitstru.amp10.err,afitstru.null.err,afitstru.sig.err]
; See mgaussfit simple and faster version.
common fgaussfitcom,zdlnz,wzp
    if n_elements(zdlnz) ne 1 then begin
        zdlnz = 10.0 / alog(10)
        wzp = sqrt(2.*!pi)
    endif
    zpow=n_elements(powers)
    if zpow lt 3 then begin 
        x0 = 0.0
        sig = 0.0
        amp10 = -299.
	goto,ende
    endif
    if n_elements(gewichte) ne zpow then gewichte=replicate(1.,zpow)
    a = pofi( xwerte , powers , gewichte , 2 )

    if a[2] lt 0.0 then begin
        sigsig = - 1 / ( 2.0 * a[2] )
        x0 = a[1] * sigsig
        sig = sqrt( sigsig * zdlnz )
        amp10 = a[0] + x0 * x0 / ( 2.0 * sigsig ) + zdlnz * alog(wzp * sig)
    endif else begin
        x0 = 0.0
        sig = 0.0
        amp10 = -299.
    endelse
    ende:
    return,[amp10,x0,sig]
end

