#!/bin/sh
#
# script that executes current_pds2png if the radar is switched on
# It may be run hourly by inserting the following line to ~/etc/crontab
#
#     0 * * * *       [ -x /home/data/metek/m36s/bin/current_pds2png.sh ] && /home/data/metek/m36s/bin/current_pds2png.sh > /dev/null
#
# The if-statement should cause current_pds2png to be executed only when the radar is running.
#
# Matthias
#
cd $HOME
. metek/m36s/local/local.sh

NEWEST_PDS=`ls -t /data/*.pds | head -1`
AGE=`metek/m36s/bin/what_age_has $NEWEST_PDS`

YEAR=`date +'%Y'`

if test $AGE -lt 1800  ; then
    metek/m36s/bin/current_${MOM_SOURCE}2png
    if test $DO_CP_AKT -eq 1 ; then
	dirotd="`ls -dt /home/data/pngs/$YEAR/* | head -1`"
        cd /home/data/pngs
        /usr/bin/rename 5h_ago 6h_ago *.png
        /usr/bin/rename 4h_ago 5h_ago *.png
        /usr/bin/rename 3h_ago 4h_ago *.png
	/usr/bin/rename 2h_ago 3h_ago *.png
	/usr/bin/rename 1h_ago 2h_ago *.png
	/usr/bin/rename latest 1h_ago *.png
	/bin/cp `ls -t $dirotd/*.z1.png | head -1` /home/data/pngs/latest.z1.png
	/bin/cp `ls -t $dirotd/*.v1.png | head -1` /home/data/pngs/latest.v1.png
	/bin/cp `ls -t $dirotd/*.r1.png | head -1` /home/data/pngs/latest.r1.png
        /bin/cp `ls -t $dirotd/*.9pz1.png | head -1` /home/data/pngs/latest.9pz1.png
	/bin/cp `ls -t $dirotd/*.ldr.png | head -1` /home/data/pngs/latest.ldr.png	
        mogrify -trim /home/data/pngs/latest*.png
    fi

fi
cd /home/data
rsync -varHz --rsh=ssh `ls -d pngs/$YEAR/[0-1][0-9][0-3][0-9] | tail -3` metekgmbh:/srv/www/htdocs/$PNGNIC/pngs/$YEAR
