pro dmp2arr_mie, p_npeaks, p_dmp_data, arr, zpeak, itime=itime
; unpacks the "dynamically packed multi peak" array of structs *p_dmp_data which comes from read1dmp_dwell 
; to the rectangular and therefore lager array 
;     arr[irg,ipeak,itime]. 
; Each element of this array is the structure dmpstru
;
    npeak_max=16b ; maximum number of peaks that may show up in the dmpformat. This parameter must be the same as in spcs2moms.
    zrg = n_elements(*p_npeaks)
    narr = n_elements(arr)
    vvv=alog(10)*0.001
    if narr eq 0 then begin
        dmpstru = {SNR:!values.f_nan, SNM:!values.f_nan, LWC:!values.f_nan, RR:!values.f_nan, LDR:!values.f_nan, VEL:!values.f_nan, RMS: !values.f_nan, ixa:-20000, ixb:20000}
        arr = replicate(dmpstru,zrg,npeak_max)
        zpeak = intarr(zrg)
    endif
    if n_elements(itime) eq 0 then itime=0
    i=0L
    for irg=0,zrg-1 do begin
        zp = (*p_npeaks)[irg]
        for ipk=0,zp-1 do begin
            ; arr[irg,ipk,itime] = (*p_dmp_data)[i++]
            ; arrx=arr[irg,ipk,itime] & STRUCT_ASSIGN,(*p_dmp_data)[i],arrx & arrx.SNR=exp(vvv*arrx.SNR) & ...LWC...RR..LDR & arr[irg,ipk,itime]=arrx
            arr[irg,ipk,itime].SNR = exp(vvv*(*p_dmp_data)[i].SNR)
            arr[irg,ipk,itime].SNM = exp(vvv*(*p_dmp_data)[i].SNM)
            lwc_int = (*p_dmp_data)[i].LWC
            arr[irg,ipk,itime].LWC = lwc_int gt -19999 ? 1e9*exp(vvv*lwc_int) : !values.f_nan
            rr_int = (*p_dmp_data)[i].RR
            arr[irg,ipk,itime].RR  = rr_int  gt -19999 ? 1e9*exp(vvv*rr_int ) : !values.f_nan
            ldr_int = (*p_dmp_data)[i].LDR
            arr[irg,ipk,itime].LDR = ldr_int gt -4999 ? exp(vvv*ldr_int) : !values.f_nan
            arr[irg,ipk,itime].VEL = (*p_dmp_data)[i].VEL
            arr[irg,ipk,itime].RMS = (*p_dmp_data)[i].RMS
            arr[irg,ipk,itime].ixa = (*p_dmp_data)[i].ixa
            arr[irg,ipk,itime].ixb = (*p_dmp_data)[i].ixb
            i++
        endfor
        zpeak[irg,itime] = zp
    endfor
end
