pro read_ceilometer_bsc,fn,range,utime,data,frm=frm
    if n_elements(frm) ne 1 then frm=0
    if frm eq 0 then begin
        openr,lun,fn,/get_lun
        dati = 'DATE     TIME '
        readu,lun,dati
        li='' & readf,lun,li
        range = float(strsplit(li,' ',/extract))
        zrg=n_elements(range)
        date=bytarr(8) & sp=0b & time=bytarr(5) 
        prof_ch = bytarr(6,zrg)
        zti=60L*96L+70L
        data = lonarr(zrg,zti)
        utime=lonarr(zti)
        iti=0L
        while not eof(lun) do begin
            readu,lun,date,sp,time,prof_ch
            li='' & readf,lun,li
            if string(date) ne '00.00.00' and string(date) ne 'DATE    ' then begin 
                for irg=0, zrg-1 do data[irg,iti]=long(string(prof_ch[*,irg]))
                utime[iti] = bdate2unixtime( string(date[6:7]) +  string(date[3:4]) + string(date[0:1]) + string(time[0:1]) + string(time[3:4]) + '00' )
                if iti lt zti-1 then iti++ else print,'read_ceilometer_bsc: zti too small' 
            endif
        endwhile
        free_lun,lun
        if iti ne zti-1 then begin 
            data = data[*,0:iti-1L]
            utime=utime[0:iti-1L]
        endif
    endif else begin
        ncdfid = NCDF_OPEN(fn,/NOWRITE)
        NCDF_VARGET, ncdfid, 'range', range & zrg=n_elements(range)
        NCDF_VARGET, ncdfid, 'time', utime & ztime=n_elements(utime)
        ncdfidv = NCDF_VARID(ncdfid, 'beta' )
        NCDF_VARGET, ncdfid, ncdfidv, data, count=[zrg,ztime]
        NCDF_CLOSE, ncdfid
        stop
    endelse
end
