Function read_srvinfo, lun
; read the header which precedes each dwell. It contains log parameters which
; may change from dwell to dwell
common read_srvinfo,header_counter
common initialize,init_extract,init_header_counter
common magic4chs,magic4chs,FzkPdsFmt,syspar
    srvinfo = { frame_cnt:0ul,$
                 time_t : 0ul, $
                 tpow   : 0.,  $
                 npw1   : 0.,  $
                 npw2   : 0.,  $
                 cpw1   : 0.,  $
                 cpw2   : 0.,  $
                 ps_err : 0ul, $
                 te_err : 0ul, $
                 rc_err : 0ul, $
                 grs1   : 0ul, $
                 grs2   : 0ul, $
                 azipos : 0.,  $
                 azivel : 0.,  $
                 elvpos : 0.,  $
                 elvvel : 0.,  $
                 northangle : 0., $
                 microsec : 0L,  $
                 azisetvel : 0.,  $
                 elvsetpos : 0.,  $
                 elvsetvel : 0.  $
    }
    readu, lun, srvinfo
;    print,srvinfo.time_t,srvinfo.milliseconds
    if srvinfo.microsec gt 1000000L or srvinfo.microsec lt 0 then srvinfo.microsec=0L
    if syspar.pds_pnoipcal_log then begin
        srvinfo.npw1 = linear(srvinfo.npw1)
        srvinfo.npw2 = linear(srvinfo.npw2)
        srvinfo.cpw1 = linear(srvinfo.cpw1)
        srvinfo.cpw2 = linear(srvinfo.cpw2)
    endif

    if syspar.pds_spectra_normalization ne 1 then begin
        srvinfo.npw1 *= syspar.pds_spectra_normalization
        srvinfo.npw2 *= syspar.pds_spectra_normalization
        srvinfo.cpw1 *= syspar.pds_spectra_normalization
        srvinfo.cpw2 *= syspar.pds_spectra_normalization
    endif

    if init_header_counter eq 0 then begin
        ;if srvinfo.frame_cnt ne header_counter+1L and srvinfo.frame_cnt gt 1uL then begin
        ;    print,'Skipped ',long(srvinfo.frame_cnt - header_counter-1L),' dwells at dwell count',srvinfo.frame_cnt,' '
        ;endif
    endif else begin
        init_header_counter = 0
    endelse
    header_counter=srvinfo.frame_cnt

    return, srvinfo
end
