pro get_noisecom,calida
    ; GAINVSRANGE_co,GAINVSRANGE_cx,nf_co,nf_cx,Calibr0Co,Calibr0Cx,CorrLNAmatchCo,CorrLNAmatchCx,adcnoise
    ; GAINVSRANGE_co/x  Receiver, flat part above 500 m is normalized to 1.0
    ; nf_co/x Noise figure, Factor, not in dB! Measured by the calibrated noise source (Noisecom) by on/off comparison 
    ; Calibr0Co/x  = Power of calibration noise / Power of Receiver Noise with matched load @300K  measured at the same time as
    ; CorrLNAmatchCo/x The noise measured in noise gate is lower than noise Receiver Noise with matched load @300K as the LNA is not matched during noise measurment.
    ;                  CorrLNAmatchCo/x > 1 has to be multiplied to noise power from the noise gate (npow from serverinfo) so that it is equivalent to the receiver noise.
    ; adcnoise   adc noise level. note it has to be multiplied by nfft so that it corresponds to noise power.
    pp={NoiseComFn_co:'/home/data/specialdata/noisecom_co.nc.sav',NoiseComFn_cx:'/home/data/specialdata/noisecom_cx.nc.sav'}
common magic4chs,magic4chs,FzkPdsFmt,syspar
    config2stru,pp,'get_noisecom',[syspar.iam+'.config']
    zhs=1000
    zhsg=30
    restore,pp.NoiseComFn_co
    nf_co=nf 
    GAINVSRANGE_co=replicate(1.0,zhs) 
    GAINVSRANGE_co[0]=GAINVSRANGE[0:zhsg-1] 
    PowCalOrgCx=PowCalCx 
    PowNoiOrgCx=PowNoiCx 
    PowNoi14Co=MEDHSD_OFF*nfft 
    padc_co=padc
    restore,pp.NoiseComFn_cx
    nf_cx=nf 
    GAINVSRANGE_cx=replicate(1.0,zhs) 
    GAINVSRANGE_cx[0]=GAINVSRANGE[0:zhsg-1] 
    PowCalOrgCo=PowCalCo 
    PowNoiOrgCo=PowNoiCo 
    PowNoi14Cx=MEDHSD_OFF*nfft 
    padc_cx=padc
    ; During measurement in noise gate the LNA input is not matched. Though it cannot be explained, this causes lower noise power.
    ; For this reason the noise power (noise from noise gate) in the pds and dmp data are too small. 
    ; They are corrected by multiplying with  CorrLNAmatchCo/Cx ~= 1.3
    ; For this reason also the the SNR values in the pds and dmp files are too big. They can be corrected by multiplying with 1/(CorrLNAmatchCo)
    ; For this reason also the the LDR values in dmp files are slightly wrong. They can be corrected by multiplying with CorrLNAmatchCo/CorrLNAmatchCx
    CorrLNAmatchCo = PowNoi14Co/PowNoiOrgCo & CorrLNAmatchCx = PowNoi14Cx/PowNoiOrgCx
    Calibr0Co=PowCalOrgCo/PowNoi14Co & Calibr0Cx=PowCalOrgCx/PowNoi14Cx
    calida={$
        GAINVSRANGE:[[GAINVSRANGE_co],[GAINVSRANGE_cx]],$
        nf:[nf_co,nf_cx],$
        Calibr0:[Calibr0Co,Calibr0Cx],$
        CorrLNAmatch:[CorrLNAmatchCo,CorrLNAmatchCx],$
        adcnoise:[padc_co,padc_cx], $
        PowNoi:[PowNoiOrgCo,PowNoiOrgCx],$
        PowCal:[PowCalOrgCo,PowCalOrgCx],$
        nfft:nfft $
    }
end
