pro mietab,mietab
; Calculate a table Qmie7Qray containing Mie correction factors for differen drop size and temperature 
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; !!! if you change any parameter in this program remember to delete ~/.mietab !!!!!!!!!!!
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
fn = getenv('HOME')+'/.mietab'
if (findfile(fn))[0] ne '' then begin
     restore, filename=fn
endif else begin
    c_light=2.99792e8
    lambda=c_light/35.5e9
    brit_temp = [    -8,    0.0,   10.0,   20.0] & brit_nt=n_elements(bri_temp)
    brit_n_re = [3.4802, 3.9207, 4.4867, 5.0591]
    brit_n_im = [2.0524, 2.3043, 2.5619, 2.6877]
    bri_temp = mk_x(56,[-20,35]) & bri_nt=n_elements(bri_temp)
    bri_n_re = interpol(brit_n_re,brit_temp,bri_temp)
    bri_n_im = interpol(brit_n_im,brit_temp,bri_temp)

    bri_nD = 1000 & bri_d = mk_x(bri_nD,[0.00001,0.008])
    mietab = {mie7ray:fltarr(bri_nD,bri_nt),ntemp:bri_nt,temp0:bri_temp[0],dtemp:bri_temp[1]-bri_temp[0],ndia:bri_nD,dia0:bri_d[0],ddia:bri_d[1]-bri_d[0]}
    kwq = 0.93    ; das k_wasser, das bei der Berechnung der Radarconstante genommen wird
    for it=0,bri_nt-1 do begin
        nref=dcomplex(bri_n_re[it],bri_n_im[it])
        ; kwq=abs((nref^2-1.)/(nref^2+2.))^2
        for id=0,bri_nD-1 do begin
            bhmie,!dpi*bri_d[id]/lambda,nref,0,dumy_s1,dumy_s2,dumy_qext,dumy_qsca,qback,dumy_gsca
            mietab.mie7ray[id, it] = qback*lambda^4 / (kwq*bri_d[id]^4*!dpi^3)
        endfor
    endfor
    save, mietab, filename=fn
endelse
end
