pro noise6,arguments
; reads the npow, cpow, and n14 from mmclx files
;
; Matthias Bauer-Pfundstein bauer@metek.de
;
common startup,startup_done
if n_elements(startup_done) ne 1 then begin
@startup
endif

startup_device=!d.name

argv = env2argv(arguments)
kp = { $
    infile:'',$
    outfile:'',$
    max_dwells:70000L $
}
argv2stru,argv,kp

; Default values for the Ploting parameters. These Parameters can be changed by the command "set"
pp={ $
colt:'smooth' $
}
argv2stru,argv,pp

pph={ $
colt:   "Color table, the predefined colortables reside in the directory idl/colors" $
}

if kp.outfile ne '' then begin
    get_lun,ohand
    openw,ohand,kp.outfile
endif else ohand=-1


if kp.infile ne '' then begin
    fn4ld = findfile(kp.infile)
    infiles_oldsyntax = strsplit(kp.infile,':',/extract)
    if n_elements(infiles_oldsyntax) gt n_elements(fn4ld) then fn4ld=infiles_oldsyntax
    if n_elements(fn4ld) eq 0 then fn4ld=['']
    if fn4ld[0] eq '' then begin 
        nfiles=0 & print,'file not found'
    endif else nfiles=n_elements(fn4ld)
    for ifile = 0, nfiles-1 do begin
    print,'processing ',fn4ld[ifile]
        gzipped = strpos(fn4ld[ifile],'.gz') eq strlen(fn4ld[ifile])-3
        if gzipped then begin
            spawn,'echo $$',pid
            fn4ldx='/tmp/noise6infile.'+pid[0]+'.nc'
            spawn,'cp '+fn4ld[ifile]+'  '+ fn4ldx+'.gz'
            spawn,'gunzip '+fn4ldx+'.gz'
            ; fn4ldx = strmid(fn4ld[ifile],0,strlen(fn4ld[ifile])-3)
        endif else fn4ldx=fn4ld[ifile]
        ncdfid = NCDF_OPEN(fn4ldx,/NOWRITE)
        NCDF_VARGET, ncdfid, 'range', rangex & zrg=n_elements(rangex)
        NCDF_VARGET, ncdfid, 'time', timex & ztime=n_elements(timex)
        ;NCDF_VARGET, ncdfid, 'tpow', tpowx, count=[ztime], offset=[0]
        NCDF_VARGET, ncdfid, 'npw1', npw1x, count=[ztime], offset=[0]
        NCDF_VARGET, ncdfid, 'npw2', npw2x, count=[ztime], offset=[0]
        NCDF_VARGET, ncdfid, 'cpw1', cpw1x, count=[ztime], offset=[0]
        NCDF_VARGET, ncdfid, 'cpw2', cpw2x, count=[ztime], offset=[0]
        NCDF_VARGET, ncdfid, 'MRMco',  MRMco, count=[ztime], offset=[0]
        NCDF_VARGET, ncdfid, 'MRMcx',  MRMcx, count=[ztime], offset=[0]
        ncdfidv = NCDF_VARID(ncdfid, 'SNRg' )
        NCDF_VARGET, ncdfid, ncdfidv, SNRg, count=[zrg,ztime], offset=[0,0]
        ncdfidv = NCDF_VARID(ncdfid, 'HSDco' ) 
        NCDF_VARGET, ncdfid, ncdfidv, HSDco, count=[1,ztime], offset=[zrg-2,0]
        ncdfidv = NCDF_VARID(ncdfid, 'HSDcx' ) 
        NCDF_VARGET, ncdfid, ncdfidv, HSDcx, count=[1,ztime], offset=[zrg-2,0]
        NCDF_CLOSE, ncdfid
        if gzipped then spawn,'rm '+fn4ldx

        for iti=0,ztime-1 do begin
            ig = where(finite(SNRg[*,iti]),nig)
            if nig gt 0 then tSNRg=total(SNRg[ig,iti]) else tSNRg=0.0
            printf,ohand,format='(i10,6(f9.2),f12.1,2(f10.3))',timex[iti],npw1x[iti],npw2x[iti],cpw1x[iti],cpw2x[iti],HSDco[0,iti],HSDcx[0,iti],tSNRg,MRMco[iti],MRMcx[iti]
        endfor
    endfor
endif else print,'infile must be given'
exit
end
