pro pdd2ant,arguments
;   
; 
; Matthias Bauer
;
common startup,startup_done
common magic4chs,magic4chs,FzkPdsFmt
if n_elements(startup_done) ne 1 then begin
@startup
endif

argv = env2argv(arguments)

kp = { $
    infile:'', $
    iam:'nobody', $   ; radar name, may be specified to evaluate data from another MIRA36
    outant:'' $  ; If set, special calculation for antenna measurement
}
argv2stru,argv,kp
kp.iam = whoami(kp.iam)

; Default values for the Ploting parameters. These Parameters can be changed by the command "set"
pp={ $
modvuar:1$
}
argv2stru,argv,pp

; online descripion for the above parameters
pph={ $  
modvuar: "Restrict the calculated 1st moments to expected_vrange+/-0.5 velocity un-ambiguty range, by doing a modolo operation"$
}

if kp.outant ne '' then openw,antLun,kp.outant,/get_lun


zrg = -1L

if kp.infile eq 'data' then begin
    zfiles=1
    infiles=[kp.infile]
endif else begin
    infiles = findfile(kp.infile)
    infiles_oldsyntax = strsplit(kp.infile,':',/extract)
    if n_elements(infiles_oldsyntax) gt n_elements(infiles) then infiles=infiles_oldsyntax
    if infiles[0] eq '' then begin
        print,'infile not found: ' + kp.infile
        goto,ende
    endif else zfiles = n_elements(infiles)
endelse
extract=['p1','p2','v1','v2','r1','r2']
for ifiles=0,zfiles-1 do begin
    ; open the pds file and read the fileheader
    if infiles[ifiles] eq 'data' then begin
        spawn,"tail_s2m 2 /data/\*.pds",unit=lun
        online = 1
    endif else begin
        openr,lun,infiles[ifiles],/get_lun
        online = 0
    endelse

    ppar = read_hdr(lun,hdr)

    if ifiles eq 0 then begin
        zchan = hdr.pol+1L ; number of channels
    endif

    while not eof(lun) do begin
        ; read one dwell of spectra
        resume:
        if FzkPdsFmt then begin
            while (rmh=read_mainframe_header(lun, hdr)) eq 0 do begin
                if rmh eq -1L then goto,ende
                ppar = read_ppar_frame( lun, hdr)
            endwhile
        endif
        if zrg ne hdr.mom_zrg then begin
            ; create some arrays
            zrg = long(hdr.mom_zrg)
        endif
        
        if ptr_valid(p_srvinfo) then ptr_free,p_srvinfo
        if ptr_valid(p_data) then heap_free,p_data    ; replaces ptr_free,(*p_data).sp1 & ptr_free,(*p_data).sp2 & ptr_free,p_data
        
        ; read the spectra here:
        read1pds_dwell, lun, hdr, ppar, p_srvinfo, p_data, extract=extract

            if kp.outant ne '' then begin
                ; Write Median power over all ranges as ascii:
                rgful=16
                medpco_dsp = median(((*p_data).P1)[0L,rgful:zrg-3,0L])
                medpcx_dsp = median(((*p_data).P2)[0L,rgful:zrg-3,0L])
                azipos=(*p_srvinfo).AZIPOS 
                elvpos=(*p_srvinfo).ELVPOS
                ; printf,antlun,format='(f8.3," ",f8.3," ",f8.1," ",f8.1)',azipos,elvpos,db(medpco),db(medpcx)
                printf,antlun,format='(f8.3," ",f8.3," ",f8.1," ",f8.1)',azipos,elvpos,db(medpco_dsp),db(medpcx_dsp)
            endif

            
    endwhile ; while not eof of one fiöe
    free_lun,lun
endfor ; ifiles

ende:
if kp.outant ne '' then close,antLun
if ptr_valid(p_srvinfo) then heap_free,p_srvinfo
if ptr_valid(p_data) then heap_free,p_data
exit
end
