pro readspc,files,gziped=gziped,time,p_data,hdr,ppar,p_srvinfo,done,extract=extract
common magic4chs,magic4chs,FzkPdsFmt,syspar
common readspc,lun,infiles,ifile,zfile,zhs,zchan,nfft,pp
if n_elements(lun) ne 1 then lun=-1
if n_elements(ifile) ne 1 then ifile=-1

if ifile lt 0 then begin
    infiles = findfile(files)
    infiles_oldsyntax = strsplit(files,':',/extract)
    if n_elements(infiles_oldsyntax) gt n_elements(infiles) then infiles=infiles_oldsyntax
    if infiles[0] eq '' then begin
        print,'infile not found: ' + kp.infile
        goto,ende
    endif else zfile = n_elements(infiles)

    ; Default values for the Ploting parameters. These Parameters can be changed by the command "set"
    pp={ $
    FixedValTpow:-1.0,$ ; If thermistor is not working reliable it is better to introduce a fixed value of transmitter power here.
    modvuar:1$ ; Restrict the calculated 1st moments to expected_vrange+/-0.5 velocity un-ambiguty range, by doing a modolo operation
    }

    config2stru,pp,'spcs2dmp',[syspar.iam+'.config']
endif

if ptr_valid(p_srvinfo) then done = time ne 0L && time eq (*p_srvinfo).Time_T else done=0
while done eq 0 do begin
resume:
    if lun lt 0 then begin
        if ifile lt zfile then begin
            ifile++ 
            if n_elements(gziped) eq 1 then gziped_=gziped else begin
                if strpos(infiles[ifile],'.zspc') eq strlen(infiles[ifile])-5 or $ 
                strpos(infiles[ifile],'.zspca') eq strlen(infiles[ifile])-6 or $
                strpos(infiles[ifile],'.gz')  eq strlen(infiles[ifile])-3       then gziped_=1 else gziped_=0
            endelse
            openr,lun,infiles[ifile],/get_lun,compress=gziped_
            ppar = read_hdr(lun,hdr)
        endif
    endif
    while lun ge 0 && eof(lun) eq 0 && done eq 0 do begin
        if FzkPdsFmt then begin
            while (rmh=read_mainframe_header(lun, hdr)) eq 0 do begin
                if rmh eq -1L then goto,ende
                ppar = read_ppar_frame( lun, hdr)
            endwhile
        endif

        if ptr_valid(p_srvinfo) then ptr_free,p_srvinfo
        if ptr_valid(p_data) then heap_free,p_data    ; replaces ptr_free,(*p_data).sp1 & ptr_free,(*p_data).sp2 & ptr_free,p_data
        read1pds_dwell, lun, hdr, ppar, p_srvinfo, p_data, extract=extract
        if n_elements( (*(*p_data).sp1)[*,0] ) ne hdr.nfft then begin
            if eof(lun) then goto,ende
            print,'corrupted data'
            goto,resume
        endif
        if time eq 0 || time eq (*p_srvinfo).TIME_T then done=1
        if pp.FixedValTpow gt 0 then (*p_srvinfo).tpow = pp.FixedValTpow
        
    endwhile
    if eof(lun) then lun=-1
endwhile
ende:
end

