pro show_noisecom,arguments
;
; Show the result of noisecom measurements which are in use in the current configuration file metek/m36s/local/idl/<SystemName>.config
; 
; The System Name can be specified by parameter iam=<SystemName> if there is a corresponding file metek/m36s/local/idl/<SystemName>.config 
;
; Matthias
common startup,startup_done
if n_elements(startup_done) ne 1 then begin
@startup
endif

argv = env2argv(arguments)

kp = { $
    iam:'nobody', $   ; radar name, may be specified to evaluate data from another MIRA36
    config:'' $   ; read configurations from metek/m36s/local/idl/<config>
    }
argv2stru,argv,kp
kp.iam = whoami(kp.iam)
common magic4chs,magic4chs,FzkPdsFmt,syspar
get_noisecom,calida
if n_elements(calida.nfft) then nfft=calida.nfft else nfft=256
print,'Noise gate correction factor: Power noise gate / receiver noise power in matched state (dB) ',db(calida.CORRLNAMATCH)
print,'Calibration during noisecom test: power cal / power noise (db) ',db(calida.CALIBR0)
print,'Noise figure (dB) ',db(calida.NF)
print,'ADC noise power (linear)',(calida.ADCNOISE*nfft)
print,'Power noise during calibration measurement (linear) ',(calida.PowNoi)
print,'Power of internal reference souce noise during calibration measurement (linear)',(calida.PowCal)
exit
end
