pro write_zspc,zspcLun,srvinfo,avespc,hilde_nls,det_thress,magic4chs
; write one concise spectrum
; 
zrg = (size(hilde_nls))[1]
zchan = (size(hilde_nls))[2]
nfft = (size(avespc))[1]
lenint=2L & lenflt=4L
    ; Count how much space is required by ZSPC and save all that can be used later
    nixabs = intarr(zrg)
    ixas = intarr(nfft/2,zrg)
    ixbs = intarr(nfft/2,zrg)
    len_zspc = 0L
    for irg=0,zrg-1 do begin
        ; nixabs[irg] = get_ixaixb(avespc[*,irg,0L] ge det_thress[irg,0L] or avespc[*,irg,1L] ge det_thress[irg,1L]*1.5 ,ixa_,ixb_,nixtrue_)
        nixabs[irg] = get_ixaixb(avespc[*,irg,0L] ge det_thress[irg,0L] or avespc[*,irg,1L] ge det_thress[irg,1L] ,ixa_,ixb_,nixtrue_)
        ixas[0,irg] = ixa_
        ixbs[0,irg] = ixb_
        ; len_zspc += lenflt*zchan*nixtrue_ + lenint*2*nixabs[irg]
        len_zspc += lenint*zchan*nixtrue_+lenint + lenint*2*nixabs[irg]
    endfor

    len_hsd = zrg*zchan*lenflt
    ;len_hsd = zrg*zchan*lenint+lenflt
    len_labchain=8L
    len_srvi=N_Tags(*srvinfo,/length)
    len_mainframe = len_labchain+len_srvi + len_labchain+len_hsd + len_labchain+len_zspc
    writeu,zspcLun,magic4chs, len_mainframe 
    writeu,zspcLun,'SRVI', len_srvi, *srvinfo
    writeu,zspcLun,'HSDV', len_hsd, hilde_nls
    ; writeu,zspcLun,'HSDV', len_hsd, packflt2int(hilde_nls,max),max
    writeu,zspcLun,'ZSPC',len_zspc
    for irg=0,zrg-1 do begin
        writeu,zspcLun,nixabs[irg]
        for iab=0,nixabs[irg]-1 do begin
            ixa=ixas[iab,irg] & ixb=ixbs[iab,irg]
            writeu,zspcLun,ixa,ixb-ixa+1
            for ichan=0,zchan-1 do writeu,zspcLun,packflt2int(avespc[ixa:ixb,irg,ichan],max),max
        endfor
    endfor
end

pro write1pds_dwell,Lun,p_srvinfo,moments,zrg,zchan,dwd_me,do_save_spectra,spectra
common magic4chs,magic4chs,FzkPdsFmt,syspar
    len_srvi=N_Tags(*p_srvinfo,/length)
    maxchg=(size(moments))[2]
    if n_elements(do_save_spectra) ne 1 then do_save_spectra=0
    zspectra = do_save_spectra * n_elements(spectra)
    serverinfo_x = *p_srvinfo
    
    if FzkPdsFmt then begin
        len_mainframe = 8L + len_srvi + 8L + 0L + 3L * (8L + maxchg * 4 * 2) + 8L + zspectra*4L
        writeu,Lun,magic4chs, len_mainframe
        writeu,Lun,'SRVI', len_srvi, serverinfo_x
        if do_save_spectra then begin
            si=size(spectra)
            nfft=si[1]
            zrgpz=si[2]
            zch=si[3]
            spectra_out = fltarr(nfft,zch,zrgpz)
            for ich=0,zch-1 do spectra_out[*,ich,*]=spectra[*,*,ich]
            writeu,Lun,'FFTD', zspectra*4L,spectra_out
        endif else begin
            writeu,Lun,'FFTD', 0L
        endelse
        writeu,Lun,'SNRD', maxchg * 4 * 2,          moments[*,*,0L]
        writeu,Lun,'VELD', maxchg * 4 * 2, dwd_me * moments[*,*,1L]
        writeu,Lun,'RMSD', maxchg * 4 * 2,          moments[*,*,2L]
        writeu,Lun,'EXPD',0L
    endif else begin
        writeu,Lun,magic4chs,-1L,serverinfo_x   ; pobably -1L has to be substituted by len_srvi
        writeu,Lun,'FCOP',-1L
        writeu,Lun,'FFFT',0L
        writeu,Lun,'FINT',4L*(zrg+2L),         moments[0L,0:zrg-1L,0L],0.,0.
        writeu,Lun,'FVEL',4L*(zrg+2L),dwd_me * moments[0L,0:zrg-1L,1L],0.,0.
        writeu,Lun,'FRMS',4L*(zrg+2L),         moments[0L,0:zrg-1L,2L],0.,0.

        if zchan ge 2 then begin
            writeu,Lun,'FCRP',-1L
            writeu,Lun,'FFFT',0L
            writeu,Lun,'FINT',4L*(zrg+2L),       moments[1L,0:zrg-1L,0L],0.,0.
            writeu,Lun,'FVEL',4L*(zrg+2L),dwd_me*moments[1L,0:zrg-1L,1L],0.,0.
            writeu,Lun,'FRMS',4L*(zrg+2L),       moments[1L,0:zrg-1L,2L],0.,0.
        endif
    endelse
end

pro write_ppars,ppar,kp,pp,out_ppar,avav_ppar,outlun,PdDspLun,PdGlobalLun,zspcLun,avavLun,extract,do_descrhdr=do_descrhdr
common magic4chs,magic4chs,FzkPdsFmt,syspar
; this part is needed twice. For this resason it was packed to a procedure
    out_ppar = ppar
    out_ppar.raw = 0
    out_ppar.ihp = out_ppar.raw_gate1
    out_ppar.chg = out_ppar.raw_gate2-out_ppar.raw_gate1+1+2-syspar.noise3
    out_ppar.avc = ppar.avc * pp.nave
    if pp.of0 gt 0 then begin
        out_ppar.of0 = pp.of0
    endif
    if kp.outfile ne '' then begin
        if do_descrhdr then write_hdr,outlun,out_ppar,0 else write_ppar_frame,outlun,out_ppar
    endif
    if kp.outpddsp ne '' and ppar.osc eq 4 then begin
        print,'Reading concisely compressed spectra which do not contain moment data, so passing these moments by outpddsp does not work'
        kp.outpddsp=''
        free_lun,PdDspLun
    endif
    if kp.outpddsp ne '' then begin
        outpd_ppar = ppar
        outpd_ppar.raw = 0
        if do_descrhdr then write_hdr, PdDspLun, outpd_ppar, 0 else write_ppar_frame,PdDspLun,outpd_ppar
        extract=['SP1','SP2','p1','p2','v1','v2','r1','r2']
    endif else extract=['SP1','SP2']
    if kp.outpdglobal ne '' then begin
        pdg_ppar=out_ppar
        if kp.pdgwithspectra then pdg_ppar.osc = 2
        if do_descrhdr then write_hdr,PdGlobalLun,pdg_ppar,1 else write_ppar_frame, PdGlobalLun,pdg_ppar
    endif
    if kp.outzspc ne '' then begin
        zspc_ppar=out_ppar
        zspc_ppar.osc = 4
        zspc_ppar.raw = 1
        if do_descrhdr then write_hdr,zspcLun,zspc_ppar,0 else write_ppar_frame,zspcLun,zspc_ppar
    endif
    if kp.outavav ne '' then begin
        ;
        avav_ppar = out_ppar
        if pp.avav_of0 gt 0 then begin
            avav_ppar.of0 = pp.avav_of0
        endif
        avav_ppar.avc = out_ppar.avc * pp.navavt * pp.navavr
        avav_ppar.chg = (out_ppar.chg-2) / pp.navavr +2-syspar.noise3
        avavzrg=avav_ppar.chg-2
        if out_ppar.pol gt 2 then begin
            avav_ppar.pol = out_ppar.pol * pp.navavr
        endif else begin
            if out_ppar.pdr le 10 then begin
                avav_ppar.pdr = (out_ppar.pdr + 1) * pp.navavr - 1
            endif else begin
                avav_ppar.pdr = out_ppar.pdr * pp.navavr
            endelse
        endelse
        avav_ppar.raw_gate1 =  ceil(out_ppar.raw_gate1 / float(pp.navavr))
        avav_ppar.raw_gate2 =  avav_ppar.raw_gate1+avavzrg-1
        avav_ppar.osc = 4
        avav_ppar.raw = 1
        if do_descrhdr then write_hdr,avavLun,avav_ppar,0 else write_ppar_frame,avavLun,avav_ppar
    endif
end

pro spectraprocessing,arguments
;   
; Reads the spectra from pds files and estimates 3 spectral moments of the 16 most 
; dominant peaks.  
;
; Calling Sequence: 
;
; unix> idl spectraprocessing infile=data/20040602_1000.pds outfile=20040602.9.pdf 
;
; IDL > spectraprocessing, 'infile=data/20040602_1000.pds outfile=xxx_off.pdf'
; 
; infile      File to read the pds data from. Multible files with contain successive 
;             (in time) data may be given as array of strings.
;
; outfile     File for writing the output data.
;
; Arguments are passes as keyword parameters in the form <keyword>=<value1>[:<value2>...]
; - If mmclx is called by an interactive IDL session all keyword parameters are 
;   passed in the first string argument as a space separated list. Each keword-value pair must
;   not contain blanks. 
; - if mmclx is called from the csh-script idl each argument ($1, $2, ...) is idl 
;   processed as one keword-value pair. Again, each keword-value pair may not contain blanks.
;
; See the structure pph below for a description of the other keyword parameters.
; 
; Matthias Bauer-Pfundstein
;
common startup,startup_done
if n_elements(startup_done) ne 1 then begin
@startup
endif

argv = env2argv(arguments)

kp = { $
    infile:'', $
    gziped:-1 , $
    iam:'nobody', $   ; radar name, may be specified to evaluate data from another MIRA36
    config:'', $
    outpddsp:'', $  ; If set, extract the moments calculated by th DSP to this file
    outpdglobal:'', $  ; If set, calculate also the global moments and save them to this file
    pdgwithspectra:0, $  ; If set, save the averaged spectra together with the pdg output
    outzspc:'',$ ; If set, save averaged spectra to this file. 
    outavav:'',$ ; If set, save spectra which are averages by two cascaded averaging procedures
    outfile:'' $
}
argv2stru,argv,kp
kp.iam = whoami(kp.iam)
common magic4chs,magic4chs,FzkPdsFmt,syspar

; Default values for the Ploting parameters. These Parameters can be changed by the command "set"
pp={ $
nave:1,$     ; Number of spectral averages performed before peak identification and moment calculation
navavt:6,$   ; Spectra which are averaged for nave dwells of the input data are averaged in a secend
navavr:3,$   ; stage by navavt in time and navavr in range.
of0:-1,$     ; ofs0, parameter for detection threshold
avav_of0:-1,$     ; ofs0, parameter for detection threshold for cascaded averaging
$; LDRof07of0:0.8181818,$ ; (wird im mmclx entschieden) As the spectral range ixa,ixb in cross channel is synced to co channel ofs0 may be reduced by LDRof07of0 in the cross channel.
hilde_method:3,$ ; enumerate: 1 hildebrand-sekhon, 2 hildebrand-fischer-henemut, 3 HSdiv
hsd4noisegate:0,$ ; If set then HSD algorithm is used in the noise gate. 
ofdiv:9.,$ ; Used by HSdiv, similar to ofs0 for determination of detection threshold. divisions from minimum to this thresold are regarded as noise
ndiv:16,$ ; Used by HSdiv, number of parts to which the spectrum is divided
rgclutter:50,$ ; maximum height in which clutter should be removed
max_sholder_dbc:-1.10,$ ; theroretically the sholders of the clutter in the spectra should be -6 dbc. Non clutter signal may cover the sholders. Then no clutter removal is performed
; fftwin:[0.75, 0.3, 0.16, 0.065, 0.023, 0.008, 0.0025],$ ; decaying factor for the neighbor spectral lines in clutter removal
fftwin:[0.31, 0.0042, 0.001, 0, 0, 0, 0, 0],$ ; decaying factor for the neighbor spectral lines in clutter removal
gsm_n:-1, $ ; number of points of convol. Kernel for smoothing before peak search
gsm_alpha:8.6, $ ; 1/width of gausian kernel for smoothing, see gsm_n
peak_thr:9.0 ,$ ; Threshold for peak separation, canion method. Canions sepatate peaks if the relative depth of the canion inbtween is greater than peak_thr.
peak_sig_thr:0.05,$ ; 
gap4dom:5, $ ; Peaks are separated in any case if more than gap4dom values are below detection thresold between them
expected_vrange:-2.0,$ ; see modvuar
MeltHei:1500.,$ ; Height of melting layer, used for temperatur estimation for Mie correction.
outdoortemp2metlhei:152., $ ; If outdoortemp is saved in the ps_err tag of the serverinfo structrure the MeltRgSearchCent is calculatete from it.
DefaultOutdoortemp:-1000.,$ ; Default value of outdoortemp which is used in case no metar data saved at /mom/*.weather is available.
FixedValTpow:-1.0,$ ; If thermistor is not working reliable it is better to introduce a fixed value of transmitter power here.
modvuar:1$ ; Restrict the calculated 1st moments to expected_vrange+/-0.5 velocity un-ambiguty range, by doing a modolo operation
}

config2stru,pp,'spectraprocessing',[kp.iam+'.config',kp.config]

argv2stru,argv,pp

if kp.outfile ne '' then openw,outlun,kp.outfile,/get_lun
if kp.outpddsp ne '' then openw,PdDspLun,kp.outpddsp,/get_lun
if kp.outpdglobal ne '' then openw,PdGlobalLun,kp.outpdglobal,/get_lun
if kp.outzspc ne '' then openw,zspcLun,kp.outzspc,/get_lun,/compress
if kp.outavav ne '' then openw,avavLun,kp.outavav,/get_lun,/compress

; Konstants:
; dwd_me = syspar.dwd_me
;mombufsize = 512L ; fixed number of range gates in fzk-pds format  ; wird jetzt duch common magic4chs definiert
;mombufsize = 1024L ; fixed number of range gates in fzk-pds format ; alte Bezeichnung von mombufsize war mombufsize
;mombufsize steht jetzt der der Struktur syspar.mombufsize die in common magic4chs als letzte Variable steht.
nmulti = 16 ; must be ^2  (better dont change it!)
lenint=2L & lenlong=4L & lenflt=4L
nmom = 3           

mietab,mietab 
; d=findgen(mietab.NDIA)*mietab.DDIA+mietab.DIA0
; plot,d*1000,db(mietab.mie7ray[*, 0]),yra=[-25,5],yst=1
; for i=1,mietab.NTEMP-1 do oplot,d*1000,db(mietab.mie7ray[*, i]),color=i mod 16
 
dmpstru = {SNR:-20000, SNM:-20000, LWC:-20000, RR:-20000, LDR:-20000, VEL:!values.f_nan, RMS: !values.f_nan, ixa:-20000, ixb:20000}
ndmpstru = N_Tags(dmpstru, /Length)  ; number of values passed in dmpformat 
; SNR = C * 10^(mom.SNR/1000.) = Int N(D)*D^6*Mie(D) dD, where C = H^2/H_0^2*P_0/P*C_0 = Radar Constant. Note, it's calculated without Mie correction.
; SNM = C * 10^(mom.SNM/1000.) = Int N(D)*D^6 dD. Note, it's calculated with Mie correction.
; LWC = rho * pi * C / 6 * 10^(mom.LWC/1000.) = Int N(D)*D^3 dD ; 10^(mom.LWC/1000.) = Sum spc(fi)/(D(fi)^3*Mie(D(fi))^3). Vertical Wind velocity ia assumed to be zero.
;  RR = rho * pi * C / 6 * 10^(mom.RR/1000.)  = Int N(D)*D^3*V_T(D) dD ; 10^(mom.LWC/1000.) = Sum VEL(fi)*spc(fi)/(D(fi)^3*Mie(D(fi))^3)
; LDR = 10^(mom.LDR/1000.) = SNR_cross/SNR_co
; mom.VEL = 1st moment in m/s
; mom.RMS = peak width in m/s
; mom.ixa, mom.ixb range of spectral lines containing the peak.

zrg = -1L
avavzrg = -1L
nfft = 0  ; nfft of the spectra in momory. If hdr.nfft differs then a new buffer for noisspectra is created.
co=0
cx=1

if kp.infile eq 'data' then begin
    zfiles=1
    infiles=[kp.infile]
endif else begin
    infiles = findfile(kp.infile)
    infiles_oldsyntax = strsplit(kp.infile,':',/extract)
    if n_elements(infiles_oldsyntax) gt n_elements(infiles) then infiles=infiles_oldsyntax
    if infiles[0] eq '' then begin
        print,'infile not found: ' + kp.infile
        goto,ende
    endif else zfiles = n_elements(infiles)
endelse
for ifiles=0,zfiles-1 do begin
    ; open the pds file and read the fileheader
    if infiles[ifiles] eq 'data' then begin
        spawn,"tail_s2m 2 /data/\*.pds",unit=lun
        online = 1
    endif else begin
        if kp.gziped ge 0 then gziped=kp.gziped else begin
            if strpos(infiles[ifiles],'.zspc') eq strlen(infiles[ifiles])-5 or $ 
               strpos(infiles[ifiles],'.zspca') eq strlen(infiles[ifiles])-6 or $
               strpos(infiles[ifiles],'.zspcaa') eq strlen(infiles[ifiles])-7 or $
               strpos(infiles[ifiles],'.gz')  eq strlen(infiles[ifiles])-3       then gziped=1 else gziped=0
        endelse
        openr,lun,infiles[ifiles],/get_lun,compress=gziped
        online = 0
    endelse

    ppar = read_hdr(lun,hdr)

    if ifiles eq 0 then begin
        ; write the file headers only for the first input file
        write_ppars,ppar,kp,pp,out_ppar,avav_ppar,outlun,PdDspLun,PdGlobalLun,zspcLun,avavLun,extract,do_descrhdr=1
    endif

    while not eof(lun) do begin
        ; read one dwell of spectra
        resume:
        if FzkPdsFmt then begin
            while (rmh=read_mainframe_header(lun, hdr)) eq 0 do begin
                if rmh eq -1L then goto,ende
                ppar = read_ppar_frame( lun, hdr)
                write_ppars,ppar,kp,pp,out_ppar,avav_ppar,outlun,PdDspLun,PdGlobalLun,zspcLun,avavLun,extract,do_descrhdr=0
            endwhile
        endif
        
        ; create some arrays
        if zrg ne hdr.raw_zrg || zchan ne hdr.pol+1L then begin
            zrg = long(hdr.raw_zrg)
            zchan = hdr.pol+1L ; number of channels
            dmpstrus = replicate(dmpstru, syspar.mombufsize, nmulti)
            npeaks = bytarr(zrg) ; needed for dmpformat
            heis = findgen(zrg) * hdr.delta_h + hdr.mom_h_min
            nues = 1+3.68e-5 * heis + 1.71e-9 * heis^2
            if kp.outpddsp ne '' then begin
                mom_zrg = hdr.mom_zrg
                moments = fltarr(zchan,syspar.mombufsize,nmom)
                ed_laprf = 1./(hdr.la * hdr.prf)
            endif
            if kp.outpdglobal ne '' then begin
                lig3=lindgen(nmom)
                gmoments = fltarr(zchan, syspar.mombufsize, nmom)
                ed_laprf = 1./(hdr.la * hdr.prf)
            endif
            if kp.outavav ne '' then begin
                avavzrg = avav_ppar.raw_gate2-avav_ppar.raw_gate1 + 1 - syspar.noise3 
                avavixa4spc = lonarr(avavzrg)
                avavixb4spc = lonarr(avavzrg)
                for avavirg = 0, avavzrg-1 do begin
                    avavixa4spc[avavirg] = (round((avavirg+avav_ppar.raw_gate1-0.5)*pp.navavr+0.5)-ppar.raw_gate1) > 0 
                    avavixb4spc[avavirg] = (round((avavirg+avav_ppar.raw_gate1+0.5)*pp.navavr-0.5) < ppar.raw_gate2 ) - ppar.raw_gate1
                endfor
            endif
            NpowFromSpc=fltarr(zchan)
            CpowFromSpc=fltarr(zchan)
        endif
        if hdr.nfft ne nfft then begin
            nfft=hdr.nfft & nffth = nfft/2L & nfftme=nfft-1L
            dx = hdr.VUAR/nfft
            x = cmod(dx * findgen(nfft), hdr.VUAR,0) ; vel=0 is at index=0, negative velocities are at the end
            ix2ord =   (lindgen(nfft)+nffth) mod nfft
            xord = x[ix2ord]  ; xord = -VUAR/2, ..., 0, ... +VUAR/2
            
            spcord=fltarr(nfft,zchan)
            ; the spectra are sorted so that 0 is in the middle (nffth) and the falling dropplets are at bins greater than nffth
            if syspar.dwd_me_spc eq -1 then begin
                lind = (nfft-lindgen(nfft)+nffth) mod nfft 
                ; in case of DWD radar the spectrum has to be swapped. For consistency the velocities in pds-format have to 
                ; be swapped again. So when using only pds output swapping twice compensates, but its necessary nevertheless for 
                ; correct velocities in the dmp-data. Note calc_moms() turns the sign again to make the velocity of falling drops negative. oO
            endif else begin
                lind = (lindgen(nfft)+nffth) mod nfft
            endelse
            if syspar.pds_spectra_centered then ixblaze=(lindgen(nfft)+nffth) mod nfft else ixblaze=lindgen(nfft)
            nave=pp.nave & ednave = 1./float(nave)
            ; buffers for the Spectra
            iave=0
            avespc = fltarr(nfft,zrg+2,zchan)
            ; tpow = 0.0
            hilde_nls = fltarr(zrg,zchan)
            det_thress=fltarr(zrg,zchan)
            if kp.outavav ne '' then begin
                iavav = 0
                avavspc = fltarr(nfft,avavzrg+2+syspar.noise3,zchan)
                ; avavtpow = 0.0
                avavhilde_nls=fltarr(avavzrg,zchan)
                avavdet_thress=fltarr(avavzrg,zchan)
            endif
        endif

        if iave eq 0 then begin
            ; clear the buffer to which the spectra will be averaged
            avespc[*,*,*]=0.0
            tpow = 0.0
        endif

        if kp.outavav ne '' && iavav eq 0 then begin
            avavspc[*,*,*]=0.0
            avavtpow = 0.0
        endif
        
        
        ; ######### Read the spectra here ######################
        if ptr_valid(p_srvinfo) then ptr_free,p_srvinfo
        if ptr_valid(p_data) then heap_free,p_data    ; replaces ptr_free,(*p_data).sp1 & ptr_free,(*p_data).sp2 & ptr_free,p_data
        read1pds_dwell, lun, hdr, ppar, p_srvinfo, p_data, extract=extract
        if n_elements( (*(*p_data).sp1)[*,0] ) ne nfft then begin
            if eof(lun) then goto,ende
            print,'corrupted data'
            goto,resume
        endif
        if pp.FixedValTpow gt 0 then (*p_srvinfo).tpow = pp.FixedValTpow

        (*p_srvinfo).ps_err = -1UL
        outdoortemp = outdoortemperature((*p_srvinfo).TIME_T)
        if finite(outdoortemp) ne 1 && pp.DefaultOutdoortemp ge -998.0 then outdoortemp=pp.DefaultOutdoortemp
        if finite(outdoortemp) then begin 
            pp.MeltHei = pp.outdoortemp2metlhei * outdoortemp
            (*p_srvinfo).ps_err = ulong(outdoortemp) + 100UL
        endif
        
        if n_elements(temps) ne n_elements(heis) then begin
            temps = temperature(heis,(*p_srvinfo).TIME_T,MeltHei=pp.MeltHei,outdoortemp2metlhei=pp.outdoortemp2metlhei)
        endif
        if kp.outpddsp ne '' then begin
            ; Pass Moments calculated by the DSP in PDS format
            moments[0, 0:mom_zrg-1,0L] = (*p_data).P1 & if zchan eq 2 then moments[1, 0:mom_zrg-1,0L] = (*p_data).P2
            moments[0, 0:mom_zrg-1,1L] = (*p_data).V1*ed_laprf & if zchan eq 2 then moments[1, 0:mom_zrg-1,1L] = (*p_data).V2*ed_laprf
            moments[0, 0:mom_zrg-1,2L] = (*p_data).R1*ed_laprf & if zchan eq 2 then moments[1, 0:mom_zrg-1,2L] = (*p_data).R2*ed_laprf
            write1pds_dwell,PdDspLun,p_srvinfo,moments,mom_zrg,zchan,1
        endif
        
        if n_elements(sp_tagnr) ne 1 then begin
            sp_tagnr = [(where(tag_names(*p_data) eq 'SP1'))[0],(where(tag_names(*p_data) eq 'SP2'))[0]]
            cal_tagnr = [(where(tag_names(*p_srvinfo) eq 'CPW1'))[0],(where(tag_names(*p_srvinfo) eq 'CPW2'))[0]]
            noise_tagnr = [(where(tag_names(*p_srvinfo) eq 'NPW1'))[0],(where(tag_names(*p_srvinfo) eq 'NPW2'))[0]]
        endif

        ; Add the spectra to one averaging buffer
        for ichan=0L,zchan-1L do begin
            for irg=0L,zrg+1L do begin
                avespc[0L,irg,ichan] = avespc[*,irg,ichan] + (*(*p_data).(sp_tagnr[ichan]))[*,irg] ; avespc[nfft,zrg+2,zchan]
            endfor
        endfor
        tpow += (*p_srvinfo).tpow
        iave++

        if iave eq pp.nave then begin
            ; Do the final adjustments of the spectra averaging
            avespc[0,0,0] = ednave * avespc[*,*,*]
            (*p_srvinfo).tpow = ednave * tpow
            iave=0

            ; Do the calculations that are needed only once for all range gates
            ; SNR_min10 = of0 / ( 10.0 * hdr.nfft * sqrt(out_ppar.avc) )
            det_thres_fac = ( 1 + out_ppar.of0/(10. * sqrt(out_ppar.avc)) ) 
            ;SNRminLDR = out_ppar.of0 * pp.LDRof07of0 / (10. * sqrt(out_ppar.avc))   ; nfft im Nenner?
            ; Das wird jezt doch wieder in mmclx entschieden
            for ichan=0,zchan-1 do begin
                ; calculate the noise power and the calibration power from the averaged spec. 
                if pp.hsd4noisegate then begin
                    NpowFromSpc[ichan] = hilde(avespc[*,zrg,ichan],method=pp.hilde_method, ofdiv=pp.ofdiv, ndiv=pp.ndiv, n_spcave=out_ppar.avc) * nfft
                endif else begin
                    NpowFromSpc[ichan] = median(avespc[*,zrg,ichan]) * nfft
                endelse
                CpowFromSpc[ichan] = median(avespc[*,zrg+1,ichan]) * nfft
                (*p_srvinfo).(noise_tagnr[ichan]) = syspar.pds_pnoipcal_log ? db(NpowFromSpc[ichan]/syspar.pds_spectra_normalization) : NpowFromSpc[ichan]/syspar.pds_spectra_normalization
                (*p_srvinfo).(cal_tagnr[ichan]) = syspar.pds_pnoipcal_log ? db(CpowFromSpc[ichan]/syspar.pds_spectra_normalization) : CpowFromSpc[ichan]/syspar.pds_spectra_normalization
                ; the thermistor power should be averaged??
            endfor ; ichan
            
            ; do the moment estimation for each range gate and each channel
            for irg = 0, zrg-1 do begin
                ; height and temp is needed for the Mie-correction
                temp = temps[irg] ; temp = temps[irg]  !!!
                nue = nues[irg]

                ; processing which is the same for all peaks
                for ichan=0,zchan-1 do begin
                    spc = avespc[ixblaze,irg,ichan]
                    if ppar.osc eq 4 then begin
                        hilde_nls[irg,ichan] = (*(*p_data).hsd)[irg,ichan]
                    endif else begin
                        hilde_nls[irg,ichan] = hilde(spc,method=pp.hilde_method, ofdiv=pp.ofdiv, ndiv=pp.ndiv, n_spcave=out_ppar.avc)
                    endelse
                    det_thress[irg,ichan]=hilde_nls[irg,ichan]*det_thres_fac
                    ;if irg ge 71 and irg le 78 and ichan eq 0 then begin
                    ;    spcr=spc 
                    ;    plot,db(spc),yra=[-10,30],psym=10 
                    ;    remove_clutter,spcr,hilde_nls[irg,ichan],det_thress[irg,ichan],pp 
                    ;    oplot,db(spcr),col=1,psym=10 & oplot,[0,256],[1,1]*det_thress[irg,ichan],color=2 
                    ;    print,irg
                    ;    stop
                    ;endif
                    if irg le pp.rgclutter then begin
                        ;print,"irg:",irg,' ichan:',ichan
                        remove_clutter,spc,hilde_nls[irg,ichan],det_thress[irg,ichan],pp
                    endif
                    spcord[0,ichan] = spc[lind] ; vorzeichen wie Frequenzspektrum, Fallende Tropfen haben pos Vorzeichen. 
                endfor

                ; Global Moment Estimation
                if kp.outpdglobal ne '' then begin 
                    for ichan=0L,zchan-1L do begin 
                        ix_above_thres = where(spcord[*,ichan] ge det_thress[irg,ichan], nix_above)
                        if nix_above gt 0 then begin
                            ; noise removal and thresholding
                            spc_above_9noise = spcord[ix_above_thres,ichan] - hilde_nls[irg,ichan]
                            dummy = max(spc_above_9noise,ixxmax) 
                            xx = cmod(xord[ix_above_thres],hdr.VUAR,xord[ix_above_thres[ixxmax]])
                            ; moment estimation
                            noise4snr = NpowFromSpc[ichan]
                            gmoments[ichan, irg, lig3] = calc_moms(spc_above_9noise,xx*ed_laprf,noise4snr) ; calc_moms dreht vel-Vorzeichen um
                            if pp.modvuar then gmoments[ichan, irg, 1L] =  cmod(gmoments[ichan, irg, 1L], hdr.VUAR*ed_laprf,0)
                        endif else begin
                            gmoments[ichan, irg, lig3] = [0.0, -9999.0, -9999.0]
                        endelse
                    endfor ; ichan
                endif
                
                ; Peak Identification. It is done only in the co-channel
                if pp.gsm_n gt 0 then spc_co4id_pk = gsmooth(spcord[*,0L] > det_thress[irg,0L], n=pp.gsm_n,alpha=pp.gsm_alpha) $
                                else spc_co4id_pk = spcord[*,0L] > det_thress[irg,0L]
                peak_ifrqs = identify_peaks_by_canion(spc_co4id_pk,det_thress[irg,0L],peak_thr_fac=pp.peak_thr/sqrt(out_ppar.avc),$
                    gap4dom=pp.gap4dom, peak_sig_thr=pp.peak_sig_thr, maxis=maxis)
                npeak = n_elements(peak_ifrqs)/2 ; this is 0 in case peak_ifrqs=-1
                npeaks[irg] = npeak < nmulti
                if npeak gt 1  then begin
                    ; sort the peaks by their maxi values saved in maxis
                    peak_ifrqs = peak_ifrqs[*,reverse(sort(maxis))]
                endif

                if kp.outfile ne '' then begin
                    ; Multi Peak Moment estimation
                    for ipeak=0,nmulti-1 do begin
                        if ipeak lt npeak then begin
                            ixa = peak_ifrqs[0,ipeak] & ixb = peak_ifrqs[1,ipeak]
                            nlines = (ixb-ixa+nfft) mod nfft
                            
                            ; per peak co-channel processing
                            if ixa lt ixb then begin
                                spc_of_peak = spcord[ixa:ixb,0L]-hilde_nls[irg,0L]
                                xx_of_peak = xord[ixa:ixb]
                            endif else begin
                                spc_of_peak = [spcord[ixa:nfftme,0L],spcord[0:ixb,0L]]-hilde_nls[irg,0L]
                                xx_of_peak = [xord[ixa:nfftme],xord[0L:ixb] + hdr.VUAR] ; calculated 1st moments will be in -VUAR/2:VUAR
                            endelse
                            noise4snr=NpowFromSpc[co]
                            dmpstrus[irg,ipeak] = calc_moms_mie(spc_of_peak, xx_of_peak, noise4snr, mietab, nue, temp, dmpstru, SNRco) ; calc_moms dreht vel-Vorzeichen um
                            if pp.modvuar then begin
                                dmpstrus[irg,ipeak].VEL = cmod( dmpstrus[irg,ipeak].VEL, hdr.VUAR, pp.expected_vrange)
                            endif
                            
                            ; per peak cross-channel processing
                            if ixa lt ixb then begin
                                SNcx = total(spcord[ixa:ixb,1L]-hilde_nls[irg,1L])
                            endif else begin
                                SNcx = total([spcord[ixa:nfftme,1L],spcord[0L:ixb,1L]]-hilde_nls[irg,1])
                            endelse
                            ; Berechnung fuer LDRdetectable wird doch wieder besser in mmclx gemacht
                            ; SNxc_min = sqrt(float(nlines)) * SNRminLDR * hilde_nls[irg,1] ; minimum Signal in cposs channel which is significantly above noise
                            ; dmpstrus[irg,ipeak].LDR =  SNcx ge SNxc_min ? fix(1000.*alog10(SNcx / (SNRco*(*p_srvinfo).NPW2))) : -19999
                            dmpstrus[irg,ipeak].LDR = SNcx ge 0.0 ?  fix(1000.*alog10(SNcx / (SNRco*NpowFromSpc[cx]))) : -5000

                            ; add index range information:
                            dmpstrus[irg,ipeak].ixa = ixa
                            dmpstrus[irg,ipeak].ixb = ixb
                        endif else begin
                            dmpstrus[irg,ipeak] = dmpstru
                        endelse
                    endfor ; ipeak
                endif ; outfile ne ''
            endfor  ; irg


            ; Write the concisely compressed spectra to disk
            if kp.outzspc ne '' then begin
                write_zspc,zspcLun,p_srvinfo,avespc[lind,*,*],hilde_nls,det_thress,magic4chs
            endif

            ; Cascaded spectra averaging
            if kp.outavav ne '' then begin
                ; Add the spectra to one averaging buffer
                for ichan=0L,zchan-1L do begin
                    for avavirg=0L,avavzrg-1L do begin
                        for avav_ix=avavixa4spc[avavirg],avavixb4spc[avavirg] do begin
                            avavspc[0L,avavirg,ichan] = avavspc[*,avavirg,ichan] + avespc[*,avav_ix,ichan]
                        endfor
                    endfor
                    ; noise and cal noise gate:
                    avavspc[0L,avavzrg  ,ichan] = avavspc[*,avavzrg  ,ichan] + avespc[*,zrg,ichan]
                    avavspc[0L,avavzrg+1,ichan] = avavspc[*,avavzrg+1,ichan] + avespc[*,zrg+1,ichan]
                endfor
                avavtpow += (*p_srvinfo).tpow
                iavav++
                
                if iavav eq pp.navavt then begin
                    ; final steps of cascaded spectra averaging
                    ; Divide the summed up data by the number of averages
                    p_avavsrvinfo = ptr_new(*p_srvinfo)
                    ednavav=1/float(pp.navavt)
                    for ichan=0L,zchan-1L do begin
                        for avavirg=0L,avavzrg-1L do begin
                            avavspc[*,avavirg,ichan] *= ednavav/float(avavixb4spc[avavirg]-avavixa4spc[avavirg]+1) 
                        endfor
                        ; calculate the noise power and the calibration power from the averaged spec. Note, noise and cal noise are not averaged over navavr range gates
                        avavspc[*,avavzrg,ichan] *=  ednavav
                        avavspc[*,avavzrg+1,ichan] *=  ednavav
                        avavnpow_ch = median(avavspc[*,avavzrg,ichan]) * nfft
                        avavcpow_ch = median(avavspc[*,avavzrg+1,ichan]) * nfft
                        (*p_avavsrvinfo).(noise_tagnr[ichan]) = syspar.pds_pnoipcal_log ? db(avavnpow_ch/syspar.pds_spectra_normalization) : avavnpow_ch/syspar.pds_spectra_normalization 
                        (*p_avavsrvinfo).(cal_tagnr[ichan]  ) = syspar.pds_pnoipcal_log ? db(avavcpow_ch/syspar.pds_spectra_normalization) : avavcpow_ch/syspar.pds_spectra_normalization              
                    endfor ; ichan
                    (*p_avavsrvinfo).tpow =  avavtpow * ednavav
                    iavav = 0
                    
                    ; calculate the HSdiv noise and the detection threshold of the cacade-averaged spectra
                    avavdet_thres_fac = ( 1 + avav_ppar.of0/(10. * sqrt(avav_ppar.avc)) )
                    for ichan=0L,zchan-1L do begin
                        for avavirg=0L,avavzrg-1L do begin
                            avavhilde_nls[avavirg,ichan] = hilde(avavspc[*,avavirg,ichan],method=pp.hilde_method, ofdiv=pp.ofdiv, ndiv=pp.ndiv, n_spcave=avav_ppar.avc)
                            avavdet_thress[avavirg,ichan] = avavhilde_nls[avavirg,ichan]*avavdet_thres_fac
                        endfor
                    endfor

                    write_zspc,avavLun,p_avavsrvinfo,avavspc[lind,*,*],avavhilde_nls,avavdet_thress,magic4chs

                endif
            endif

            ; Write the calculated moments to file

            ; 1.) global moments calculated above in PDS format
            if kp.outpdglobal ne '' then begin
                write1pds_dwell,PdGlobalLun,p_srvinfo,gmoments,zrg,zchan,syspar.dwd_me,kp.pdgwithspectra,avespc
            endif

            ; 2.) Multi Peak Moments
            if kp.outfile ne '' then begin
                len_srvi = N_Tags(*p_srvinfo,/Length)
                tnpeaks = long(total(npeaks)) 
                len_hsd = zrg * zchan * 4L
                len_mom = tnpeaks * ndmpstru 
                len_mainframe = 8L+len_srvi + 8L+len_hsd  + 8L+zrg + 8L+len_mom
                writeu,outlun,magic4chs, len_mainframe
                if FzkPdsFmt then srvi_sgnt='SRVI' else srvi_sgnt=magic4chs
                writeu,outlun,srvi_sgnt, len_srvi, *p_srvinfo
                writeu,outlun,'HSDD', len_hsd,hilde_nls[0L:zrg-1L,0:zchan-1L]*nfft
                writeu,outlun,'NPKS', zrg, npeaks
                writeu,outlun,'DMPD', len_mom
                for irg=0,zrg-1 do begin                          ; das geht vielleicht auch ohne schleife
                    for ipeak=0,npeaks[irg]-1 do begin
                        writeu,outlun,dmpstrus[irg, ipeak]
                    endfor
                endfor
                ; flush,outlun
            endif
        endif ; if iave eq pp.nave
    endwhile ; while not eof of one file
    free_lun,lun
endfor ; ifiles

ende:
if kp.outfile ne '' then free_lun,outlun
if kp.outpddsp ne '' then free_lun,PdDspLun
if kp.outpdglobal ne '' then free_lun,PdGlobalLun
if kp.outzspc ne '' then free_lun,zspcLun
if ptr_valid(p_srvinfo) then heap_free,p_srvinfo
if ptr_valid(p_data) then heap_free,p_data
exit
end
