pro config2stru,stru,ProgName,ConfigFiles
; Read configuration data from the files ConfigFiles. The files are searched in the idl search path.
; if a configuration information is found that matches one of the tags of the structure stru and 
; also ProgName the value found in the file will overwrite the value tag in stru.
; The information found in the last file will remain in the structure.
common config2stru,paths,zpath
if n_elements(paths) eq 0 then begin
    paths_=strsplit(!path,':',/ext)
    ;paths=paths_[where(strpos(paths_,'idl/lib') lt 0)]
    paths=paths_[where(strpos(paths_,'/idl') ge 0)]
    zpath=n_elements(paths)
endif
;help,stru
tags = tag_names(stru)
zfiles=n_elements(ConfigFiles)
for ifi=0,zfiles-1 do begin
    for ipa=0, zpath-1 do begin
        if ConfigFiles[ifi] ne '' then path = findfile(paths[ipa]+'/'+ConfigFiles[ifi]) else path=''
        if path ne '' then begin
            ;print,path
            openr,hand,path,/get_lun
            while not eof(hand) do begin
                line='' & readf,hand,line
                kpos = strpos(line,'#')
                if kpos ge 0 then line=strmid(line,0,kpos)
                rx=stregex(line,'[	 ]*([A-Za-z][A-Za-z_0-9]*).([A-Za-z][A-Za-z_0-9]*)[	 ]*=(.*)$',/extr,/sub)
                nrx = n_elements(rx)
                if nrx ge 4 && rx[1] eq ProgName then begin
                    key = rx[2]
                    val = rx[3]
                    tagnumber_of_key = (where(strupcase(key) eq tags))[0]
                    if tagnumber_of_key ge 0 then begin
                        ne_stru_tag = n_elements(stru.(tagnumber_of_key))
                        ; print,'ne_stru_tag:',ne_stru_tag,' key:',key,' val:',val
                        if ne_stru_tag eq 1 then begin
                            stru.(tagnumber_of_key) = val 
                        endif else begin
                            vals = strsplit(val,':',/extract)
                            if n_elements(vals) le ne_stru_tag then begin
                                stru.(tagnumber_of_key) = ''
                                stru.(tagnumber_of_key) = vals 
                            endif else begin
                                printf,-2,'Keyword paramter '+key+' should be a '+string(ne_stru_tag)+ $
                                        ' element vector. Elements are separated by :'
                            endelse
                        endelse
                    endif
                endif
            endwhile
            free_lun,hand
        endif
    endfor
endfor
end
