function env2argv,arguments
;
; Arguments can be provided by two methods:
; - If the main program was called by an interactive IDL session the first (and only)
; string parameter should be passed to the parameter arguments of this function. It
; may contain a space separated list of keyword parameters. Each of thes keyword 
; parameters is a string of the form keyname=value. Thes keyword parameters are split 
; to the strarr argv.
; - Aditionally strings contained in the environment variables ARG1, ARG2, ...,
; ARG9, ARG10, ... are prepended to argv. The script idl packs its calling arguments
; these environment variables. This is done as IDL can not extract the shell
; variables like $1, $2,...
; 
; These keyword parameters are extracted to predefined structures by the routine
; argv2stru,argv,stru  
;
; Matthias Bauer-Pfundstein bauer@metek.de
;
    argc_max=99
    args=strarr(argc_max)
    arg = 'not empty'
    iarg=1
    while arg ne '' do begin
        if iarg le 9 then argname = 'ARG'+string(iarg,format='(i1)') $
                        else argname = 'ARG'+string(iarg,format='(i2)')
        arg = getenv(argname)
        args[iarg-1] = arg
        iarg = iarg + 1
    endwhile
    nargs = iarg - 2
    if n_elements(arguments) ne 0 then args[nargs] = strsplit(arguments,/extract,escape='\',count=n) else n=0
    nargs = nargs + n
    if nargs gt 0 then return,args[0:nargs-1] else return,'empty'
end

