function hilde,a,method=method,n_spcave=n_spcave,ix_signal=ix_signal,ndiv=ndiv,ofdiv=ofdiv
; Gibt den Rauchpegel des Spektrums a zurrck
; method 1: Hildebrand-Sekon: n_spcave = Zahl der spektralen Mittelungen. Die jeweils grte Linie 
;     wird entfernt, bis die Varianz kleiner wird als der Mittelwert/sqrt(n_spcave)
; method 2: Hildebran-Hennemuth-Verfahren: n_spcave gibt das Verhltnis Mittelwert^2/Varianz^2 zurck
; method 3: div-Verfahren
; ix_signal gibt die Indices der Linien zurck, die als Signal erkannt werden (unbrauchbar).
default_value,method,1

n=n_elements(a)
if method ne 3 then begin
    ixs=sort(a)
    sum_a=fltarr(n)
    sum_aa=fltarr(n)
    sa=0. & saa=0.
    for i=0,n-1 do begin
        xa=a(ixs(i))
        sa = sa + xa
        sum_a(i)=sa
        saa = saa + xa*xa
        sum_aa(i)=saa
    endfor
    ns=indgen(n)+1
    aveqs = (sum_a/ns)^2
    varqs = (sum_aa-aveqs*ns) / float((ns-1)>1)
endif
case method of 
    1:begin
        ; Hildebrand-Sekhon
        ix_spreu=n-1
        while ix_spreu gt 1 do begin
            ; if varqs[ix_spreu]/sqrt(n_spcave) le aveqs[ix_spreu] then goto,break1
            if varqs[ix_spreu] le aveqs[ix_spreu]/sqrt(n_spcave) then goto,break1
            ix_spreu = ix_spreu - 1
        endwhile
        break1: 
        noise = sum_a[ix_spreu]/float(ix_spreu)
        ix_signal = ixs[ix_spreu:n-1]
    end
    2:begin
        ; Hildebrand-Fischer-Henemut
        ovar=varqs(n-1) & ix_spreu=n-2
        while ix_spreu gt 0 do begin
            if varqs(ix_spreu) lt ovar then goto,break2
            ovars=varqs(ix_spreu)
            ix_spreu = ix_spreu - 1 
        endwhile
        break2: ixn = ix_spreu+1
        n_spcave = aveqs/varqs(ixn)
        noise = sum_a[ixn]/float(ixn)
        ix_signal = ixs[ixn:n-1]
    end
    3:begin
        ; div algorithm
        if n_elements(ndiv) ne 1 then ndiv=8
        if n_elements(ofdiv) ne 1 then ofdiv=8.
        zdiv=long(n/ndiv)
        adiv=fltarr(ndiv)
        igdiv=lindgen(zdiv)
        a = a > 0.0
        edzdiv = 1./float(zdiv)
        for idiv=0,ndiv-1 do begin
            adiv[idiv] = edzdiv * total(a[idiv*zdiv+igdiv])
        endfor
        mindiv=min(adiv)
        thrdiv = mindiv * (1+ofdiv/sqrt(n_spcave*zdiv)) 
        ixdiv = where(adiv le thrdiv,nixdiv)
        noise = total(adiv[ixdiv])/float(nixdiv)
        ix_signal_div =  where(adiv gt thrdiv,nixs)
        if nixs ge 1 then begin
            ix_signal = lonarr(nixs*zdiv)
            for i=0,nixs-1 do begin
                ix_signal[i*zdiv] = ix_signal_div[i]*zdiv + igdiv
            endfor
        endif else ix_signal=-1L
    end
    else: Message,"hilde: unknown method"
endcase
return,noise
end
