function konsensus,werte,win,sig,in_clust=zinmax,average=average,idx=idx
;
; konsensus calculates the consensus average:
;  
;     <Consensus> = konsensus(<DataArr>,<window>,in_clust=<NinClust>,idx=<idxIn>,average=<Average>)
;
; <Consensus> Median of the values falling in to the biggest Cluster. 
; <DataArr>   One dimensional array. Data from which the median of the biggest cluster should be searched.
; <window>    Diameters of the range of values in which all the values of the cluster should lie.
; <NinClust>  Provides after execution the number of elements of the cluster found. 
; <idxIn>     Provides after execution the indices of the elements of the cluster found.
; <Average>   Same as <Consensus>, but arethmtic average instead of the median.
;
; Matthias
;
    if n_elements(average) ne 1 then average=0b
    n = n_elements(werte)
    winh = 0.5 * win
    zinmax = 0
    for i = 0 , n-1 do begin
        zin = total(werte ge werte(i)-winh and werte le werte(i)+winh )  
	if zin gt zinmax and werte(i) ge -999 then begin
	    zinmax = zin 
	    imax = i
	endif
    endfor
    if zinmax ge 1 then begin
        idx = where(werte ge werte(imax)-winh and werte le werte(imax)+winh)
        nidx = n_elements(idx)
        if average then begin
            ave = total(werte(idx))/nidx
        endif else begin
            ave = median(werte(idx))
        endelse
        sig = sqrt( total( (werte(idx)-ave)^2 ) / nidx )
    endif else begin
        idx=-1
        ave=werte(0)
        nidx=0
        sig=-999.
    endelse
    return,ave
end

