#!/usr/bin/perl
# device dependant information about log parameters which is used by 
# mk_detect4radarlog, mk_radadarlog_nicer, ave_radarlog and others.
#
# u4 (usefor):
#                number of digit                  1                 2
#   program for which it applies  mk_radarlog_nicer  mk_radarlog_vert
#
# nm (name):
# 
# fmt (format):
#
# Matthias Bauer-Pfundstein
#
%attr = (
aaa   => { nm=>'HvDac'           , u4=>'nnnyy', fmt=>'%5d'   },
aa8   => { nm=>'HvStab'          , u4=>'nnnyy', fmt=>'%5d'   },
aa9   => { nm=>'HvDelta'         , u4=>'ynnyy', fmt=>'%5d'   },
aac   => { nm=>'Hv'              , u4=>'yyyyy', fmt=>'%5d'   },
aab   => { nm=>'HvSet'           , u4=>'yyyyy', fmt=>'%5d'   },
aa1   => { nm=>'I_Hv'            , u4=>'yyyyy', fmt=>'%6.2f'   },
aa2   => { nm=>'HV_M-U_Aux'      , u4=>'ynnnn', fmt=>'%5.1f'   },
aa3   => { nm=>'TempHVmfet'      , u4=>'yynnn', fmt=>'%5.1f'   },
aa4   => { nm=>'TempTrafo1'      , u4=>'yynnn', fmt=>'%5.1f'   },
aa5   => { nm=>'TempTarfo2'      , u4=>'yynnn', fmt=>'%5.1f'   },
#aa5   => { nm=>'TempCtrlTr'      , u4=>'yyyyy', fmt=>'%5.1f' },
ba0   => { nm=>'1000V'           , u4=>'yyyyy', fmt=>'%4d'   },
ba3   => { nm=>'ModuFh'          , u4=>'yyyyy', fmt=>'%5.1f'   },
ba4   => { nm=>'I_Mg'            , u4=>'yyyyy', fmt=>'%5.2f' },
ca2   => { nm=>'TempMg'          , u4=>'yyyyy', fmt=>'%5.1f' },
ca4   => { nm=>'FanCtrl'         , u4=>'nnnyy', fmt=>'%5.1f' },
ba1   => { nm=>'FhCode'          , u4=>'yyyyy', fmt=>'%5.2f' },
ba2   => { nm=>'FhCurr'          , u4=>'yyyyy', fmt=>'%5.2f' },
#a9   => { nm=>'TimerState'      , u4=>'nnyyy', fmt=>'%5.1f' },
ca3   => { nm=>'TrMode'          , u4=>'ynnyy', fmt=>'%5.1f' },
aa6   => { nm=>'PsHvMode'          , u4=>'ynnyy', fmt=>'%5.1f' },
#ac   => { nm=>'NrOfDefFan'      , u4=>'nnyyy', fmt=>'%5.1f' },
# aad => { nm=>'TrPresMg_obs'    , u4=>'nyyyy', fmt=>'%6.1f' },
# aae => { nm=>'UNKNOWNFRQ'      , u4=>'nyyyy', fmt=>'%6.1f' },
#af   => { nm=>'Debug'           , u4=>'nnyyy', fmt=>'%6.1f' },
ba5   => { nm=>'1000Mode'        , u4=>'ynnyy', fmt=>'%5.1f' },
#ba6   => { nm=>'TempFhCrtl'      , u4=>'yynyy', fmt=>'%5.1f' },
ba7   => { nm=>'MgFhMode'        , u4=>'ynnyy', fmt=>'%5.1f' },
ba8   => { nm=>'MgFhPwm'        , u4=>'ynnyy', fmt=>'%5.0f' },
ba9   => { nm=>'ModFhMode'       , u4=>'ynnyy', fmt=>'%5.1f' },
#al   => { nm=>'FhModeTimer'     , u4=>'nnyyy', fmt=>'%6.1f' },
#am   => { nm=>'TrHvMode'        , u4=>'nyyyy', fmt=>'%5.1f' },
#an   => { nm=>'Tr26VMode'       , u4=>'nnyyy', fmt=>'%5.1f' },
bab   => { nm=>'FhCodeSet'       , u4=>'yyyyy', fmt=>'%5.2f' },
bac   => { nm=>'I_mgTres'        , u4=>'nnnnn', fmt=>'%5.2f' },
baa   => { nm=>'1000vSet'        , u4=>'yyyyy', fmt=>'%4d'   },
fb1   => {    nm=>'RecErr'       , u4=>'yyyyy', fmt=>'%4.4X' },
fb0   => { nm=>'CurRecErr'       , u4=>'yynyy', fmt=>'%4.4X' },
cb0   => {    nm=>'TxnErr'       , u4=>'yyyyy', fmt=>'%4.4X' },
cb1   => { nm=>'CurTxnErr'       , u4=>'yynyy', fmt=>'%4.4X' },
bb0   => {    nm=>'ModNFhErr'    , u4=>'yyyyy', fmt=>'%4.4X' },
bb1   => { nm=>'CurModNFhErr'    , u4=>'nnnyy', fmt=>'%4.4X' },
bb2   => { nm=>'ModNFhBtn'       , u4=>'yyyyy', fmt=>'%4.4X' },
ab1   => {    nm=>'HvErr'        , u4=>'yyyyy', fmt=>'%4.4X' },
ab3   => { nm=>'CurHvErr'        , u4=>'nynyy', fmt=>'%4.4X' },
ab5   => { nm=>'4vHvBtn'         , u4=>'yyyyy', fmt=>'%4.4X' },
db0   => { nm=>'AfcLck'          , u4=>'yynyy', fmt=>'%4.4X' },
db1   => { nm=>'AfcClb'          , u4=>'nnnyy', fmt=>'%4.4X' },
#b2   => { nm=>'ResetSource'     , u4=>'nnyyy', fmt=>'%4.4X' },
dah   => { nm=>'AfcType'         , u4=>'nnnnn', fmt=>'%4d' }, 
daf   => { nm=>'PowCorFac'       , u4=>'nnnnn', fmt=>'%5.3f' }, 
dai   => { nm=>'FrqLoIni'        , u4=>'nnnnn', fmt=>'%5d' },
da0   => { nm=>'FrqLo'           , u4=>'yyyyy', fmt=>'%5d'   , med=>1  },
da7   => { nm=>'DetunLo'         , u4=>'nnnyy', fmt=>'%6.1f' },
dae   => { nm=>'PowTr'           , u4=>'yyyyy', fmt=>'%6.2f' },
fa2   => { nm=>'PresWg'          , u4=>'yyyyy', fmt=>'%6.2f' },
fa4   => { nm=>'DetRw'           , u4=>'yyyyy', fmt=>'%6.3f' },
fa5   => { nm=>'DetDw'           , u4=>'yyyyy', fmt=>'%6.3f' },
#fa6   => { nm=>'RhIn'            , u4=>'yynyy', fmt=>'%6.3f' },
#daj   => { nm=>'DetDuraX'        , u4=>'yyyyy', fmt=>'%5.1f' },
dam   => { nm=>'DetSkip'         , u4=>'yyyyy', fmt=>'%9.2f'   },
#b0   => { nm=>'RecSendCmd'      , u4=>'nnyyy', fmt=>'%4.4X' },
# ea0 => { nm=>'X_Angle_obs'     , u4=>'nyyyy', fmt=>'%6.1f' },
# ea1 => { nm=>'Y_Angle_obs'     , u4=>'nyyyy', fmt=>'%6.1f' },
#ea2 => { nm=>'TempTiltSens'      , u4=>'nnnyy', fmt=>'%6.1f' },
#ea3 => { nm=>'DutyTiltSens'      , u4=>'nnnyy', fmt=>'%5.1f' },
da2   => { nm=>'PowLO1'          , u4=>'yyyyy', fmt=>'%5.2f' },
da3   => { nm=>'PowLO2'          , u4=>'yyyyy', fmt=>'%5.2f' },
da5   => { nm=>'DetunCrs'        , u4=>'yyyyy', fmt=>'%5.0f' },
da4   => { nm=>'DetunFin'        , u4=>'yyyyy', fmt=>'%5.0f' },
da6   => { nm=>'Frq'             , u4=>'nnnnn', fmt=>'%9d'   },
#ea0   => { nm=>'AntX'            , u4=>'nnyyy', fmt=>'%5.2f' },
#ea1   => { nm=>'AntY'            , u4=>'nnyyy', fmt=>'%5.2f' },
#ea4   => { nm=>'TempDish'        , u4=>'nnyyy', fmt=>'%6.1f' },
#ea5   => { nm=>'TempAir'         , u4=>'nnyyy', fmt=>'%6.1f' },
#ad   => { nm=>'AntHeaterMode'   , u4=>'nnyyy', fmt=>'%4d'   },
#ae   => { nm=>'CompressorMode'  , u4=>'nnyyy', fmt=>'%4d'   },
#af   => { nm=>'AirConMode'      , u4=>'nnyyy', fmt=>'%4d'   },
dak   => { nm=>'Ampl1'           , u4=>'ynnnn', fmt=>'%4d'   },
dal   => { nm=>'Ampl2'           , u4=>'ynnnn', fmt=>'%4d' },
fag   => { nm=>'GRS'             , u4=>'ynnyy', fmt=>'%8.8s' },
pa0   => { nm=>'PowNoi1', ch=>1  , u4=>'yyyyy', fmt=>'%7.2f' },
pa1   => { nm=>'PowNoi2', ch=>2  , u4=>'yyyyy', fmt=>'%7.2f' },
ra0   => { nm=>'PowCal1', ch=>1  , u4=>'yyyyy', fmt=>'%7.2f' },
ra1   => { nm=>'PowCal2', ch=>2  , u4=>'yyyyy', fmt=>'%7.2f' },
pa2   => { nm=>'FFTsize',        , u4=>'yyyyy', fmt=>'%4d'   },
fa6   => { nm=>'TempAirUc'     , u4=>'nnnyy', fmt=>'%6.3f' }, #(aux1)
ux1   => { nm=>'TempAir'       , u4=>'yynyy', fmt=>'%4.1f' }, #(aux1)
fa0   => { nm=>'RhWgUc'          , u4=>'nnnyy', fmt=>'%6.3f' }, #(aux2)
ux2   => { nm=>'RhWg'            , u4=>'yynyy', fmt=>'%6.3f' }, #(aux2)
fa3   => { nm=>'RhAirUc'       , u4=>'nnnyy', fmt=>'%6.3f' }, #(aux3)
ux3   => { nm=>'RhAir'         , u4=>'yynyy', fmt=>'%6.3f' }, #(aux3)
fa1   => { nm=>'TempAntUc'       , u4=>'nnnnn', fmt=>'%6.3f' }, #(aux4)
ux4   => { nm=>'TempAnt'         , u4=>'yynnn', fmt=>'%6.3f' }, #(aux4)
lj0   => { nm=>'TempPreAC',      , u4=>'yynyy', fmt=>'%5.1f' }, # Air Temperature before ACing
lj1   => { nm=>'TempBlower',     , u4=>'yynyy', fmt=>'%5.1f' }, # Air Temperature between AC(right) and AC(left)
lj2   => { nm=>'TempPostAC',     , u4=>'yynyy', fmt=>'%5.1f' }, # Air Temperature after ACing
#lj3   => { nm=>'TempTrailer',    , u4=>'yynyy', fmt=>'%5.1f' }, # Air Temperatuer in the trailerr
lj4   => { nm=>'ACBlower',	 , u4=>'yynyy', fmt=>'%1d'   }, # State of huge blowe in the trailer
lj5   => { nm=>'Aerotech',       , u4=>'yynyy', fmt=>'%1d'   }, # State of Aerotech Unit
lj6   => { nm=>'ACleft',         , u4=>'yynyy', fmt=>'%1d'   }, # State of left airconditioner
lj7   => { nm=>'ACright',        , u4=>'yynyy', fmt=>'%1d'   }, # State of right airconditioner
lj8   => { nm=>'ACHeater',       , u4=>'yynyy', fmt=>'%1d'   }, # State of AC heater in the left chamber
lj9   => { nm=>'BlowerPwr',      , u4=>'yynyy', fmt=>'%1d'   }, # State of power of yaskawa
#lja   => { nm=>'YaskawaS1',      , u4=>'yynyy', fmt=>'%1d'   }, # State of control input of yaskawa
up0   => { nm=>'UpsAge',         , u4=>'yynyy', fmt=>'%4d'   }, # Seconds since the last update of the ups log file
up1   => { nm=>'UpsPriV',        , u4=>'yynyy', fmt=>'%5.1f' }, # Input voltage of the UPS
up2   => { nm=>'UpsSecV',        , u4=>'yynyy', fmt=>'%5.1f' }, # Output voltage of the UPS
nav   => { nm=>'Nave'            , u4=>'ynyyy', fmt=>'%4d'   },
);
